module wcsutils

    use module_tamasis, only : p
    use module_math,    only : PI, DEG2RAD, RAD2DEG, NaN, mInf, pInf
    use module_fitstools,      only : ft_read_keyword
    use module_pointingmatrix, only : PointingElement, xy2pmatrix, xy2roi, roi2pmatrix
    use module_projection,     only : convex_hull
    use module_wcs,            only : ad2xy_gnomonic, ad2xys_gnomonic, init_astrometry
    implicit none

    integer, parameter :: NEAREST_NEIGHBOUR = 0
    integer, parameter :: SHARP_EDGES = 1

contains

    subroutine angle_lonlat(lon1, lat1, m, lon2, lat2, n, angle)
        use module_math, only : angle_lonlat_ => angle_lonlat

        real(p), intent(in)  :: lon1(m), lat1(m)
        integer, intent(in)  :: m
        real(p), intent(in)  :: lon2(n), lat2(n)
        integer, intent(in)  :: n
        real(p), intent(out) :: angle(max(m,n))

        if (m == 1) then
            call angle_lonlat_(lon1(1), lat1(1), lon2, lat2, angle)
        else if (n == 1) then
            call angle_lonlat_(lon1, lat1, lon2(1), lat2(1), angle)
        else
            call angle_lonlat_(lon1, lat1, lon2, lat2, angle)
        end if

    end subroutine angle_lonlat


    !---------------------------------------------------------------------------


    subroutine barycenter_lonlat(lon, lat, n, lon0, lat0)

        integer*8, intent(in) :: n
        real*8, intent(in)    :: lon(n), lat(n)
        real*8, intent(out)   :: lon0, lat0

        real*8    :: x, y, z, phi, cotheta, cocotheta
        integer*8 :: i

        if (size(lon) == 0) then
            lon0 = NaN
            lat0 = NaN
            return
        end if

        x = 0
        y = 0
        z = 0
        !$omp parallel do reduction(+:x,y,z) private(phi,cotheta,cocotheta)
        do i = 1, n
            phi = lon(i) * DEG2RAD
            cotheta = lat(i) * DEG2RAD
            if (cotheta /= cotheta .or. phi /= phi) cycle
            cocotheta = cos(cotheta)
            x = x + cocotheta * cos(phi)
            y = y + cocotheta * sin(phi)
            z = z + sin(cotheta)
        end do
        !$omp end parallel do
        
        lon0 = modulo(atan2(y,x) * RAD2DEG + 360._p, 360._p)
        lat0 = acos(sqrt((x**2 + y**2)/(x**2 + y**2 + z**2))) * RAD2DEG
        lat0 = sign(lat0, z)
        
    end subroutine barycenter_lonlat


    !---------------------------------------------------------------------------


    subroutine create_grid_square(nx, ny, size, filling_factor, xreflection, yreflection, rotation, xcenter, ycenter, coords)
        !f2py threadsafe
        integer, intent(in)    :: nx                 ! number of detectors along the x axis
        integer, intent(in)    :: ny                 ! number of detectors along the y axis
        real*8, intent(in)     :: size               ! size of the detector placeholder
        real*8, intent(in)     :: filling_factor     ! fraction of transmitting detector area
        logical, intent(in)    :: xreflection        ! reflection along the x-axis (before rotation)
        logical, intent(in)    :: yreflection        ! reflection along the y-axis (before rotation)
        real*8, intent(in)     :: rotation           ! counter-clockwise rotation in degrees (before translation)
        real*8, intent(in)     :: xcenter, ycenter   ! coordinates of the grid center
        real*8, intent(inout)  :: coords(2,4,nx,ny)  ! output coordinates of the detector corners (first dimension is x and y)

        integer :: i, j, k
        real*8 :: x, y, x0, y0, size_eff, r11, r12, r21, r22, tmp

        size_eff = size * sqrt(filling_factor)
        r11 = cos(DEG2RAD * rotation)
        r21 = sin(DEG2RAD * rotation)
        r12 = -r21
        r22 = r11
        if (xreflection) then
            r11 = -r11
            r21 = -r21
        end if
        if (yreflection) then
            r12 = -r12
            r22 = -r22
        end if
        x0 = -0.5_p * ((nx + 1) * size + size_eff)
        y0 = -0.5_p * ((ny + 1) * size + size_eff)
        
        do j = 1, ny
            y = y0 + size * j
            do i = 1, nx 
                x = x0 + size * i
                coords(1,1,i,j) = x
                coords(2,1,i,j) = y
                coords(1,2,i,j) = x + size_eff
                coords(2,2,i,j) = y
                coords(1,3,i,j) = x + size_eff
                coords(2,3,i,j) = y + size_eff
                coords(1,4,i,j) = x
                coords(2,4,i,j) = y + size_eff
                do k = 1, 4
                    tmp = coords(1,k,i,j)
                    coords(1,k,i,j) = xcenter + r11 * coords(1,k,i,j) + r12 * coords(2,k,i,j)
                    coords(2,k,i,j) = ycenter + r21 * tmp             + r22 * coords(2,k,i,j)
                end do
            end do
        end do
        
    end subroutine create_grid_square


    !---------------------------------------------------------------------------
    
    
    subroutine mean_degrees(array, n, mean)

        integer*8, intent(in) :: n
        real(p), intent(in)   :: array(n)
        real(p), intent(out)  :: mean

        real(p) :: val
        integer :: isample, n180, nvalids
        logical :: zero_minus, zero_plus

        mean = 0
        zero_minus = .false.
        zero_plus  = .false.
        n180 = 0
        nvalids = 0

        !$omp parallel do default(shared) reduction(+:n180, nvalids, mean)     &
        !$omp reduction(.or.:zero_minus,zero_plus) private(isample, val)
        do isample = 1, n
            val = modulo(array(isample), 360._p)
            if (val /= val) cycle
            zero_minus = zero_minus .or. val > 270._p
            zero_plus  = zero_plus  .or. val <= 90._p
            if (val >= 180._p) n180 = n180 + 1
            mean = mean + val
            nvalids = nvalids + 1
        end do
        !$omp end parallel do

        if (zero_minus .and. zero_plus) mean = mean - 360._p * n180

        if (nvalids > 0) then
            mean = modulo(mean / nvalids, 360._p)
        else
            mean = NaN
        end if

    end subroutine mean_degrees


    !---------------------------------------------------------------------------


    subroutine minmax_degrees(array, n, minv, maxv)

        integer*8, intent(in) :: n
        real(p), intent(in)   :: array(n)
        real(p), intent(out)  :: minv, maxv

        real(p) :: val, meanv
        integer :: isample

        call mean_degrees(array, size(array, kind=8), meanv)
        if (meanv /= meanv) then
            minv = NaN
            maxv = NaN
            return
        end if

        minv = pInf
        maxv = mInf
        !$omp parallel do default(shared) reduction(min:minv) reduction(max:maxv) private(val)
        do isample=1, size(array)
            val = array(isample)
            if (val /= val) cycle
            val = modulo(val, 360._p)
            if (val > meanv) then
                if (abs(val-360._p-meanv) < abs(val-meanv)) val = val - 360._p
            else
                if (abs(val+360._p-meanv) < abs(val-meanv)) val = val + 360._p
            end if
            minv = min(minv, val)
            maxv = max(maxv, val)
        end do
        !$omp end parallel do

        minv = modulo(minv, 360._p)
        maxv = modulo(maxv, 360._p)

    end subroutine minmax_degrees


    !---------------------------------------------------------------------------
    
    
    subroutine projection_scale(header, nx, ny, array, status)

        use module_wcs, only : Astrometry, init_astrometry, &
                               projection_scale_ => projection_scale
        character(len=*), intent(in) :: header
        integer, intent(in)          :: nx, ny
        real(p), intent(out)         :: array(nx,ny)
        integer, intent(out)         :: status

        type(Astrometry) :: astr

        call init_astrometry(header, astr, status)
        if (status /= 0) return

        call projection_scale_(astr, array, status)
        if (status /= 0) return

    end subroutine projection_scale


    !---------------------------------------------------------------------------


    subroutine instrument2ad(input, output, ncoords, ra, dec, pa)
        ! Convert coordinates in the instrument frame (focal plane) into
        ! celestial coordinates, assuming a pointing direction and a position
        ! angle.
        !
        !         input(2) = Declination if PA=0
        !    \    |
        !     \PA_|
        !      \/ |
        !       \ |
        !        \|_______ input(1) = -R.A. if PA=0
        !
        ! 
        ! The routine is not accurate at the poles.
        ! Input units are in arc seconds, output units in degrees.

        integer, intent(in)    :: ncoords           ! number of coordinates
        real(p), intent(in)    :: input(2,ncoords)  ! input coordinates in instrument frame
        real(p), intent(inout) :: output(2,ncoords) ! output in celestial coordinates
        real(p), intent(in)    :: ra, dec, pa       ! pointing direction is (0,0) in the local frame

        real(p) :: cospa, sinpa, c1, c2
        integer :: i

        cospa = cos(pa * DEG2RAD)
        sinpa = sin(pa * DEG2RAD)

        do i = 1, ncoords
            c1 = input(1,i) / 3600._p
            c2 = input(2,i) / 3600._p
            output(2,i) = dec + (-c1 * sinpa + c2 * cospa)
            output(1,i) = ra  + ( c1 * cospa + c2 * sinpa) / cos(output(2,i) * DEG2RAD)
        end do

    end subroutine instrument2ad


    !---------------------------------------------------------------------------


    subroutine instrument2xy_minmax(coords, ncoords, ra, dec, pa, npointings, header, xmin, ymin, xmax, ymax, status)
        ! Return the minimum and maximum sky pixel coordinate values of coordinates in the instrument frame.

        integer*8, intent(in)                      :: ncoords, npointings     ! #coordinates, #pointings
        real(p), intent(in)                        :: coords(2,ncoords)       ! instrument frame coordinates
        real(p), intent(in), dimension(npointings) :: ra, dec, pa             ! input pointings in celestial coordinates
        character(len=2880), intent(in)            :: header                  ! input FITS header
        real(p), intent(out)                       :: xmin, ymin, xmax, ymax  ! min and max values of the map coordinates
        integer, intent(out)                       :: status                  ! status flag

        real(p), allocatable :: hull_instrument(:,:), hull(:,:)
        integer, allocatable :: ihull(:)
        integer*8            :: ipointing

        call init_astrometry(header, status=status)
        if (status /= 0) return

        call convex_hull(coords, ihull)
        allocate (hull_instrument(2,size(ihull)), hull(2,size(ihull)))
        hull_instrument = coords(:,ihull)

        xmin = pInf
        xmax = mInf
        ymin = pInf
        ymax = mInf

#ifndef IFORT
        !$omp parallel do reduction(min:xmin,ymin) reduction(max:xmax,ymax) private(hull)
#endif
        do ipointing = 1, npointings

            call instrument2ad(hull_instrument, hull, size(ihull), ra(ipointing), dec(ipointing), pa(ipointing))
            hull = ad2xy_gnomonic(hull)
            xmin = min(xmin, minval(hull(1,:)))
            ymin = min(ymin, minval(hull(2,:)))
            xmax = max(xmax, maxval(hull(1,:)))
            ymax = max(ymax, maxval(hull(2,:)))

        end do
#ifndef IFORT
        !$omp end parallel do
#endif

    end subroutine instrument2xy_minmax


    !---------------------------------------------------------------------------


    subroutine instrument2pmatrix_nearest_neighbour(coords, ncoords, area, ra, dec, pa, masked, npointings, header, pmatrix, out,  &
                                                    status)
        !f2py integer*8, depend(npointings,ncoords) :: pmatrix(npointings*ncoords)
        integer*8, intent(in)                        :: ncoords, npointings     ! #coordinates, #pointings
        real(p), intent(in)                          :: coords(2,ncoords)       ! instrument frame coordinates
        real(p), intent(in)                          :: area(ncoords)           ! detector area / reference_area
        real(p), intent(in), dimension(npointings)   :: ra, dec, pa             ! input pointings in celestial coordinates
        logical*1, intent(in), dimension(npointings) :: masked                  ! pointing flags: true if masked, removed
        character(len=*), intent(in)                 :: header
        type(PointingElement), intent(inout)         :: pmatrix(1,npointings,ncoords)
        logical, intent(out)                         :: out
        integer, intent(out)                         :: status

        real(p)   :: coords2(2,ncoords), x(ncoords), y(ncoords), s(ncoords)
        integer*8 :: isample
        integer   :: nx, ny

        out = .false.
        call init_astrometry(header, status=status)
        if (status /= 0) return
        ! get the size of the map
        call ft_read_keyword(header, 'naxis1', nx, status=status)
        if (status /= 0) return
        call ft_read_keyword(header, 'naxis2', ny, status=status)
        if (status /= 0) return

        !$omp parallel do private(isample, coords2, x, y, s) reduction(.or. : out)
        ! loop over the samples which have not been removed
        do isample = 1, npointings

            if (masked(isample)) then
                pmatrix(1,isample,:)%pixel = -1
                pmatrix(1,isample,:)%weight = 0
                cycle
            end if

            call instrument2ad(coords, coords2, int(ncoords), ra(isample), dec(isample), pa(isample))
            
            call ad2xys_gnomonic(coords2, x, y, s)

            ! the input map has flux densities, not surface brightness
            ! f_idetector = f_imap * weight
            ! with weight = detector_area / pixel_area
            ! and pixel_area = reference_area / s
            call xy2pmatrix(x, y, nx, ny, out, pmatrix(1,isample,:))
            pmatrix(1,isample,:)%weight = real(s * area, kind=kind(pmatrix%weight))

        end do
        !$omp end parallel do

    end subroutine instrument2pmatrix_nearest_neighbour


    !---------------------------------------------------------------------------


    subroutine instrument2pmatrix_sharp_edges(coords, ncoords, ra, dec, pa, masked, npointings, header, pmatrix,                   &
                                              npixels_per_sample, new_npixels_per_sample, out, status)
        !f2py integer*8, depend(npixels_per_sample,npointings,ncoords) :: pmatrix(npixels_per_sample*npointings*ncoords/4)
        integer*8, intent(in)                        :: ncoords, npointings ! #coordinates, #pointings
        real(p), intent(in)                          :: coords(2,ncoords)   ! instrument frame coordinates
        real(p), intent(in), dimension(npointings)   :: ra, dec, pa         ! input pointings in celestial coordinates
        logical*1, intent(in), dimension(npointings) :: masked              ! pointing flags: true if masked, removed
        character(len=*), intent(in)                 :: header              ! sky map FITS header
        type(PointingElement), intent(inout)         :: pmatrix(npixels_per_sample,npointings,ncoords/4) ! the pointing matrix
        integer, intent(in)  :: npixels_per_sample     ! input maximum number of sky pixels intersected by a detector
        integer, intent(out) :: new_npixels_per_sample ! actual maximum number of sky pixels intersected by a detector
        logical, intent(out) :: out                    ! true if some coordinates fall outside of the map
        integer, intent(out) :: status

        real(p)   :: coords2(2,ncoords)
        integer   :: roi(2,2,ncoords/4)
        integer*8 :: isample
        integer   :: nx, ny

        new_npixels_per_sample = 0
        out = .false.
        call init_astrometry(header, status=status)
        if (status /= 0) return
        ! get the size of the map
        call ft_read_keyword(header, 'naxis1', nx, status=status)
        if (status /= 0) return
        call ft_read_keyword(header, 'naxis2', ny, status=status)
        if (status /= 0) return

        !$omp parallel do private(isample, coords2, roi) &
        !$omp reduction(max : npixels_per_sample) reduction(.or. : out)
        do isample = 1, npointings

            if (masked(isample)) then
                pmatrix(:,isample,:)%pixel = -1
                pmatrix(:,isample,:)%weight = 0
                cycle
            end if

            call instrument2ad(coords, coords2, int(ncoords), ra(isample), dec(isample), pa(isample))
            
            coords2 = ad2xy_gnomonic(coords2)
            roi = xy2roi(coords2, 4)
            call roi2pmatrix(roi, 4, coords2, nx, ny, new_npixels_per_sample, out, pmatrix(:,isample,:))

        end do
        !$omp end parallel do

    end subroutine instrument2pmatrix_sharp_edges


end module wcsutils

! Copyright 2010-2011 Pierre Chanial
! All rights reserved
!
! A stack implementation
module module_stack

    use iso_fortran_env, only : ERROR_UNIT
    implicit none
    private

    public :: stack_int
    public :: stackcell_int

    type stack_int
        integer                      :: nelements = 0
        type(stackcell_int), pointer :: head => null()
    contains
        procedure :: pop
        procedure :: push
        procedure :: is_empty
        procedure :: to_array
        procedure :: print
    end type stack_int

    type stackcell_int
        integer                      :: value
        type(stackcell_int), pointer :: next => null()
    end type stackcell_int


contains


    function pop(this)

        class(stack_int), intent(inout) :: this
        integer                         :: pop
        type(stackcell_int), pointer    :: current

        if (this%is_empty()) then
            write (ERROR_UNIT,'(a)') "Stack is empty."
            pop = 0
            return
        end if
        current => this%head
        pop = current%value
        deallocate(this%head)
        this%head => current%next
        this%nelements = this%nelements - 1

    end function pop


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine push(this, value)

        class(stack_int), intent(inout) :: this
        integer, intent(in)             :: value
        integer                         :: istat
        type(stackcell_int), pointer    :: current

        allocate(current, stat=istat)
        if (istat /= 0) then
            write (ERROR_UNIT,'(a)') "Error allocating new cell in stack."
            return
        end if

        current%value = value
        if (.not. this%is_empty()) then
            current%next => this%head
        end if
        this%head => current
        this%nelements = this%nelements + 1

    end subroutine push


    !-------------------------------------------------------------------------------------------------------------------------------


    function is_empty(this)

        class(stack_int), intent(in) :: this
        logical                  :: is_empty

        is_empty = this%nelements == 0

    end function


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine print(this)

        class(stack_int), intent(in) :: this
        integer                      :: i, nformat
        type(stackcell_int), pointer :: current
        character(len=10)            :: fmt

        if (this%is_empty()) then
           write (*,*) "Stack is empty"
           return
        end if

        nformat = ceiling(alog(real(this%nelements)))+1
        write (fmt,'(a,i0,a)') '(i', nformat, ',a,i0)'
        current => this%head
        i = 1
        do while (.true.)
           write (*,fmt) i, ': ', current%value
           i = i + 1
           if (.not. associated(current%next)) exit
           current => current%next
        end do

    end subroutine print


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine to_array(this, array)

        class(stack_int), intent(in)      :: this
        integer, intent(out), allocatable :: array(:)
        type(stackcell_int), pointer      :: current
        integer                           :: i

        allocate(array(this%nelements))

        current => this%head
        do i = 1, this%nelements
           array(i) = current%value
           current => current%next
        end do

     end subroutine to_array


end module module_stack

! Copyright 2010-2011 Pierre Chanial
! All rights reserved
!
module module_precision

   integer, parameter :: sp = kind(1.0)
   integer, parameter :: dp = selected_real_kind(2*precision(1.0_sp))
   integer, parameter :: qp = selected_real_kind(2*precision(1.0_dp))
   
end module module_precision

! Copyright 2010-2011 Pierre Chanial
! All rights reserved
!
module module_string

    use module_tamasis, only : p
    implicit none
    private

    public :: strlowcase
    public :: strupcase
    public :: strcompress
    public :: strsplit
    public :: strinteger
    public :: strjoin
    public :: strreal
    public :: strsection
    public :: strternary

    interface strjoin
        module procedure strjoin_trim, strjoin_opt
    end interface

    interface strinteger
        module procedure strinteger_int4, strinteger_int4_left, strinteger_int8
    end interface

    interface strsection
        module procedure strsection_int4, strsection_int8
    end interface


contains


    ! convert a word to lower case
    elemental function strlowcase(input)

        character(len=*), intent(in) :: input
        character(len=len(input))    :: strlowcase

        integer                      :: i,ic

        strlowcase = input
        do i=1, len(input)
            ic = iachar(input(i:i))
            if (ic >= 65 .and. ic < 90) strlowcase(i:i) = achar(ic+32)
        end do

     end function strlowcase


    !-------------------------------------------------------------------------------------------------------------------------------


    ! convert a word to upper case
    elemental function strupcase(input)

        character(len=*), intent(in) :: input
        character(len=len(input))    :: strupcase

        integer                      :: i,ic

        strupcase = input
        do i=1, len(input)
            ic = iachar(input(i:i))
            if (ic >= 97 .and. ic < 122) strupcase(i:i) = achar(ic-32)
        end do

    end function strupcase


    !-------------------------------------------------------------------------------------------------------------------------------


    ! remove blanks
    ! strcompress should have an allocatable length, but not implemented in gfortran 4.4
    elemental function strcompress(input)

        character(len=*), intent(in) :: input
        character(len=len(input))    :: strcompress

        integer                      :: i, j
  
        strcompress = ' '
        j = 1
        do i=1, len_trim(input)
            if (iachar(input(i:i)) == 32) cycle
            strcompress(j:j) = input(i:i)
            j = j + 1
        end do
      
    end function strcompress


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine strsplit(input, delimiter, output)

        character(len=*), intent(in) :: input
        character, intent(in)        :: delimiter
        character(len=*), allocatable, intent(out) :: output(:)

        integer :: i, noutputs, ioutput, start
      
        noutputs = 1
        do i = 1, len(input)
            if (input(i:i) == delimiter) then
                noutputs = noutputs + 1
            end if
        end do

        allocate (output(noutputs))

        ioutput = 1
        start = 1
        do i=1, len(input)
            if (input(i:i) == delimiter) then
                output(ioutput) = input(start:i-1)
                ioutput = ioutput + 1
                start = i + 1
                cycle
            end if
        end do
        output(ioutput) = input(start:)

    end subroutine strsplit


    !-------------------------------------------------------------------------------------------------------------------------------


    pure function strinteger_int4(input) result(strinteger)

        integer*4, intent(in)                     :: input
        character(len=strinteger_int4_len(input)) :: strinteger

        character(len=80)                         :: string
      
        string = ' '
        write(string, '(i80)') input
        strinteger = adjustl(string)
      
    end function strinteger_int4


    !-------------------------------------------------------------------------------------------------------------------------------


    pure function strinteger_int4_len(input) result(length)
 
        integer               :: length
        integer*4, intent(in) :: input

        if (input == 0)  then
            length = 1
            return
        end if

        length = floor(log10(dble(abs(input))))+1

        if (input < 0) length = length + 1

    end function strinteger_int4_len


    !-------------------------------------------------------------------------------------------------------------------------------


    pure function strinteger_int4_left(input, width) result(strinteger)

        integer*4, intent(in) :: input
        integer, intent(in)   :: width
        character(len=width)  :: strinteger

        write (strinteger, '(i0)') input
        strinteger = adjustl(strinteger)
      
    end function strinteger_int4_left


    !-------------------------------------------------------------------------------------------------------------------------------


    pure function strinteger_int8(input) result(strinteger)

        integer*8, intent(in)                     :: input
        character(len=strinteger_int8_len(input)) :: strinteger

        character(len=80)                         :: string

        string = ' '
        write(string, '(i80)') input
        strinteger = adjustl(string)
      
    end function strinteger_int8


    !-------------------------------------------------------------------------------------------------------------------------------


    pure function strinteger_int8_len(input) result(length)
 
        integer*8, intent(in) :: input
        integer               :: length

        if (input == 0)  then
            length = 1
            return
        end if

        length = floor(log10(dble(abs(input))))+1

        if (input < 0) length = length + 1

    end function strinteger_int8_len
 
 
    !-------------------------------------------------------------------------------------------------------------------------------


    pure function strinteger_int8_left(input, width) result(strinteger)

        integer*8, intent(in) :: input
        integer, intent(in)   :: width
        character(len=width)  :: strinteger

        write (strinteger, '(i0)') input
        strinteger = adjustl(strinteger)
      
    end function strinteger_int8_left


    !-------------------------------------------------------------------------------------------------------------------------------


    pure function strreal(input, prec)

        real(p), intent(in) :: input
        integer, intent(in) :: prec
        character(len=strreal_len(input,prec)) :: strreal
      
        character(len=20)   :: charvalue
        integer             :: status

        write (charvalue,'(bn,f20.'//strinteger(prec)//')',iostat=status) input
        if (status /= 0) then
            strreal = '*****'
            return
        end if
      
        strreal = adjustl(charvalue)

    end function strreal


    !-------------------------------------------------------------------------------------------------------------------------------


    pure function strreal_len(input, prec) result(length)

        integer             :: length
        real(p), intent(in) :: input
        integer, intent(in) :: prec

        character(len=20)   :: charvalue
        integer             :: status

        write (charvalue,'(bn,f20.'//strinteger(prec)//')',iostat=status) input
        if (status /= 0) then
            length = 5
            return
        end if
      
        length = len_trim(adjustl(charvalue))

    end function strreal_len


    !-------------------------------------------------------------------------------------------------------------------------------


    pure function strjoin_trim(input)

        character(len=*), intent(in)           :: input(:)
        character(len=strjoin_trim_len(input)) :: strjoin_trim

        integer                                :: i, k
        
        k = 1
        do i = 1, size(input)
            strjoin_trim(k:k+len_trim(input(i))-1) = trim(input(i))
            k = k + len_trim(input(i))
        end do

    end function strjoin_trim


    !-------------------------------------------------------------------------------------------------------------------------------


    pure function strjoin_trim_len(input)

        character(len=*), intent(in) :: input(:)
        integer                      :: strjoin_trim_len

        integer                      :: i

        strjoin_trim_len = sum([(len_trim(input(i)), i=1, size(input))])

    end function strjoin_trim_len


    !-------------------------------------------------------------------------------------------------------------------------------


    pure function strjoin_opt(input, dotrim)

        character(len=*), intent(in)                 :: input(:)
        logical, intent(in)                          :: dotrim
        character(len=strjoin_opt_len(input,dotrim)) :: strjoin_opt

        integer                                      :: i, k

        if (dotrim) then
            k = 1
            do i = 1, size(input)
                strjoin_opt(k:k+len_trim(input(i))-1) = trim(input(i))
                k = k + len_trim(input(i))
            end do
        else
            k = len(input)
            do i = 1, size(input)
                strjoin_opt((i-1)*k+1:i*k) = input(i)
            end do
        end if
        
    end function strjoin_opt


    !-------------------------------------------------------------------------------------------------------------------------------


    pure function strjoin_opt_len(input, dotrim)

        character(len=*), intent(in)  :: input(:)
        logical, intent(in)           :: dotrim
        integer                       :: strjoin_opt_len

        integer                       :: i

        if (.not. dotrim) then
            strjoin_opt_len = size(input) * len(input(1))
        else
            strjoin_opt_len = sum([(len_trim(input(i)), i=1, size(input))])
        end if

    end function strjoin_opt_len


    !-------------------------------------------------------------------------------------------------------------------------------


    function strsection_int4(first, last) result(str)

        integer*4, intent(in)                          :: first, last
        character(len=strsection_int4_len(first,last)) :: str
        
        if (first == 0 .and. last == 0) then
            str = ':'
            return
        end if

        if (first == 0) then
            write (str,'(":",i0)') last
            return
        end if

        if (last == 0) then
            write (str,'(i0,":")') first
            return
        end if

        write (str,'(i0,":",i0)') first, last

    end function strsection_int4


    !-------------------------------------------------------------------------------------------------------------------------------


    ! 0 means unbound
    pure function strsection_int4_len(first, last) result(length)

        integer               :: length
        integer*4, intent(in) :: first, last

        length = len(strinteger(first)) + len(strinteger(last)) + 1
        if (first == 0) length = length - 1
        if (last  == 0) length = length - 1

    end function strsection_int4_len


    !-------------------------------------------------------------------------------------------------------------------------------


    function strsection_int8(first, last) result(str)

        integer*8, intent(in)                          :: first, last
        character(len=strsection_int8_len(first,last)) :: str
        
        if (first == 0 .and. last == 0) then
            str = ':'
            return
        end if

        if (first == 0) then
            write (str,'(":",i0)') last
            return
        end if

        if (last == 0) then
            write (str,'(i0,":")') first
            return
        end if

        write (str,'(i0,":",i0)') first, last

    end function strsection_int8


    !-------------------------------------------------------------------------------------------------------------------------------


    ! 0 means unbound
    pure function strsection_int8_len(first, last) result(length)

        integer               :: length
        integer*8, intent(in) :: first, last

        length = len(strinteger(first)) + len(strinteger(last)) + 1
        if (first == 0) length = length - 1
        if (last  == 0) length = length - 1

    end function strsection_int8_len


    !-------------------------------------------------------------------------------------------------------------------------------


    function strternary(condition, str_true, str_false)

        logical, intent(in)          :: condition
        character(len=*), intent(in) :: str_true, str_false
        character(len=strternary_len(condition,str_true,str_false)):: strternary

        if (condition) then
            strternary = str_true
        else
            strternary = str_false
        end if

    end function strternary


    !-------------------------------------------------------------------------------------------------------------------------------


    pure function strternary_len(condition, str_true, str_false)

        integer                      :: strternary_len
        character(len=*), intent(in) :: str_true, str_false
        logical, intent(in)          :: condition

        if (condition) then
            strternary_len = len(str_true)
        else
            strternary_len = len(str_false)
        end if

    end function strternary_len


end module module_string

! Copyright 2010-2011 Pierre Chanial
! All rights reserved
!
module module_pointingmatrix

    use module_math,       only : NaN, nint_down, nint_up
    use module_projection, only : intersection_polygon_unity_square
    use module_precision,  only : sp
    use module_tamasis,    only : p
    implicit none
    private

    public :: pointingelement
    public :: pmatrix_direct
    public :: pmatrix_direct_one_pixel_per_sample
    public :: pmatrix_transpose
    public :: pmatrix_transpose_one_pixel_per_sample
    public :: pmatrix_ptp
    public :: pmatrix_mask
    public :: pmatrix_pack
    public :: xy2roi
    public :: xy2pmatrix
    public :: roi2pmatrix
    public :: backprojection_weight
    public :: backprojection_weighted_roi

    type pointingelement
        real(sp)  :: weight
        integer*4 :: pixel
    end type pointingelement

contains


    subroutine pmatrix_direct(pmatrix, map, timeline)

        type(pointingelement), intent(in) :: pmatrix(:,:)
        real(p), intent(in)               :: map(0:)
        real(p), intent(inout)            :: timeline(:)
        integer                           :: ipixel, isample, npixels_per_sample, nsamples

        npixels_per_sample = size(pmatrix,1)
        nsamples = size(pmatrix, 2)

        !$omp parallel do
        do isample = 1, nsamples
!!$            timeline(isample) = sum(map(pmatrix(:,isample)%pixel) * pmatrix(:,isample)%weight)
            timeline(isample) = 0
            do ipixel = 1, npixels_per_sample
                if (pmatrix(ipixel,isample)%pixel == -1) exit
                timeline(isample) = timeline(isample) + map(pmatrix(ipixel,isample)%pixel) * pmatrix(ipixel,isample)%weight
            end do
        end do
        !$omp end parallel do

    end subroutine pmatrix_direct


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine pmatrix_direct_one_pixel_per_sample(pmatrix, map, timeline)

        type(pointingelement), intent(in) :: pmatrix(:)
        real(p), intent(in)               :: map(0:)
        real(p), intent(inout)            :: timeline(:)
        integer                           :: isample, nsamples

        nsamples = size(pmatrix, 1)

        !$omp parallel do
        do isample = 1, nsamples
            if (pmatrix(isample)%pixel >= 0) then
                timeline(isample) = map(pmatrix(isample)%pixel) * pmatrix(isample)%weight
            end if
        end do
        !$omp end parallel do

    end subroutine pmatrix_direct_one_pixel_per_sample


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine pmatrix_transpose(pmatrix, timeline, map)
        type(pointingelement), intent(in) :: pmatrix(:,:)
        real(kind=p), intent(in)          :: timeline(:)
        real(kind=p), intent(out)         :: map(0:)
        integer                           :: isample, ipixel, npixels, nsamples

        npixels  = size(pmatrix, 1)
        nsamples = size(pmatrix, 2)

#ifdef GFORTRAN
        !$omp parallel do reduction(+:map)
#else
        !$omp parallel do
#endif
        do isample = 1, nsamples
            do ipixel = 1, npixels
                if (pmatrix(ipixel,isample)%pixel == -1) exit
#ifndef GFORTRAN
                !$omp atomic
#endif
                map(pmatrix(ipixel,isample)%pixel) = map(pmatrix(ipixel,isample)%pixel) +                                          &
                    pmatrix(ipixel,isample)%weight * timeline(isample)
            end do
        end do
        !$omp end parallel do

    end subroutine pmatrix_transpose


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine pmatrix_transpose_one_pixel_per_sample(pmatrix, timeline, map)
        type(pointingelement), intent(in) :: pmatrix(:)
        real(kind=p), intent(in)          :: timeline(:)
        real(kind=p), intent(out)         :: map(0:)
        integer                           :: isample, nsamples

        nsamples = size(pmatrix, 1)

        do isample = 1, nsamples
            if (pmatrix(isample)%pixel >= 0) then
                map(pmatrix(isample)%pixel) = map(pmatrix(isample)%pixel) + pmatrix(isample)%weight * timeline(isample)
            end if
        end do

    end subroutine pmatrix_transpose_one_pixel_per_sample


    !-------------------------------------------------------------------------------------------------------------------------------
   
   
    subroutine pmatrix_ptp(pmatrix, ptp)
        type(pointingelement), intent(in) :: pmatrix(:,:)
        real(kind=p), intent(inout)       :: ptp(0:,0:)
        integer                           :: isample
        integer                           :: ipixel, jpixel, i, j
        integer                           :: npixels, nsamples
        real(kind(pmatrix%weight))        :: pi, pj
       
        npixels  = size(pmatrix, 1)
        nsamples = size(pmatrix, 2)
       
        !$omp parallel do reduction(+:ptp) private(isample, ipixel, jpixel, i, j, pi, pj)
        do isample = 1, nsamples
            do ipixel = 1, npixels
                if (pmatrix(ipixel,isample)%pixel == -1) exit
                i  = pmatrix(ipixel,isample)%pixel
                pi = pmatrix(ipixel,isample)%weight
                do jpixel = 1, npixels
                    if (pmatrix(jpixel,isample)%pixel == -1) exit
                    j  = pmatrix(jpixel,isample)%pixel
                    pj = pmatrix(jpixel,isample)%weight
                    ptp(i,j) = ptp(i,j) + pi * pj
                end do
            end do
        end do
        !$omp end parallel do

    end subroutine pmatrix_ptp


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine pmatrix_mask(pmatrix, mask)
        ! True means: not observed
        type(pointingelement), intent(in) :: pmatrix(:,:)
        logical(1), intent(inout)         :: mask(0:)

        integer*8 :: isample, ipixel, npixels, nsamples
        integer*4 :: pixel

        npixels  = size(pmatrix, 1)
        nsamples = size(pmatrix, 2)

        !$omp parallel do private(pixel)
        do isample = 1, nsamples
            do ipixel = 1, npixels
                pixel = pmatrix(ipixel,isample)%pixel
                if (pixel == -1) exit
                if (pmatrix(ipixel,isample)%weight == 0) cycle
                mask(pixel) = .false.
            end do
        end do
        !$omp end parallel do

    end subroutine pmatrix_mask


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine pmatrix_pack(pmatrix, mask)
        ! True means: not observed

        type(pointingelement), intent(inout) :: pmatrix(:,:)
        logical(1), intent(in)               :: mask(0:)

        integer*8 :: isample, nsamples
        integer*4 :: table(lbound(mask,1):ubound(mask,1))
        integer*4 :: pixel, ipixel, ipacked, npixels

        ! fill a table which contains the packed indices of the non-masked pixels
        ipacked = 0
        do ipixel=0, size(mask)-1
            if (mask(ipixel)) cycle
            table(ipixel) = ipacked
            ipacked = ipacked + 1
        end do

        npixels  = size(pmatrix, 1)
        nsamples = size(pmatrix, 2)

        !$omp parallel do private(pixel, ipixel)
        do isample = 1, nsamples
            ipixel = 1
            do while (ipixel <= npixels)
                pixel = pmatrix(ipixel,isample)%pixel
                if (pixel == -1) exit
                if (pmatrix(ipixel,isample)%weight == 0 .or. mask(pixel)) then
                    pmatrix(ipixel:npixels-1,isample) = pmatrix(ipixel+1:npixels,isample)
                    pmatrix(npixels,isample)%pixel = -1
                    pmatrix(npixels,isample)%weight = 0
                    cycle
                end if
                pmatrix(ipixel,isample)%pixel = table(pixel)
                ipixel = ipixel + 1
            end do
        end do
        !$omp end parallel do

    end subroutine pmatrix_pack


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine backprojection_weight(pmatrix, timeline, mask, map, weight)
        type(pointingelement), intent(in)     :: pmatrix(:,:)
        real(kind=p), intent(in)              :: timeline(:)
        logical(kind=1), intent(in), optional :: mask(:)
        real(kind=p), intent(inout)           :: map(0:)
        real(kind=p), intent(inout)           :: weight(0:)

        integer                               :: npixels, nsamples
        integer                               :: ipixel, isample, imap          
        logical                               :: domask

        npixels  = size(pmatrix, 1)
        nsamples = size(pmatrix, 2)
        domask   = present(mask)

        !$omp parallel do &
#ifdef GFORTRAN
        !$omp reduction(+:map,weight) &
#endif
        !$omp private(isample,ipixel,imap)
        do isample = 1, nsamples
            if (domask) then
                if (mask(isample)) cycle
            end if
            do ipixel = 1, npixels
                imap = pmatrix(ipixel,isample)%pixel
                if (imap == -1) exit
#ifndef GFORTRAN
                !$omp atomic
#endif
                map   (imap) = map   (imap) + pmatrix(ipixel,isample)%weight * timeline(isample)
#ifndef GFORTRAN
                !$omp atomic
#endif
                weight(imap) = weight(imap) + pmatrix(ipixel,isample)%weight
            end do
        end do
        !$omp end parallel do

    end subroutine backprojection_weight


    !-------------------------------------------------------------------------------------------------------------------------------


    ! backproject a frame into a minimap
    subroutine backprojection_weighted_roi(pmatrix, nx, timeline, mask, itime, map, roi)

        type(pointingelement), intent(in) :: pmatrix(:,:,:)
        integer, intent(in)               :: nx
        real(p), intent(in)               :: timeline(:,:)
        logical(kind=1), intent(in)       :: mask(:,:)
        integer, intent(in)               :: itime
        real(p), intent(out)              :: map(0:)
        integer, intent(out)              :: roi(2,2)

        real(sp) :: weight(0:ubound(map,1))
        integer  :: nxmap, xmap, ymap, imap
        integer  :: ndetectors, npixels_per_sample, idetector, ipixel

        npixels_per_sample = size(pmatrix,1)
        ndetectors = size(pmatrix,3)

        roi(1,1) = minval(modulo(pmatrix(:,itime,:)%pixel,nx), pmatrix(:,itime,:)%pixel /= -1) + 1 ! xmin
        roi(1,2) = maxval(modulo(pmatrix(:,itime,:)%pixel,nx), pmatrix(:,itime,:)%pixel /= -1) + 1 ! xmax
        roi(2,1) = minval(pmatrix(:,itime,:)%pixel / nx, pmatrix(:,itime,:)%pixel /= -1) + 1       ! ymin
        roi(2,2) = maxval(pmatrix(:,itime,:)%pixel / nx, pmatrix(:,itime,:)%pixel /= -1) + 1       ! ymax

        nxmap = roi(1,2) - roi(1,1) + 1

        ! backprojection of the timeline and weights
        map = 0
        weight = 0
        do idetector = 1, ndetectors

            if (mask(itime,idetector)) cycle

            do ipixel = 1, npixels_per_sample

                if (pmatrix(ipixel,itime,idetector)%pixel == -1) exit

                xmap = mod(pmatrix(ipixel,itime,idetector)%pixel, nx) - roi(1,1) + 1
                ymap = pmatrix(ipixel,itime,idetector)%pixel / nx     - roi(2,1) + 1
                imap = xmap + ymap * nxmap
                map(imap) = map(imap) + timeline(itime,idetector) * pmatrix(ipixel,itime,idetector)%weight
                weight(imap) = weight(imap) + pmatrix(ipixel,itime,idetector)%weight

            end do

        end do

        map = map / weight
        where (weight == 0)
            map = NaN
        end where

    end subroutine backprojection_weighted_roi


    !-------------------------------------------------------------------------------------------------------------------------------


    ! roi is a 3-dimensional array: [1=x|2=y,1=min|2=max,idetector]
    function xy2roi(xy, nvertices) result(roi)

        real(p), intent(in) :: xy(:,:)
        integer, intent(in) :: nvertices

        integer             :: roi(size(xy,1),2,size(xy,2)/nvertices)
        integer             :: idetector

        do idetector = 1, size(xy,2) / nvertices
            roi(1,1,idetector) = nint_up  (minval(xy(1,nvertices * (idetector-1)+1:nvertices*idetector)))
            roi(1,2,idetector) = nint_down(maxval(xy(1,nvertices * (idetector-1)+1:nvertices*idetector)))
            roi(2,1,idetector) = nint_up  (minval(xy(2,nvertices * (idetector-1)+1:nvertices*idetector)))
            roi(2,2,idetector) = nint_down(maxval(xy(2,nvertices * (idetector-1)+1:nvertices*idetector)))
        end do

    end function xy2roi


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine xy2pmatrix(x, y, nx, ny, out, pmatrix)

        real(p), intent(in)                :: x(:), y(:)
        integer, intent(in)                :: nx, ny
        logical, intent(inout)             :: out
        type(pointingelement), intent(out) :: pmatrix(:)

        integer                            :: idetector, ix, iy

        do idetector = 1, size(pmatrix)

            ix = nint_up(x(idetector))
            iy = nint_up(y(idetector))
            if (ix < 1 .or. ix > nx .or. iy < 1 .or. iy > ny) then
               out = .true.
               pmatrix(idetector)%pixel  = -1
               pmatrix(idetector)%weight = 0
               cycle
            end if

            pmatrix(idetector)%pixel  = ix - 1 + (iy - 1) * nx
            pmatrix(idetector)%weight = 1.

        end do

    end subroutine xy2pmatrix


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine roi2pmatrix(roi, nvertices, coords, nx, ny, nroi, out, pmatrix)

        integer, intent(in)                :: roi(:,:,:)
        integer, intent(in)                :: nvertices
        real(p), intent(in)                :: coords(:,:)
        integer, intent(in)                :: nx, ny
        integer, intent(inout)             :: nroi
        logical, intent(inout)             :: out
        type(pointingelement), intent(out) :: pmatrix(:,:)

        real(p)  :: polygon(size(roi,1),nvertices)
        integer  :: npixels_per_sample, idetector, ix, iy, iroi
        real(sp) :: weight

        npixels_per_sample = size(pmatrix, 1)
        do idetector = 1, size(pmatrix, 2)

            if (roi(2,1,idetector) < 1 .or. roi(2,2,idetector) > ny .or. roi(1,1,idetector) < 1 .or. roi(1,2,idetector) > nx) then
               out = .true.
            end if

            iroi = 1
            do iy = max(roi(2,1,idetector),1), min(roi(2,2,idetector),ny)

                do ix = max(roi(1,1,idetector),1), min(roi(1,2,idetector),nx)

                    polygon(1,:) = coords(1,(idetector-1)*nvertices+1:idetector*nvertices) - (ix-0.5_p)
                    polygon(2,:) = coords(2,(idetector-1)*nvertices+1:idetector*nvertices) - (iy-0.5_p)
                    weight = real(abs(intersection_polygon_unity_square(polygon, nvertices)), kind=sp)
                    if (weight == 0) cycle
                    if (iroi <= npixels_per_sample) then
                        pmatrix(iroi,idetector)%pixel  = ix - 1 + (iy - 1) * nx
                        pmatrix(iroi,idetector)%weight = weight
                    end if
                    iroi = iroi + 1

                end do

            end do

            ! fill the rest of the pointing matrix
            pmatrix(iroi:,idetector)%pixel  = -1
            pmatrix(iroi:,idetector)%weight = 0
            nroi = max(nroi, iroi-1)

        end do

    end subroutine roi2pmatrix


end module module_pointingmatrix

! Copyright 2010-2011 Pierre Chanial
! All rights reserved
!
module module_fitstools

    use iso_c_binding
    use iso_fortran_env,  only : ERROR_UNIT, OUTPUT_UNIT
    use module_precision, only : sp, dp, qp
    use module_string,    only : strinteger, strlowcase, strsection, strupcase
    use module_tamasis,   only : p
    implicit none
    private

    public :: FLEN_KEYWORD
    public :: FLEN_CARD
    public :: FLEN_VALUE
    public :: FLEN_COMMENT
    public :: FLEN_ERRMSG
    public :: FLEN_STATUS
    public :: ft_read_keyword

    integer, private, parameter :: GROUP = 1
    integer, private, parameter :: NULLVAL = 0

    integer, parameter :: FLEN_KEYWORD = 71
    integer, parameter :: FLEN_CARD    = 80
    integer, parameter :: FLEN_VALUE   = 70
    integer, parameter :: FLEN_COMMENT = 72
    integer, parameter :: FLEN_ERRMSG  = 80
    integer, parameter :: FLEN_STATUS  = 30


    interface ft_read_keyword
        module procedure ft_read_keyword_header_logical, ft_read_keyword_header_int4, ft_read_keyword_header_int8,                 &
                         ft_read_keyword_header_real4, ft_read_keyword_header_real8, ft_read_keyword_header_character
    end interface ft_read_keyword



contains


    subroutine get_keyword(header, keyword, value, found, comment, must_exist, status)

        character(len=*), intent(in)                       :: header
        character(len=*), intent(in)                       :: keyword
        character(len=FLEN_VALUE), intent(out)             :: value
        logical, intent(out)                               :: found
        character(len=FLEN_COMMENT), intent(out), optional :: comment
        logical, intent(in), optional                      :: must_exist
        integer, intent(out)                               :: status

        character(len=FLEN_VALUE)   :: buffer
        character(len=FLEN_KEYWORD) :: strlowkeyword
        integer                     :: i, ikeyword, ncards

        status = 0
        value = ' '

        ncards = (len(header)-1) / 80 + 1! allow for an additional \0
        found = .false.
        if (present(comment)) comment = ' '
        strlowkeyword = strlowcase(keyword)

        ! find the record number associated to the keyword
        do ikeyword = 1, ncards
           if (strlowcase(header((ikeyword-1)*80+1:(ikeyword-1)*80+8)) == strlowkeyword) then
              found = .true.
              exit
           end if
        end do

        ! the keyword is not found
        if (.not. found) then
            if (present(must_exist)) then
                if (must_exist) then
                    status = 202
                    write (ERROR_UNIT, '(a)') "Missing keyword '" // strupcase(keyword) // "' in FITS header."
                    return
                end if
            end if
            return
        end if

        buffer = adjustl(header((ikeyword-1)*80+11:ikeyword*80))

        ! simple case, the value is not enclosed in quotes
        if (buffer(1:1) /= "'") then
            i = index(buffer, '/')
            if (i == 0) i = 71
            goto 999 ! end of slash
        end if

        ! find ending quote
        i = 2
        do while (i <= 70)
            if (buffer(i:i) == "'") then
                i = i + 1
                if (i == 71) goto 999 ! end of slash
                if (buffer(i:i) /= "'") exit
            end if
            i = i + 1
        end do

        ! i points right after ending quote, let's find '/' ignoring what's before it
        do while (i <= 70)
            if (buffer(i:i) == '/') exit
            i = i + 1
        end do

        ! i points to '/' or is 71
    999 value = buffer(1:i-1)
        if (present(comment)) comment = buffer(i+1:)

    end subroutine get_keyword


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine ft_read_keyword_header_logical(header, keyword, value, found, status, comment)

        character(len=*), intent(in)                       :: header
        character(len=*), intent(in)                       :: keyword
        logical, intent(out)                               :: value
        logical, intent(out), optional                     :: found
        integer, intent(out)                               :: status
        character(len=FLEN_COMMENT), optional, intent(out) :: comment

        character(len=FLEN_VALUE) :: charvalue
        logical                   :: found_

        value = .false.

        call get_keyword(header, keyword, charvalue, found_, comment, .not. present(found), status)
        if (present(found)) found = found_
        if (status /= 0 .or. .not. found_) return

        charvalue = strupcase(charvalue)
        if (charvalue /= 'FALSE'(1:min(5,len_trim(charvalue))) .and. charvalue /= 'TRUE'(1:min(4,len_trim(charvalue)))) then
            status = 404
            write (ERROR_UNIT,'(a)') "ft_read_keyword_header_logical: invalid logical value '" // trim(charvalue) //             &
                  "' for keyword '" // keyword // "' in FITS header."
            return
        end if

        if (charvalue(1:1) == 'T') value = .true.

    end subroutine ft_read_keyword_header_logical


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine ft_read_keyword_header_int4(header, keyword, value, found, status, comment)

        character(len=*), intent(in)                       :: header
        character(len=*), intent(in)                       :: keyword
        integer*4, intent(out)                             :: value
        logical, intent(out), optional                     :: found
        integer, intent(out)                               :: status
        character(len=FLEN_COMMENT), optional, intent(out) :: comment

        character(len=FLEN_VALUE) :: charvalue
        logical                   :: found_

        value = 0

        call get_keyword(header, keyword, charvalue, found_, comment, .not. present(found), status)
        if (present(found)) found = found_
        if (status /= 0 .or. .not. found_) return

        read (charvalue,'(i20)',iostat=status) value
        if (status /= 0) then
            status = 407
            write (ERROR_UNIT,'(a)') "ft_read_keyword_header_int4: invalid integer value '" // trim(charvalue) //                &
                  "' for keyword '" // keyword // "' in FITS header."
            return
        end if

    end subroutine ft_read_keyword_header_int4


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine ft_read_keyword_header_int8(header, keyword, value, found, status, comment)

        character(len=*), intent(in)                       :: header
        character(len=*), intent(in)                       :: keyword
        integer*8, intent(out)                             :: value
        logical, intent(out), optional                     :: found
        integer, intent(out)                               :: status
        character(len=FLEN_COMMENT), optional, intent(out) :: comment

        character(len=FLEN_VALUE) :: charvalue
        logical                   :: found_

        value = 0

        call get_keyword(header, keyword, charvalue, found_, comment, .not. present(found), status)
        if (present(found)) found = found_
        if (status /= 0 .or. .not. found_) return

        read (charvalue,'(i20)',iostat=status) value
        if (status /= 0) then
            status = 407
            write (ERROR_UNIT,'(a)') "ft_read_keyword_header_int8: invalid integer value '" // trim(charvalue) //                &
                  "' for keyword '" // keyword // "' in FITS header."
            return
        end if

    end subroutine ft_read_keyword_header_int8


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine ft_read_keyword_header_real4(header, keyword, value, found, status, comment)

        character(len=*), intent(in)                       :: header
        character(len=*), intent(in)                       :: keyword
        real(sp), intent(out)                              :: value
        logical, intent(out), optional                     :: found
        integer, intent(out)                               :: status
        character(len=FLEN_COMMENT), optional, intent(out) :: comment

        real(dp) :: value_

        call ft_read_keyword(header, keyword, value_, found, status, comment)
        value = real(value_, sp)

    end subroutine ft_read_keyword_header_real4


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine ft_read_keyword_header_real8(header, keyword, value, found, status, comment)

        character(len=*), intent(in)                       :: header
        character(len=*), intent(in)                       :: keyword
        real(dp), intent(out)                              :: value
        logical, intent(out), optional                     :: found
        integer, intent(out)                               :: status
        character(len=FLEN_COMMENT), optional, intent(out) :: comment

        character(len=FLEN_VALUE) :: charvalue
        logical                   :: found_

        value = 0

        call get_keyword(header, keyword, charvalue, found_, comment, .not. present(found), status)
        if (present(found)) found = found_
        if (status /= 0 .or. .not. found_) return

        read (charvalue,*,iostat=status) value
        if (status /= 0) then
            status = 409
            write (ERROR_UNIT,'(a)') "ft_read_keyword: invalid real value '" // trim(charvalue) //                 &
                  "' for keyword '" // keyword // "' in FITS header."
            return
        end if

    end subroutine ft_read_keyword_header_real8


    !-------------------------------------------------------------------------------------------------------------------------------


#if PRECISION_REAL == 16
    subroutine ft_read_keyword_header_real16(header, keyword, value, found, status, comment)

        character(len=*), intent(in)                       :: header
        character(len=*), intent(in)                       :: keyword
        real(qp), intent(out)                              :: value
        logical, intent(out), optional                     :: found
        integer, intent(out)                               :: status
        character(len=FLEN_COMMENT), optional, intent(out) :: comment

        real(dp) :: value_

        call ft_read_keyword(header, keyword, value_, found, status, comment)
        value = real(value_, qp)

    end subroutine ft_read_keyword_header_real16
#endif

    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine ft_read_keyword_header_character(header, keyword, value, found, status, comment)

        character(len=*), intent(in)                       :: header
        character(len=*), intent(in)                       :: keyword
        character(len=*), intent(out)                      :: value
        logical, intent(out), optional                     :: found
        integer, intent(out)                               :: status
        character(len=FLEN_COMMENT), optional, intent(out) :: comment

        character(len=FLEN_VALUE) :: charvalue
        integer                   :: ncharvalue, i, j
        logical                   :: found_

        call get_keyword(header, keyword, charvalue, found_, comment, .not. present(found), status)
        if (present(found)) found = found_
        if (status /= 0 .or. .not. found_) return

        if (charvalue(1:1) /= "'") then
           value = charvalue
           return
        end if

        value = ' '

        ! remove leading quote
        charvalue = charvalue(2:len_trim(charvalue))

        ! scan until next '
        ! make double quotes single
        ncharvalue = len_trim(charvalue)
        i = 1
        j = 1
        do while (j <= ncharvalue)
           if (charvalue(j:j) == "'") then
              if (j == ncharvalue .or. charvalue(j+1:j+1) /= "'") exit
           end if
           value(i:i) = charvalue(j:j)
           i = i + 1
           if (j /= ncharvalue) then
               if (charvalue(j:j+1) == "''") j = j + 1
           end if
           j = j + 1
        end do

    end subroutine ft_read_keyword_header_character


end module module_fitstools

module pointingmatrix

    use module_precision, only : sp
    use module_tamasis, only : p

    implicit none

!    integer, parameter :: sp = selected_real_kind(6,37)  ! single precision
!    integer, parameter :: p = selected_real_kind(15,307) ! double precision

    type PointingElement
        real(sp) :: value
        integer  :: index
    end type PointingElement

contains
    
    subroutine backprojection_weight(pmatrix, data, map1d, weight1d, npixels_per_sample, nsamples, npixels)

        !f2py integer*8,intent(in)        :: pmatrix(npixels_per_sample*nsamples)

        integer*8, intent(in)             :: nsamples
        type(PointingElement), intent(in) :: pmatrix(npixels_per_sample, nsamples)
        real(p), intent(in)               :: data(nsamples)
        real(p), intent(inout)            :: map1d(npixels)
        real(p), intent(inout)            :: weight1d(npixels)
        integer, intent(in)               :: npixels_per_sample
        integer, intent(in)               :: npixels

        call backprojection_weight__inner(pmatrix, data, map=map1d, weight=weight1d)

    end subroutine backprojection_weight


    !---------------------------------------------------------------------------


    subroutine backprojection_weight_mask(pmatrix, data, mask, map1d, weight1d, npixels_per_sample, nsamples, npixels)

        !f2py integer*8,intent(in)        :: pmatrix(npixels_per_sample*nsamples)

        integer*8, intent(in)             :: nsamples
        type(PointingElement), intent(in) :: pmatrix(npixels_per_sample, nsamples)
        real(p), intent(in)               :: data(nsamples)
        logical*1, intent(in)             :: mask(nsamples)
        real(p), intent(inout)            :: map1d(npixels)
        real(p), intent(inout)            :: weight1d(npixels)
        integer, intent(in)               :: npixels_per_sample
        integer, intent(in)               :: npixels

        call backprojection_weight__inner(pmatrix, data, mask, map1d, weight1d)

    end subroutine backprojection_weight_mask


    !---------------------------------------------------------------------------


    subroutine check(matrix, npixels_per_sample, nsamples, npixels, isvalid)
        !f2py threadsafe
        !f2py integer*8, dimension(npixels_per_sample*nsamples) :: matrix

        integer*8, intent(in)             :: nsamples
        type(PointingElement), intent(in) :: matrix(npixels_per_sample,nsamples)
        integer, intent(in)               :: npixels_per_sample
        integer, intent(in)               :: npixels
        logical*1, intent(out)            :: isvalid
        integer :: index, ipixel, isample

        isvalid = .false.
        do isample = 1, size(matrix, 2)
            do ipixel = 1, size(matrix, 1)
                index = matrix(ipixel,isample)%index
                if (index == -1) cycle
                if (index < 0 .or. index >= npixels) return
            end do
        end do
        isvalid = .true.

    end subroutine check


    !---------------------------------------------------------------------------


    subroutine direct(pmatrix, map1d, signal, npixels_per_sample, nsamples, npixels)

        !f2py integer*8, dimension(npixels_per_sample*nsamples), intent(inout) :: pmatrix

        integer*8, intent(in)  :: nsamples
        type(PointingElement), intent(inout) :: pmatrix(npixels_per_sample, nsamples)
        real(p), intent(in)    :: map1d(npixels)
        real(p), intent(inout) :: signal(nsamples)
        integer, intent(in)    :: npixels_per_sample
        integer, intent(in)    :: npixels

        if (npixels_per_sample == 1) then
            call pmatrix_direct_one_pixel_per_sample(pmatrix(1,:), map1d, signal)
        else
            call pmatrix_direct(pmatrix, map1d, signal)
        end if

    end subroutine direct


    !---------------------------------------------------------------------------


    subroutine intersects(pmatrix, pixel, npixels_per_sample, nsamples, ndetectors, out)
        !f2py integer*8, dimension(npixels_per_sample*nsamples*ndetectors), intent(in) :: pmatrix

        integer*8, intent(in)                     :: nsamples
        type(PointingElement), intent(in)         :: pmatrix(npixels_per_sample, nsamples, ndetectors)
        integer(kind(pmatrix%value)), intent(in) :: pixel
        integer, intent(in)                       :: npixels_per_sample
        integer, intent(in)                       :: ndetectors
        logical*1, intent(out)                    :: out
        
        out = any(pmatrix%index == pixel)

    end subroutine intersects


    !---------------------------------------------------------------------------


    subroutine intersects_openmp2(pmatrix, pixel, npixels_per_sample, nsamples, ndetectors, out)
        !f2py integer*8, dimension(npixels_per_sample*nsamples*ndetectors), intent(in) :: pmatrix

        integer*8, intent(in)                     :: nsamples
        type(PointingElement), intent(in)         :: pmatrix(npixels_per_sample, nsamples, ndetectors)
        integer(kind(pmatrix%value)), intent(in) :: pixel
        integer, intent(in)                       :: npixels_per_sample
        integer, intent(in)                       :: ndetectors
        logical*1, intent(out)                    :: out
        
        !$omp parallel workshare
        out = any(pmatrix%index == pixel)
        !$omp end parallel workshare

    end subroutine intersects_openmp2


    !---------------------------------------------------------------------------


    subroutine intersects_axis2(pmatrix, pixel, npixels_per_sample, nsamples, ndetectors, out)
        !f2py integer*8, dimension(npixels_per_sample*nsamples*ndetectors), intent(in) :: pmatrix

        integer*8, intent(in)                     :: nsamples
        type(PointingElement), intent(in)         :: pmatrix(npixels_per_sample, nsamples, ndetectors)
        integer(kind(pmatrix%value)), intent(in) :: pixel
        integer, intent(in)                       :: npixels_per_sample
        integer, intent(in)                       :: ndetectors
        logical*1, intent(out)                    :: out(ndetectors)

        integer   :: idetector, ipixel
        integer*8 :: isample

        out = .false.
        !$omp parallel do schedule(guided)
        loop_detector: do idetector = 1, ndetectors
            do isample = 1, nsamples
                do ipixel = 1, npixels_per_sample
                    if (pmatrix(ipixel,isample,idetector)%index == pixel) then
                        out(idetector) = .true.
                        cycle loop_detector
                    end if
                end do
            end do
        end do loop_detector
        !$omp end parallel do

    end subroutine intersects_axis2


    !---------------------------------------------------------------------------


    subroutine intersects_axis3(pmatrix, pixel, npixels_per_sample, nsamples, ndetectors, out)
        !f2py integer*8, dimension(npixels_per_sample*nsamples*ndetectors), intent(in) :: pmatrix

        integer*8, intent(in)                     :: nsamples
        type(PointingElement), intent(in)         :: pmatrix(npixels_per_sample, nsamples, ndetectors)
        integer(kind(pmatrix%value)), intent(in) :: pixel
        integer, intent(in)                       :: npixels_per_sample
        integer, intent(in)                       :: ndetectors
        logical*1, intent(out)                    :: out(nsamples)

        integer   :: idetector, ipixel
        integer*8 :: isample

        out = .false.
        !$omp parallel do schedule(guided)
        loop_sample: do isample = 1, nsamples
            do idetector = 1, ndetectors
                do ipixel = 1, npixels_per_sample
                    if (pmatrix(ipixel,isample,idetector)%index == pixel) then
                        out(isample) = .true.
                        cycle loop_sample
                    end if
                end do
            end do
        end do loop_sample
        !$omp end parallel do

    end subroutine intersects_axis3


    !---------------------------------------------------------------------------


    subroutine mask(pmatrix, mask1d, npixels_per_sample, nsamples, npixels)

        !f2py integer*8, dimension(npixels_per_sample*nsamples), intent(in) :: pmatrix

        integer*8, intent(in)             :: nsamples
        type(PointingElement), intent(in) :: pmatrix(npixels_per_sample, nsamples)
        logical*1, intent(inout)          :: mask1d(npixels)
        integer, intent(in)               :: npixels_per_sample
        integer, intent(in)               :: npixels

        call pmatrix_mask(pmatrix, mask1d)

    end subroutine mask


    !---------------------------------------------------------------------------
    
    
    subroutine pack(pmatrix, mask1d, npixels_per_sample, nsamples, npixels)

        !f2py integer*8, dimension(npixels_per_sample*nsamples), intent(inout) :: pmatrix

        integer*8, intent(in)                :: nsamples
        type(PointingElement), intent(inout) :: pmatrix(npixels_per_sample, nsamples)
        logical*1, intent(in)                :: mask1d(npixels)
        integer, intent(in)                  :: npixels_per_sample
        integer, intent(in)                  :: npixels

        call pmatrix_pack(pmatrix, mask1d)

    end subroutine pack


    !---------------------------------------------------------------------------


    subroutine ptp(pmatrix, array, npixels_per_sample, nsamples, npixels)

        !f2py integer*8, dimension(npixels_per_sample*nsamples), intent(inout) :: pmatrix

        integer*8, intent(in)                :: nsamples
        type(PointingElement), intent(inout) :: pmatrix(npixels_per_sample, nsamples)
        real(p), intent(inout)               :: array(npixels, npixels)
        integer, intent(in)                  :: npixels_per_sample
        integer, intent(in)                  :: npixels

        call pmatrix_ptp(pmatrix, array)

    end subroutine ptp


    !---------------------------------------------------------------------------


    subroutine ptp_one(pmatrix, array, nsamples, npixels)

        !f2py integer*8, dimension(nsamples), intent(inout) :: pmatrix

        integer*8, intent(in)                :: nsamples
        type(PointingElement), intent(inout) :: pmatrix(nsamples)
        real(p), intent(inout)               :: array(npixels)
        integer, intent(in)                  :: npixels
        integer*8 :: isample

        do isample = 1, nsamples
            array(pmatrix(isample)%index) = array(pmatrix(isample)%index) +    &
                                            pmatrix(isample)%value**2
        end do

    end subroutine ptp_one


    !---------------------------------------------------------------------------


    subroutine transpose(pmatrix, signal, map1d, npixels_per_sample, nsamples, npixels)

        !f2py integer*8, dimension(npixels_per_sample*nsamples), intent(inout) :: pmatrix

        integer*8, intent(in)  :: nsamples
        type(PointingElement), intent(inout) :: pmatrix(npixels_per_sample, nsamples)
        real(p), intent(in)    :: signal(nsamples)
        real(p), intent(inout) :: map1d(npixels)
        integer, intent(in)    :: npixels_per_sample
        integer, intent(in)    :: npixels

        if (npixels_per_sample == 1) then
            call pmatrix_transpose_one_pixel_per_sample(pmatrix(1,:), signal, map1d)
        else
            call pmatrix_transpose(pmatrix, signal, map1d)
        end if

    end subroutine transpose


    !---------------------------------------------------------------------------


    subroutine roi2matrix_cartesian(roi, coords, ncoords, nvertices,           &
        npixels_per_sample, nx, ny, matrix, new_npixels_per_sample, out)
        !f2py threadsafe
        !f2py integer*8, dimension(npixels_per_sample*ncoords) :: matrix

        integer, intent(in)                 :: roi(2,2,ncoords)
        real(p), intent(in)                 :: coords(2,nvertices,ncoords)
        integer, intent(in)                 :: ncoords, nvertices
        integer, intent(in)                 :: npixels_per_sample
        integer, intent(in)                 :: nx, ny
        integer, intent(out)                :: new_npixels_per_sample
        logical, intent(out)                :: out
        type(PointingElement), intent(inout)::matrix(npixels_per_sample,ncoords)

        real(p) :: polygon(2,nvertices)
        integer :: icoord, ix, iy, npixels
        real*4  :: val

        do icoord = 1, size(matrix, 2)

            if (roi(2,1,icoord) < 1 .or. roi(2,2,icoord) > ny .or.             &
                roi(1,1,icoord) < 1 .or. roi(1,2,icoord) > nx) then
               out = .true.
            end if

            npixels = 1
            do iy = max(roi(2,1,icoord),1), min(roi(2,2,icoord),ny)

                do ix = max(roi(1,1,icoord),1), min(roi(1,2,icoord),nx)

                    polygon(1,:) = coords(1,:,icoord) - (ix-0.5_p)
                    polygon(2,:) = coords(2,:,icoord) - (iy-0.5_p)
                    val = real(abs(intersection_polygon_unity_square(polygon, nvertices)), kind=sp)
                    if (val == 0) cycle
                    if (npixels <= npixels_per_sample) then
                        matrix(npixels,icoord)%index = ix - 1 + (iy - 1) * nx
                        matrix(npixels,icoord)%value = val
                    end if
                    npixels = npixels + 1

                end do

            end do

            ! fill the rest of the pointing matrix
            matrix(npixels:,icoord)%index  = -1
            matrix(npixels:,icoord)%value = 0
            new_npixels_per_sample = max(new_npixels_per_sample, npixels-1)

        end do

    end subroutine roi2matrix_cartesian


    !---------------------------------------------------------------------------
    !---------------------------------------------------------------------------
    !---------------------------------------------------------------------------
    !---------------------------------------------------------------------------


    pure function intersection_polygon_unity_square(xy, nvertices) result(out)

        real*8              :: out
        real*8, intent(in)  :: xy(2,nvertices)
        integer, intent(in) :: nvertices
        integer             :: i, j

        out = 0
        j = nvertices
        do i=1, nvertices
            out = out + intersection_segment_unity_square(xy(1,i), xy(2,i),    &
                                                          xy(1,j), xy(2,j))
            j = i
        end do

    end function intersection_polygon_unity_square


    !---------------------------------------------------------------------------


    pure function intersection_segment_unity_square(x1, y1, x2, y2) result(out)

        real*8             :: out
        real*8, intent(in) :: x1, y1, x2, y2 ! 1st and 2nd point coordinates

        real*8 :: pente       ! slope of the straight line going through p1, p2
        real*8 :: ordonnee    ! point where the straight line crosses y-axis
        real*8 :: delta_x     ! = x2-x1
        real*8 :: xmin, xmax  ! minimum and maximum values of x to consider
                              ! (clipped in the square (0,0),(1,0),(1,1),(0,1)
        real*8 :: ymin, ymax  ! minimum and maximum values of y to consider
                              ! (clipped in the square (0,0),(1,0),(1,1),(0,1)
        real*8 :: xhaut       ! value of x at which straight line crosses the
                              ! (0,1),(1,1) line
        logical:: neg_delta_x ! TRUE if delta_x < 0

        ! Check for vertical line : the area intercepted is 0
        if (x1 == x2) then
            out = 0
            return
        end if

        ! Order the two input points in x
        if (x2 > x1) then
            xmin = x1
            xmax = x2
        else
            xmin = x2
            xmax = x1
        end if

        ! And determine the bounds ignoring y for now
        ! test is p1 and p2 are outside the square along x-axis
        if (xmin > 1 .or. xmax < 0) then
            out = 0
            return    ! outside, the area is 0
        end if

        ! We compute xmin, xmax, clipped between 0 and 1 in x
        ! then we compute pente (slope) and ordonnee and use it to get ymin
        ! and ymax
        xmin = max(xmin, 0._p)
        xmax = min(xmax, 1._p)

        delta_x = x2 - x1
        neg_delta_x = delta_x < 0
        pente = (y2 - y1) / delta_x
        ordonnee  = y1 - pente * x1
        ymin = pente * xmin + ordonnee
        ymax = pente * xmax + ordonnee

        ! Trap segment entirely below axis
        if (ymin < 0 .and. ymax < 0) then
            out = 0
            return  ! if segment below axis, intercepted surface is 0
        end if

        ! Adjust bounds if segment crosses axis x-axis
        !(to exclude anything below axis)
        if (ymin < 0) then
            ymin = 0
            xmin = - ordonnee / pente
        end if
        if (ymax < 0) then
            ymax = 0
            xmax = - ordonnee / pente
        end if

        ! There are four possibilities: both y below 1, both y above 1
        ! and one of each.

        if (ymin >= 1 .and. ymax >= 1) then

            ! Line segment is entirely above square : we clip with the square
            if (neg_delta_x) then
                out = xmin - xmax
            else
                out = xmax - xmin
            end if
            return

        end if

        if (ymin <= 1 .and. ymax <= 1) then
          ! Segment is entirely within square
          if (neg_delta_x) then
             out = 0.5_p * (xmin-xmax) * (ymax+ymin)
          else
             out = 0.5_p * (xmax-xmin) * (ymax+ymin)
          end if
          return
        end if

        ! otherwise it must cross the top of the square
        ! the crossing occurs at xhaut
        xhaut = (1 - ordonnee) / pente
        !!if ((xhaut < xmin) .or. (xhaut > xmax))   cout << " BUGGGG "
        if (ymin < 1) then
            if (neg_delta_x) then
                out = -(0.5_p * (xhaut-xmin) * (1+ymin) + xmax - xhaut)
            else
                out = 0.5_p * (xhaut-xmin) * (1+ymin) + xmax - xhaut
            end if
        else
            if (neg_delta_x) then
                out = -(0.5_p * (xmax-xhaut) * (1+ymax) + xhaut-xmin)
            else
                out = 0.5_p * (xmax-xhaut) * (1+ymax) + xhaut-xmin
            end if
        end if

    end function intersection_segment_unity_square


    subroutine pmatrix_direct(pmatrix, map, timeline)

        type(pointingelement), intent(in) :: pmatrix(:,:)
        real(p), intent(in)               :: map(0:)
        real(p), intent(inout)            :: timeline(:)
        integer                           :: ipixel, isample, npixels_per_sample, nsamples

        npixels_per_sample = size(pmatrix,1)
        nsamples = size(pmatrix, 2)

        !$omp parallel do
        do isample = 1, nsamples
!!$            timeline(isample) = sum(map(pmatrix(:,isample)%index) * pmatrix(:,isample)%value)
            timeline(isample) = 0
            do ipixel = 1, npixels_per_sample
                if (pmatrix(ipixel,isample)%index == -1) exit
                timeline(isample) = timeline(isample) + map(pmatrix(ipixel,isample)%index) * pmatrix(ipixel,isample)%value
            end do
        end do
        !$omp end parallel do

    end subroutine pmatrix_direct


    !---------------------------------------------------------------------------


    subroutine pmatrix_direct_one_pixel_per_sample(pmatrix, map, timeline)

        type(pointingelement), intent(in) :: pmatrix(:)
        real(p), intent(in)               :: map(0:)
        real(p), intent(inout)            :: timeline(:)
        integer                           :: isample, nsamples

        nsamples = size(pmatrix, 1)

        !$omp parallel do
        do isample = 1, nsamples
            if (pmatrix(isample)%index >= 0) then
                timeline(isample) = map(pmatrix(isample)%index) * pmatrix(isample)%value
            end if
        end do
        !$omp end parallel do

    end subroutine pmatrix_direct_one_pixel_per_sample


    !---------------------------------------------------------------------------


    subroutine pmatrix_transpose(pmatrix, timeline, map)
        type(pointingelement), intent(in) :: pmatrix(:,:)
        real(p), intent(in)          :: timeline(:)
        real(p), intent(out)         :: map(0:)
        integer                           :: isample, ipixel, npixels, nsamples

        npixels  = size(pmatrix, 1)
        nsamples = size(pmatrix, 2)

#ifdef GFORTRAN
        !$omp parallel do reduction(+:map)
#else
        !$omp parallel do
#endif
        do isample = 1, nsamples
            do ipixel = 1, npixels
                if (pmatrix(ipixel,isample)%index == -1) exit
#ifndef GFORTRAN
                !$omp atomic
#endif
                map(pmatrix(ipixel,isample)%index) = map(pmatrix(ipixel,isample)%index) +                                          &
                    pmatrix(ipixel,isample)%value * timeline(isample)
            end do
        end do
        !$omp end parallel do

    end subroutine pmatrix_transpose


    !---------------------------------------------------------------------------


    subroutine pmatrix_transpose_one_pixel_per_sample(pmatrix, timeline, map)
        type(pointingelement), intent(in) :: pmatrix(:)
        real(p), intent(in)          :: timeline(:)
        real(p), intent(out)         :: map(0:)
        integer                           :: isample, nsamples

        nsamples = size(pmatrix, 1)

        do isample = 1, nsamples
            if (pmatrix(isample)%index >= 0) then
                map(pmatrix(isample)%index) = map(pmatrix(isample)%index) + pmatrix(isample)%value * timeline(isample)
            end if
        end do

    end subroutine pmatrix_transpose_one_pixel_per_sample


    !---------------------------------------------------------------------------
   
   
    subroutine pmatrix_ptp(pmatrix, ptp)
        type(pointingelement), intent(in) :: pmatrix(:,:)
        real(p), intent(inout)       :: ptp(0:,0:)
        integer                           :: isample
        integer                           :: ipixel, jpixel, i, j
        integer                           :: npixels, nsamples
        real(kind(pmatrix%value))        :: pi, pj
       
        npixels  = size(pmatrix, 1)
        nsamples = size(pmatrix, 2)
       
        !$omp parallel do reduction(+:ptp) private(isample, ipixel, jpixel, i, j, pi, pj)
        do isample = 1, nsamples
            do ipixel = 1, npixels
                if (pmatrix(ipixel,isample)%index == -1) exit
                i  = pmatrix(ipixel,isample)%index
                pi = pmatrix(ipixel,isample)%value
                do jpixel = 1, npixels
                    if (pmatrix(jpixel,isample)%index == -1) exit
                    j  = pmatrix(jpixel,isample)%index
                    pj = pmatrix(jpixel,isample)%value
                    ptp(i,j) = ptp(i,j) + pi * pj
                end do
            end do
        end do
        !$omp end parallel do

    end subroutine pmatrix_ptp


    !---------------------------------------------------------------------------


    subroutine pmatrix_mask(pmatrix, mask)
        ! True means: not observed
        type(pointingelement), intent(in) :: pmatrix(:,:)
        logical(1), intent(inout)         :: mask(0:)

        integer*8 :: isample, ipixel, npixels, nsamples
        integer*4 :: pixel

        npixels  = size(pmatrix, 1)
        nsamples = size(pmatrix, 2)

        !$omp parallel do private(pixel)
        do isample = 1, nsamples
            do ipixel = 1, npixels
                pixel = pmatrix(ipixel,isample)%index
                if (pixel == -1) exit
                if (pmatrix(ipixel,isample)%value == 0) cycle
                mask(pixel) = .false.
            end do
        end do
        !$omp end parallel do

    end subroutine pmatrix_mask


    !---------------------------------------------------------------------------


    subroutine pmatrix_pack(pmatrix, mask)
        ! True means: not observed

        type(pointingelement), intent(inout) :: pmatrix(:,:)
        logical(1), intent(in)               :: mask(0:)

        integer*8 :: isample, nsamples
        integer*4 :: table(lbound(mask,1):ubound(mask,1))
        integer*4 :: pixel, ipixel, ipacked, npixels

        ! fill a table which contains the packed indices of the non-masked pixels
        ipacked = 0
        do ipixel=0, size(mask)-1
            if (mask(ipixel)) cycle
            table(ipixel) = ipacked
            ipacked = ipacked + 1
        end do

        npixels  = size(pmatrix, 1)
        nsamples = size(pmatrix, 2)

        !$omp parallel do private(pixel, ipixel)
        do isample = 1, nsamples
            ipixel = 1
            do while (ipixel <= npixels)
                pixel = pmatrix(ipixel,isample)%index
                if (pixel == -1) exit
                if (pmatrix(ipixel,isample)%value == 0 .or. mask(pixel)) then
                    pmatrix(ipixel:npixels-1,isample) = pmatrix(ipixel+1:npixels,isample)
                    pmatrix(npixels,isample)%index = -1
                    pmatrix(npixels,isample)%value = 0
                    cycle
                end if
                pmatrix(ipixel,isample)%index = table(pixel)
                ipixel = ipixel + 1
            end do
        end do
        !$omp end parallel do

    end subroutine pmatrix_pack


    !---------------------------------------------------------------------------


    subroutine backprojection_weight__inner(pmatrix, timeline, mask, map, weight)
        type(pointingelement), intent(in)     :: pmatrix(:,:)
        real(p), intent(in)              :: timeline(:)
        logical(kind=1), intent(in), optional :: mask(:)
        real(p), intent(inout)           :: map(0:)
        real(p), intent(inout)           :: weight(0:)

        integer                               :: npixels, nsamples
        integer                               :: ipixel, isample, imap          
        logical                               :: domask

        npixels  = size(pmatrix, 1)
        nsamples = size(pmatrix, 2)
        domask   = present(mask)

        !$omp parallel do &
#ifdef GFORTRAN
        !$omp reduction(+:map,weight) &
#endif
        !$omp private(isample,ipixel,imap)
        do isample = 1, nsamples
            if (domask) then
                if (mask(isample)) cycle
            end if
            do ipixel = 1, npixels
                imap = pmatrix(ipixel,isample)%index
                if (imap == -1) exit
#ifndef GFORTRAN
                !$omp atomic
#endif
                map   (imap) = map   (imap) + pmatrix(ipixel,isample)%value * timeline(isample)
#ifndef GFORTRAN
                !$omp atomic
#endif
                weight(imap) = weight(imap) + pmatrix(ipixel,isample)%value
            end do
        end do
        !$omp end parallel do

    end subroutine backprojection_weight__inner


end module pointingmatrix

! Copyright 2010-2011 Pierre Chanial
! All rights reserved
!
module module_tamasis

    use iso_fortran_env,  only : OUTPUT_UNIT
    use module_precision, only : sp, dp, qp
    implicit none
    private

    public :: p, POLICY_KEEP, POLICY_MASK, POLICY_REMOVE
    public :: tamasis_dir  ! Tamasis data directory

    character(len=*), parameter :: tamasis_dir = ''
    integer, parameter :: p = dp

    integer, parameter :: POLICY_KEEP   = 0
    integer, parameter :: POLICY_MASK   = 1
    integer, parameter :: POLICY_REMOVE = 2

end module module_tamasis

! Copyright 2010-2011 Pierre Chanial
! All rights reserved
!
module module_sort

    use module_math,    only : NaN, neq_real
    use module_tamasis, only : p
    implicit none
    private

    public :: histogram
    public :: reorder
    public :: qsortgi
    public :: qsorti
    public :: qsortid
    public :: uniq
    public :: where

    integer, pointer   :: module_array_int(:) => null()
    real(p), pointer   :: module_array_double(:) => null()
    logical*1, pointer :: module_mask(:) => null()
    !$omp threadprivate(module_array_int, module_array_double, module_mask)

    interface histogram
        module procedure histogram_nomask_int, histogram_mask_int
    end interface histogram

    interface reorder
        module procedure reorder_nomask_double, reorder_mask_double
    end interface reorder

    interface qsorti
        module procedure qsorti_int, qsorti_nomask_double, qsorti_mask_double
    end interface qsorti

    interface uniq
        module procedure uniq_int, uniq_double
    end interface uniq

    interface where
        module procedure where_1d_1d, where_2d_1d, where_2d_2d, where_3d_3d
    end interface where

contains

! From HDK@psuvm.psu.edu Thu Dec  8 15:27:16 MST 1994
!
! The following was converted from Algol recursive to Fortran iterative
! by a colleague at Penn State (a long time ago - Fortran 66, please
! excuse the GoTo's). The following code also corrects a bug in the
! Quicksort algorithm published in the ACM (see Algorithm 402, CACM,
! Sept. 1970, pp 563-567; also you younger folks who weren't born at
! that time might find interesting the history of the Quicksort
! algorithm beginning with the original published in CACM, July 1961,
! pp 321-322, Algorithm 64). Note that the following algorithm sorts
! integer data; actual data is not moved but sort is affected by sorting
! a companion index array (see leading comments). The data type being
! sorted can be changed by changing one line; see comments after
! declarations and subsequent one regarding comparisons(Fortran
! 77 takes care of character comparisons of course, so that comment
! is merely historical from the days when we had to write character
! compare subprograms, usually in assembler language for a specific
! mainframe platform at that time). But the following algorithm is
! good, still one of the best available.


      SUBROUTINE QSORTID (A, ORD)
      implicit none
      integer :: i
      integer :: ip
      integer :: iq
      integer :: ix
      integer :: iz
      integer :: l
      integer :: l1
      integer :: ndeep
      integer :: p_
      integer :: q
      integer :: u
      integer :: u1
      integer :: yp
!
      real(p), intent(in)  :: A(:)
      integer, intent(out) :: ORD(size(A))
      integer :: POPLST(2,1000)
      integer :: N
      real(p) :: X,XX,Z,ZZ,Y
!
      n = size(A)
!     TO SORT DIFFERENT INPUT TYPES, CHANGE THE FOLLOWING
!     SPECIFICATION STATEMENTS; FOR EXAMPLE, FOR FORTRAN CHARACTER
!     USE THE FOLLOWING:  CHARACTER *(*) A(N)
!
      NDEEP=0
      U1=N
      L1=1
      DO 1  I=1,N
    1 ORD(I)=I
    2 IF (U1.LE.L1) RETURN
!
    3 L=L1
      U=U1
!
! PART
!
    4 P_=L
      Q=U
!     FOR CHARACTER SORTS, THE FOLLOWING 3 STATEMENTS WOULD BECOME
!     X = ORD(P_)
!     Z = ORD(Q)
!     IF (A(X) .LE. A(Z)) GO TO 2
!
!     WHERE "CLE" IS A LOGICAL FUNCTION WHICH RETURNS "TRUE" IF THE
!     FIRST ARGUMENT IS LESS THAN OR EQUAL TO THE SECOND, BASED ON "LEN"
!     CHARACTERS.
!
      X=A(ORD(P_))
      Z=A(ORD(Q))
      IF (X.LE.Z) GO TO 5
      Y=X
      X=Z
      Z=Y
      YP=ORD(P_)
      ORD(P_)=ORD(Q)
      ORD(Q)=YP
    5 IF (U-L.LE.1) GO TO 15
      XX=X
      IX=P_
      ZZ=Z
      IZ=Q
!
! LEFT
!
    6 P_=P_+1
      IF (P_.GE.Q) GO TO 7
      X=A(ORD(P_))
      IF (X.GE.XX) GO TO 8
      GO TO 6
    7 P_=Q-1
      GO TO 13
!
! RIGHT
!
    8 Q=Q-1
      IF (Q.LE.P_) GO TO 9
      Z=A(ORD(Q))
      IF (Z.LE.ZZ) GO TO 10
      GO TO 8
    9 Q=P_
      P_=P_-1
      Z=X
      X=A(ORD(P_))
!
! DIST
!
   10 IF (X.LE.Z) GO TO 11
      Y=X
      X=Z
      Z=Y
      IP=ORD(P_)
      ORD(P_)=ORD(Q)
      ORD(Q)=IP
   11 IF (X.LE.XX) GO TO 12
      XX=X
      IX=P_
   12 IF (Z.GE.ZZ) GO TO 6
      ZZ=Z
      IZ=Q
      GO TO 6
!
! OUT
!
   13 CONTINUE
      IF (.NOT.(P_.NE.IX.AND.X.NE.XX)) GO TO 14
      IP=ORD(P_)
      ORD(P_)=ORD(IX)
      ORD(IX)=IP
   14 CONTINUE
      IF (.NOT.(Q.NE.IZ.AND.Z.NE.ZZ)) GO TO 15
      IQ=ORD(Q)
      ORD(Q)=ORD(IZ)
      ORD(IZ)=IQ
   15 CONTINUE
      IF (U-Q.LE.P_-L) GO TO 16
      L1=L
      U1=P_-1
      L=Q+1
      GO TO 17
   16 U1=U
      L1=Q+1
      U=P_-1
   17 CONTINUE
      IF (U1.LE.L1) GO TO 18
!
! START RECURSIVE CALL
!
      NDEEP=NDEEP+1
      POPLST(1,NDEEP)=U
      POPLST(2,NDEEP)=L
      GO TO 3
   18 IF (U.GT.L) GO TO 4
!
! POP BACK UP IN THE RECURSION LIST
!
      IF (NDEEP.EQ.0) GO TO 2
      U=POPLST(1,NDEEP)
      L=POPLST(2,NDEEP)
      NDEEP=NDEEP-1
      GO TO 18
!
! END SORT
! END QSORT
!
      end subroutine QSORTID

      SUBROUTINE QSORTGI (nitems, compare, ORD)
      implicit none
      integer, intent(in) :: nitems
      integer, intent(out) :: ORD(nitems)
      interface
          integer function compare(first, second)
              integer, intent(in) :: first, second
          end function compare
      end interface

      integer :: i
      integer :: ip
      integer :: iq
      integer :: ix
      integer :: iz
      integer :: l
      integer :: l1
      integer :: ndeep
      integer :: p_
      integer :: q
      integer :: u
      integer :: u1
      integer :: yp
!
      integer :: POPLST(2,1000)
      integer :: X,XX,Z,ZZ,Y
!
!     TO SORT DIFFERENT INPUT TYPES, CHANGE THE FOLLOWING
!     SPECIFICATION STATEMENTS; FOR EXAMPLE, FOR FORTRAN CHARACTER
!     USE THE FOLLOWING:  CHARACTER *(*) A(N)
!
      NDEEP=0
      U1=NITEMS
      L1=1
      DO I=1,NITEMS
          ORD(I)=I
      END DO

    2 IF (U1.LE.L1) RETURN
!
    3 L=L1
      U=U1
!
! PART
!
    4 P_=L
      Q=U
!     FOR CHARACTER SORTS, THE FOLLOWING 3 STATEMENTS WOULD BECOME
!     X = ORD(P_)
!     Z = ORD(Q)
!     IF (A(X) .LE. A(Z)) GO TO 2
!
!     WHERE "CLE" IS A LOGICAL FUNCTION WHICH RETURNS "TRUE" IF THE
!     FIRST ARGUMENT IS LESS THAN OR EQUAL TO THE SECOND, BASED ON "LEN"
!     CHARACTERS.
!
      X=ORD(P_)
      Z=ORD(Q)
      IF (compare(X, Z) >= 0) GO TO 5
      Y = X
      X = Z
      Z = Y
      YP=ORD(P_)
      ORD(P_)=ORD(Q)
      ORD(Q)=YP
    5 IF (U - L <= 1) GO TO 15
      XX=X
      IX=P_
      ZZ=Z
      IZ=Q
!
! LEFT
!
    6 P_=P_+1
      IF (P_.GE.Q) GO TO 7
      X=ORD(P_)
      IF (compare(X, XX) <= 0) GO TO 8
      GO TO 6
    7 P_=Q-1
      GO TO 13
!
! RIGHT
!
    8 Q=Q-1
      IF (Q.LE.P_) GO TO 9
      Z=ORD(Q)
      IF (compare(Z, ZZ) >= 0) GO TO 10
      GO TO 8
    9 Q=P_
      P_=P_-1
      Z=X
      X=ORD(P_)
!
! DIST
!
   10 IF (compare(X, Z) >= 0) GO TO 11
      Y = X
      X = Z
      Z = Y
      IP=ORD(P_)
      ORD(P_)=ORD(Q)
      ORD(Q)=IP
   11 IF (compare(X, XX) >= 0) GO TO 12
      XX=X
      IX=P_
   12 IF (compare(Z, ZZ) <=0) GO TO 6
      ZZ=Z
      IZ=Q
      GO TO 6
!
! OUT
!
   13 CONTINUE
      IF (.NOT.(P_ /= IX .AND. compare(X,XX) /= 0)) GO TO 14
      IP=ORD(P_)
      ORD(P_)=ORD(IX)
      ORD(IX)=IP
   14 CONTINUE
      IF (.NOT.(Q /= IZ .AND. compare(Z,ZZ) /= 0)) GO TO 15
      IQ=ORD(Q)
      ORD(Q)=ORD(IZ)
      ORD(IZ)=IQ
   15 CONTINUE
      IF (U-Q <= P_-L) GO TO 16
      L1=L
      U1=P_-1
      L=Q+1
      GO TO 17
   16 U1=U
      L1=Q+1
      U=P_-1
   17 CONTINUE
      IF (U1 <= L1) GO TO 18
!
! START RECURSIVE CALL
!
      NDEEP=NDEEP+1
      POPLST(1,NDEEP)=U
      POPLST(2,NDEEP)=L
      GO TO 3
   18 IF (U.GT.L) GO TO 4
!
! POP BACK UP IN THE RECURSION LIST
!
      IF (NDEEP.EQ.0) GO TO 2
      U=POPLST(1,NDEEP)
      L=POPLST(2,NDEEP)
      NDEEP=NDEEP-1
      GO TO 18
!
! END SORT
! END QSORT
!
    end subroutine qsortgi


    !-------------------------------------------------------------------------------------------------------------------------------
    ! INTEGER
    !-------------------------------------------------------------------------------------------------------------------------------

    subroutine qsorti_int(array, index)

        integer, intent(in), target :: array(:)
        integer, intent(out) :: index(size(array))

        module_array_int => array
        call qsortgi(size(array), compare_int, index)
        module_array_int => null()

    end subroutine qsorti_int


    !-------------------------------------------------------------------------------------------------------------------------------


    function compare_int(first, second)

        integer, intent(in) :: first, second
        integer             :: compare_int

        if (module_array_int(first) < module_array_int(second)) then
           compare_int = 1
        else if (module_array_int(first) /= module_array_int(second)) then
           compare_int = -1
        else
           compare_int = 0
        end if

    end function compare_int


    !-------------------------------------------------------------------------------------------------------------------------------
    ! DOUBLE
    !-------------------------------------------------------------------------------------------------------------------------------

    subroutine qsorti_nomask_double(array, index)

        real(p), intent(in), target :: array(:)
        integer, intent(out)        :: index(size(array))

        module_array_double => array
        call qsortgi(size(array), compare_nomask_double, index)
        module_array_double => null()

    end subroutine qsorti_nomask_double


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine qsorti_mask_double(array, mask, index)

        real(p), intent(in), target   :: array(:)
        logical*1, intent(in), target :: mask(:)
        integer, intent(out)          :: index(size(array))

        module_array_double => array
        module_mask => mask
        call qsortgi(size(array), compare_mask_double, index)
        module_array_double => null()
        module_mask => null()

    end subroutine qsorti_mask_double


    !-------------------------------------------------------------------------------------------------------------------------------


    function compare_nomask_double(first, second) result (compare)

        integer, intent(in) :: first, second
        integer             :: compare

        if (module_array_double(first) /= module_array_double(first)) then
            if (module_array_double(second) /= module_array_double(second)) then
                compare = 0
            else
                compare = -1
            end if
        else if (module_array_double(second) /= module_array_double(second)) then
            compare = 1
        else if (module_array_double(first) < module_array_double(second)) then
           compare = 1
        else if (module_array_double(first) /= module_array_double(second)) then
           compare = -1
        else
           compare = 0
        end if

    end function compare_nomask_double


    !-------------------------------------------------------------------------------------------------------------------------------


    function compare_mask_double(first, second) result (compare)

        integer, intent(in) :: first, second
        integer             :: compare

        if (module_array_double(first) /= module_array_double(first) .or. module_mask(first)) then
            if (module_array_double(second) /= module_array_double(second) .or. module_mask(second)) then
                compare = 0
            else
                compare = -1
            end if
        else if (module_array_double(second) /= module_array_double(second) .or. module_mask(second)) then
            compare = 1
        else if (module_array_double(first) < module_array_double(second)) then
            compare = 1
        else if (module_array_double(first) /= module_array_double(second)) then
            compare = -1
        else
            compare = 0
        end if

    end function compare_mask_double


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine uniq_int(array, outindex)

        integer, intent(in)  :: array(:)
        integer, intent(out), allocatable :: outindex(:)

        integer :: i, count, n, val
#if defined(GFORTRAN) || defined(IFORT)
        integer, allocatable :: tmp(:)
#endif

        n = size(array)
        if (n == 0) then
            allocate (outindex(0))
            return
        end if

        allocate (outindex(n))
        count = 0
        val = array(1)
        do i = 2, n
            if (array(i) /= val) then
                count = count + 1
                outindex(count) = i-1
                val = array(i)
            end if
        end do
        count = count + 1
        outindex(count) = n

#if defined(GFORTRAN) || defined(IFORT)
        allocate (tmp(count))
        tmp = outindex(1:count)
        call move_alloc(tmp, outindex)
#else
        outindex = outindex(1:count)
#endif

    end subroutine uniq_int


    !-------------------------------------------------------------------------------------------------------------------------------


    ! fixme: algo different from uniq_int...
    subroutine uniq_double(array, inindex, outindex, rtol)

        real(p), intent(in)               :: array(:)
        integer, intent(in)               :: inindex(size(array))
        integer, intent(out), allocatable :: outindex(:)
        real(p), intent(in)               :: rtol

        integer :: index(size(array)), nuniqs, n, i
        real(p) :: val

        n = size(array)
        if (n == 0) then
            allocate (outindex(0))
            return
        end if

        nuniqs = 1
        index(1) = inindex(1)
        val = array(inindex(1))
        do i = 2, n
            if (array(inindex(i)) /= array(inindex(i))) cycle
            if (neq_real(array(inindex(i)), val, rtol)) then
                val = array(inindex(i))
                nuniqs = nuniqs + 1
                index(nuniqs) = inindex(i)
            end if
        end do
        
        allocate (outindex(nuniqs))
        outindex = index(1:nuniqs)

    end subroutine uniq_double


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine reorder_nomask_double(array, index, nuniqs, table, rtol)

        use iso_fortran_env, only : OUTPUT_UNIT
        implicit none

        real(p), intent(in)               :: array(:)
        integer, intent(out)              :: index(size(array))
        integer, intent(out)              :: nuniqs
        real(p), intent(out), allocatable :: table(:)
        real(p), intent(in)               :: rtol

        integer :: isort(size(array)), ndata, i
        real(p) :: val, val2, tmptable(size(array))

        ndata = size(array)
        if (ndata == 0) then
            nuniqs = 0
            allocate (table(0))
            return
        end if

        call qsorti(array, isort)

        nuniqs = 0
        val = NaN
        do i = 1, ndata
            val2 = array(isort(i))
            if (val2 /= val2) then
                index(isort(i)) = huge(index)
                cycle
            end if
            if (neq_real(val, val2, rtol)) then
                val = val2
                nuniqs = nuniqs + 1
                tmptable(nuniqs) = val
            end if
            index(isort(i)) = nuniqs
        end do

        allocate (table(nuniqs))
        table = tmptable(:nuniqs)
        
    end subroutine reorder_nomask_double


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine reorder_mask_double(array, mask, index, nuniqs, table, rtol)

        use iso_fortran_env, only : OUTPUT_UNIT
        implicit none

        real(p), intent(in)               :: array(:)
        logical*1, intent(in)             :: mask(size(array))
        integer, intent(out)              :: index(size(array))
        integer, intent(out)              :: nuniqs
        real(p), intent(out), allocatable :: table(:)
        real(p), intent(in)               :: rtol

        integer :: isort(size(array)), ndata, i
        real(p) :: val, val2, tmptable(size(array))

        ndata = size(array)
        if (ndata == 0) then
            nuniqs = 0
            allocate (table(0))
            return
        end if

        call qsorti(array, mask, isort)

        nuniqs = 0
        val = NaN
        do i = 1, ndata
            val2 = array(isort(i))
            if (val2 /= val2 .or. mask(isort(i))) then
                index(isort(i)) = huge(index)
                cycle
            end if
            if (neq_real(val, val2, rtol)) then
                val = val2
                nuniqs = nuniqs + 1
                tmptable(nuniqs) = val
            end if
            index(isort(i)) = nuniqs
        end do

        allocate (table(nuniqs))
        table = tmptable(:nuniqs)
        
    end subroutine reorder_mask_double


    !-------------------------------------------------------------------------------------------------------------------------------


    function histogram_nomask_int(array, nbins) result(histogram)

        integer, intent(in) :: array(:)
        integer, intent(in) :: nbins
        integer             :: histogram(nbins)

        integer             :: i

        histogram = 0
        do i = 1, size(array)
            if (array(i) == huge(array)) cycle
            histogram(array(i)) = histogram(array(i)) + 1
        end do
        
    end function histogram_nomask_int


    !-------------------------------------------------------------------------------------------------------------------------------


    function histogram_mask_int(array, mask, nbins) result(histogram)

        integer, intent(in)   :: array(:)
        logical*1, intent(in) :: mask(size(array))
        integer, intent(in)   :: nbins
        integer               :: histogram(nbins)

        integer               :: i

        histogram = 0
        do i = 1, size(array)
            if (array(i) == huge(array) .or. mask(i)) cycle
            histogram(array(i)) = histogram(array(i)) + 1
        end do
        
    end function histogram_mask_int


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine where_1d_1d(array, indices, count)
        
        logical, intent(in) :: array(:)
        integer, intent(out), allocatable :: indices(:)
        integer, intent(out), optional :: count

        integer :: indices_(size(array))
        integer :: i, count_

        count_ = 0
        do i = 1, size(array)
            if (array(i)) then
                count_ = count_ + 1
                indices_(count_) = i
            end if
        end do
        
        allocate (indices(count_))
        indices = indices_(1:count_)
        if (present(count)) count = count_
        
    end subroutine where_1d_1d


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine where_2d_1d(mask, indices, n)
        
        logical, intent(in) :: mask(:,:)
        integer, intent(out), allocatable :: indices(:)
        integer, intent(out), optional :: n

        integer :: i

#if defined(GFORTRAN) || defined(IFORT)
        allocate (indices(count(mask)))
#endif
        indices = pack([(i, i=1, size(mask))], reshape(mask,[size(mask)]))
        n = size(indices)
        
    end subroutine where_2d_1d


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine where_2d_2d(array, i1, i2, count)
        
        logical, intent(in) :: array(:,:)
        integer, intent(out), allocatable :: i1(:), i2(:)
        integer, intent(out), optional :: count

        integer :: i1_(size(array)), i2_(size(array))
        integer :: i, j, count_

        count_ = 0
        do j = 1, size(array,2)
            do i = 1, size(array,1)
                if (array(i,j)) then
                    count_ = count_ + 1
                    i1_(count_) = i
                    i2_(count_) = j
                end if
            end do
        end do
        
        allocate (i1(count_))
        allocate (i2(count_))
        i1 = i1_(1:count_)
        i2 = i2_(1:count_)
        if (present(count)) count = count_
        
    end subroutine where_2d_2d


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine where_3d_3d(array, i1, i2, i3, count)
        
        logical, intent(in) :: array(:,:,:)
        integer, intent(out), allocatable :: i1(:), i2(:), i3(:)
        integer, intent(out), optional :: count

        integer :: i1_(size(array)), i2_(size(array)), i3_(size(array))
        integer :: i, j, k, count_

        count_ = 0
        do k = 1, size(array,3)
            do j = 1, size(array,2)
                do i = 1, size(array,1)
                    if (array(i,j,k)) then
                        count_ = count_ + 1
                        i1_(count_) = i
                        i2_(count_) = j
                        i3_(count_) = k
                    end if
                end do
            end do
        end do

        allocate (i1(count_))
        allocate (i2(count_))
        allocate (i3(count_))
        i1 = i1_(1:count_)
        i2 = i2_(1:count_)
        i3 = i3_(1:count_)
        if (present(count)) count = count_
        
    end subroutine where_3d_3d


end module module_sort

! Copyright 2010-2011 Pierre Chanial
! All rights reserved
!
module module_wcs

    use iso_c_binding
    use iso_fortran_env,  only : ERROR_UNIT
    use module_fitstools, only : FLEN_VALUE, ft_read_keyword
    use module_math,      only : DEG2RAD, RAD2DEG, distance, neq_real
    use module_string,    only : strinteger, strlowcase, strupcase
    use module_tamasis,   only : p
    implicit none
    private

    type Astrometry
        integer          :: naxis(2)
        real(p)          :: crpix(2), crval(2), cd(2,2)
        character(len=8) :: ctype(2), cunit(2)
    end type Astrometry

    public :: Astrometry
    public :: init_astrometry
    public :: print_astrometry
    public :: cd_info
    public :: projection_scale
    public :: init_gnomonic
    public :: ad2xy_gnomonic
    public :: ad2xy_gnomonic_vect
    public :: ad2xys_gnomonic
    public :: init_rotation
    public :: xy2xy_rotation
    public :: refpix_area


contains


    subroutine init_astrometry(header, astr, status)

        character(len=*), intent(in)            :: header
        type(Astrometry), intent(out), optional :: astr
        integer, intent(out)                    :: status

        type(Astrometry)          :: myastr
        logical                   :: found
        integer                   :: has_cd
        real(p)                   :: crota2, cdelt1, cdelt2
        character(len=FLEN_VALUE) :: buffer

        has_cd = 0

        call ft_read_keyword(header, 'naxis1', myastr%naxis(1), status=status)
        if (status /= 0) return

        call ft_read_keyword(header, 'naxis2', myastr%naxis(2), status=status)
        if (status /= 0) return

        call ft_read_keyword(header, 'crpix1', myastr%crpix(1), status=status)
        if (status /= 0) return

        call ft_read_keyword(header, 'crpix2', myastr%crpix(2), status=status)
        if (status /= 0) return

        call ft_read_keyword(header, 'crval1', myastr%crval(1), status=status)
        if (status /= 0) return

        call ft_read_keyword(header, 'crval2', myastr%crval(2), status=status)
        if (status /= 0) return

        call ft_read_keyword(header, 'cd1_1', myastr%cd(1,1), found, status)
        if (status /= 0) return
        if (found) has_cd = has_cd + 1

        call ft_read_keyword(header, 'cd2_1', myastr%cd(2,1), found, status)
        if (status /= 0) return
        if (found) has_cd = has_cd + 1

        call ft_read_keyword(header, 'cd1_2', myastr%cd(1,2), found, status)
        if (status /= 0) return
        if (found) has_cd = has_cd + 1

        call ft_read_keyword(header, 'cd2_2', myastr%cd(2,2), found, status)
        if (status /= 0) return
        if (found) has_cd = has_cd + 1

        call ft_read_keyword(header, 'ctype1', buffer, status=status)
        if (status /= 0) return
        myastr%ctype(1) = strupcase(buffer(1:8))

        call ft_read_keyword(header, 'ctype2', buffer, status=status)
        if (status /= 0) return
        myastr%ctype(2) = strupcase(buffer(1:8))

        call ft_read_keyword(header, 'cunit1', buffer, found, status=status)
        if (status /= 0) return
        if (found) then
            myastr%cunit(1) = strlowcase(buffer(1:8))
        else
            myastr%cunit(1) = 'deg'
        end if

        call ft_read_keyword(header, 'cunit2', buffer, found, status=status)
        if (status /= 0) return
        if (found) then
            myastr%cunit(2) = strlowcase(buffer(1:8))
        else
            myastr%cunit(2) = 'deg'
        end if

        if (has_cd /= 0 .and. has_cd /= 4) then
            write (ERROR_UNIT,'(a)') 'Header has incomplete CD matrix.'
            status = 1
            return
        end if

        if (has_cd == 0) then
            call ft_read_keyword(header, 'cdelt1', cdelt1, found, status)
            if (status /= 0) return
            if (.not. found) then
                write (ERROR_UNIT,'(a)') 'Astrometry definition cannot be extracted from header.'
                status = 1
                return
            end if
            call ft_read_keyword(header, 'cdelt2', cdelt2, found, status)
            if (status /= 0) return
            if (.not. found) then
                write (ERROR_UNIT,'(a)') 'Astrometry definition cannot be extracted from header.'
                status = 1
                return
            end if
            call ft_read_keyword(header, 'crota2', crota2, found, status)
            if (status /= 0) return
            if (.not. found) then
                crota2 = 0.
            end if
            
            crota2 = crota2 * DEG2RAD
            myastr%cd(1,1) =  cos(crota2) * cdelt1
            myastr%cd(2,1) = -sin(crota2) * cdelt1
            myastr%cd(1,2) =  sin(crota2) * cdelt2
            myastr%cd(2,2) =  cos(crota2) * cdelt2

        end if

        if (myastr%ctype(1) == 'RA---TAN' .and. myastr%ctype(2) == 'DEC--TAN') then
            call init_gnomonic(myastr)
        else
            write (ERROR_UNIT,'(a)') "Type '" // myastr%ctype(1) // "', '" // myastr%ctype(2) // "' is not implemented."
            status = 1
            return
        end if

        call init_rotation(myastr)

        if (present(astr)) astr = myastr

    end subroutine init_astrometry


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine print_astrometry(astr)

        type(Astrometry), intent(in) :: astr

        integer :: naxis, i

        naxis = 0
        do i=1, size(astr%naxis)
            if (astr%naxis(i) /= 0) naxis = naxis + 1
        end do

        write (*,*) 'NAXIS: ', strinteger(naxis), ' (', strinteger(astr%naxis(1)), ',', strinteger(astr%naxis(2)),')'
        write (*,*) 'CRPIX: ', astr%crpix
        write (*,*) 'CRVAL: ', astr%crval
        write (*,*) 'CD   : ', astr%cd(1,:)
        write (*,*) '       ', astr%cd(2,:)
        write (*,*) 'CUNIT: ', astr%cunit(1), ', ', astr%cunit(2)
        write (*,*) 'CTYPE: ', astr%ctype(1), ', ', astr%ctype(2)

    end subroutine print_astrometry


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine cd_info(cd, cdelt, crota2)

        real(p), intent(in)  :: cd(2,2)
        real(p), intent(out) :: cdelt(2)
        real(p), intent(out) :: crota2
        
        real(p) :: det

        det = cd(1,1) * cd(2,2) - cd(2,1) * cd(1,2)
        cdelt(1) = sign(sqrt(cd(1,1)**2 + cd(1,2)**2), det)
        cdelt(2) = sqrt(cd(2,2)**2 + cd(2,1)**2)
        crota2   = atan2(-cd(2,1),cd(2,2)) * RAD2DEG

    end subroutine cd_info


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine init_gnomonic(astr)

        type(Astrometry), intent(in) :: astr

        real(p) :: lambda0                ! crval(1) in rad
        real(p) :: phi1, cosphi1, sinphi1 ! cos and sin of crval(2)
        common /gnomonic/ lambda0, cosphi1, sinphi1

        lambda0 = astr%crval(1) * DEG2RAD
        phi1 = astr%crval(2) * DEG2RAD
        cosphi1 = cos(phi1)
        sinphi1 = sin(phi1)

    end subroutine init_gnomonic


    !-------------------------------------------------------------------------------------------------------------------------------


    pure function ad2xy_gnomonic(ad) result(xy)

        real(p), intent(in) :: ad(:,:)          ! R.A. and declination in degrees
        real(p)             :: xy(size(ad,1),size(ad,2))

        real(p)             :: lambda, phi, invcosc, xsi, eta
        integer             :: i
        real(p)             :: lambda0          ! crval[0] in rad
        real(p)             :: cosphi1, sinphi1 ! cos and sin of crval[1]
        common /gnomonic/ lambda0, cosphi1, sinphi1

        do i = 1, size(ad,2)
            lambda = ad(1,i) * DEG2RAD
            phi = ad(2,i) * DEG2RAD
            invcosc = RAD2DEG / (sinphi1*sin(phi)+cosphi1*cos(phi)*cos(lambda-lambda0))
            xsi = invcosc * cos(phi)*sin(lambda-lambda0)
            eta = invcosc * (cosphi1*sin(phi)-sinphi1*cos(phi)*cos(lambda-lambda0))

            call xy2xy_rotation(xsi, eta, xy(1,i), xy(2,i))
        end do

    end function ad2xy_gnomonic


    !-------------------------------------------------------------------------------------------------------------------------------


    pure subroutine ad2xys_gnomonic(ad, x, y, scale)

        real(p), intent(in)  :: ad(:,:)          ! R.A. and declination in degrees
        real(p), intent(out) :: x(size(ad,2))
        real(p), intent(out) :: y(size(ad,2))
        real(p), intent(out) :: scale(size(ad,2))

        real(p) :: lambda, phi, invcosc, xsi, eta
        integer :: i
        real(p) :: lambda0          ! crval[0] in rad
        real(p) :: cosphi1, sinphi1 ! cos and sin of crval[1]

        common /gnomonic/ lambda0, cosphi1, sinphi1

        do i = 1, size(ad,2)
            lambda = ad(1,i) * DEG2RAD
            phi = ad(2,i) * DEG2RAD
            invcosc = 1 / (sinphi1*sin(phi)+cosphi1*cos(phi)*cos(lambda-lambda0))
            xsi = RAD2DEG * invcosc * cos(phi)*sin(lambda-lambda0)
            eta = RAD2DEG * invcosc * (cosphi1*sin(phi)-sinphi1*cos(phi)*cos(lambda-lambda0))

            call xy2xy_rotation(xsi, eta, x(i), y(i))
            scale(i) = invcosc ** 3
        end do

    end subroutine ad2xys_gnomonic


    !-------------------------------------------------------------------------------------------------------------------------------


    pure elemental subroutine ad2xy_gnomonic_vect(a, d, x, y)

        real(p), intent(in)  :: a, d             ! R.A. and declination in degrees
        real(p), intent(out) :: x, y

        real(p)              :: lambda, phi, invcosc, xsi, eta
        real(p)              :: lambda0          ! crval[0] in rad
        real(p)              :: cosphi1, sinphi1 ! cos and sin of crval[1]
        common /gnomonic/ lambda0, cosphi1, sinphi1

        lambda  = a * DEG2RAD
        phi     = d * DEG2RAD
        invcosc = RAD2DEG / (sinphi1*sin(phi)+cosphi1*cos(phi)*cos(lambda-lambda0))
        xsi = invcosc * cos(phi)*sin(lambda-lambda0)
        eta = invcosc * (cosphi1*sin(phi)-sinphi1*cos(phi)*cos(lambda-lambda0))

        call xy2xy_rotation(xsi, eta, x, y)

    end subroutine ad2xy_gnomonic_vect


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine projection_scale(astr, array, status)
        
        type(Astrometry), intent(in) :: astr
        real(p), intent(out)         :: array(:,:)
        integer, intent(out)         :: status

        real(p) :: cdelt(2), rot

        call cd_info(astr%cd, cdelt, rot)

        if (astr%ctype(1) == 'RA---TAN' .and. astr%ctype(2) == 'DEC--TAN') then
            if (neq_real(abs(cdelt(1)), abs(cdelt(2)), 1.e-7_p)) then
                write (ERROR_UNIT,'(a)') 'The scaling of a map with inhomogeneous CDELT is not implemented.'
                status = 1
                return
            end if
            call projection_scale_gnomonic(array, astr%crpix, cdelt)
        else
            write (ERROR_UNIT,'(a)') "Scaling for projection type '" // astr%ctype(1) // "', '" // astr%ctype(2) // "' is not imple&
                  &mented."
            status = 1
            return
        end if

        status = 0

    end subroutine projection_scale


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine projection_scale_gnomonic(array, origin, resolution)

        real(p), intent(out) :: array(:,:)
        real(p), intent(in)  :: origin(2)
        real(p), intent(in)  :: resolution(2)

        real(p) :: R

        R = 1 / atan(resolution(1) * DEG2RAD)
        call distance(array, origin, [1/R, 1/R])

        !$omp parallel workshare
        array = cos(atan(array))**3
        !$omp end parallel workshare

    end subroutine projection_scale_gnomonic


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine init_rotation(astr)

        type(Astrometry), intent(in) :: astr

        real(p) :: cdinv(2,2), crpix(2)
        common /rotation/ cdinv, crpix

        cdinv = reshape([astr%cd(2,2), -astr%cd(2,1), -astr%cd(1,2), astr%cd(1,1)], [2,2]) / &
                (astr%cd(1,1)*astr%cd(2,2) - astr%cd(2,1)*astr%cd(1,2))
        crpix = astr%crpix

    end subroutine init_rotation


    !-------------------------------------------------------------------------------------------------------------------------------


    elemental subroutine xy2xy_rotation(xsi, eta, x, y)

        real(p), intent(in)  :: xsi, eta
        real(p), intent(out) :: x, y

        real(p) :: cdinv(2,2), crpix(2)
        common /rotation/ cdinv, crpix

        x = cdinv(1,1)*xsi + cdinv(1,2)*eta + crpix(1)
        y = cdinv(2,1)*xsi + cdinv(2,2)*eta + crpix(2)

    end subroutine xy2xy_rotation



    !-------------------------------------------------------------------------------------------------------------------------------


    function refpix_area()

        real(p) :: refpix_area

        real(p) :: cdinv(2,2), crpix(2)
        common /rotation/ cdinv, crpix
        
        refpix_area = 1 / abs(cdinv(1,1) * cdinv(2,2) - cdinv(1,2) * cdinv(2,1)) * 3600._p**2

    end function refpix_area


 end module module_wcs

module geometry
    use, intrinsic :: iso_fortran_env, only : int64, real64

    use module_tamasis, only : p
    use module_math_old, only : DEG2RAD, RAD2DEG
    implicit none


contains


    subroutine create_grid(m, n, spacing, xreflection, yreflection, angle, xcenter, ycenter, coords)
        !f2py threadsafe
        integer(int64), intent(in)  :: m                ! number of rows
        integer(int64), intent(in)  :: n                ! number of columns
        real(real64), intent(in)    :: spacing          ! size of the detector placeholder
        logical, intent(in)         :: xreflection      ! reflection along the x-axis (before rotation)
        logical, intent(in)         :: yreflection      ! reflection along the y-axis (before rotation)
        real(real64), intent(in)    :: angle            ! counter-clockwise rotation angle in degrees (before translation)
        real(real64), intent(in)    :: xcenter, ycenter ! coordinates of the grid center
        real(real64), intent(inout) :: coords(2,n,m)    ! output coordinates of the detector corners (first dimension is x and y)

        integer(int64) :: i, j
        real(real64)   :: x, y, x0, y0, r11, r12, r21, r22

        r11 = cos(DEG2RAD * angle)
        r21 = sin(DEG2RAD * angle)
        r12 = -r21
        r22 = r11
        if (xreflection) then
            r11 = -r11
            r21 = -r21
        end if
        if (.not. yreflection) then
            r12 = -r12
            r22 = -r22
        end if
        x0 = -0.5_p * (n + 1)
        y0 = -0.5_p * (m + 1)

        !$omp parallel do private(x, y)
        do j = 1, m
            y = (y0 + j) * spacing
            do i = 1, n
                x = (x0 + i) * spacing
                coords(1,i,j) = xcenter + r11 * x + r12 * y
                coords(2,i,j) = ycenter + r21 * x + r22 * y
            end do
        end do
        !$omp end parallel do

    end subroutine create_grid


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine create_grid_squares(m, n, spacing, filling_factor, xreflection, yreflection, angle, xcenter, ycenter, coords)
        !f2py threadsafe
        integer(int64), intent(in)  :: m                ! number of rows
        integer(int64), intent(in)  :: n                ! number of columns
        real(real64), intent(in)    :: spacing          ! size of the detector placeholder
        real(real64), intent(in)    :: filling_factor   ! fraction of transmitting detector area
        logical, intent(in)         :: xreflection      ! reflection along the x-axis (before rotation)
        logical, intent(in)         :: yreflection      ! reflection along the y-axis (before rotation)
        real(real64), intent(in)    :: angle            ! counter-clockwise rotation angle in degrees (before translation)
        real(real64), intent(in)    :: xcenter, ycenter ! coordinates of the grid center
        real(real64), intent(inout) :: coords(2,4,n,m)  ! output coordinates of the detector corners (first dimension is x and y)

        integer(int64) :: i, j, k
        real(real64)   :: x, y, x0, y0, size_eff, r11, r12, r21, r22, tmp

        size_eff = spacing * sqrt(filling_factor)
        r11 = cos(DEG2RAD * angle)
        r21 = sin(DEG2RAD * angle)
        r12 = -r21
        r22 = r11
        if (xreflection) then
            r11 = -r11
            r21 = -r21
        end if
        if (yreflection) then
            r12 = -r12
            r22 = -r22
        end if
        x0 = -0.5_p * ((n + 1) * spacing + size_eff)
        y0 =  0.5_p * ((m + 1) * spacing - size_eff)

        !$omp parallel do private(x, y, tmp)
        do j = 1, m
            y = y0 - spacing * j
            do i = 1, n
                x = x0 + spacing * i
                coords(1,1,i,j) = x + size_eff
                coords(2,1,i,j) = y + size_eff
                coords(1,2,i,j) = x
                coords(2,2,i,j) = y + size_eff
                coords(1,3,i,j) = x
                coords(2,3,i,j) = y
                coords(1,4,i,j) = x + size_eff
                coords(2,4,i,j) = y
                do k = 1, 4
                    tmp = coords(1,k,i,j)
                    coords(1,k,i,j) = xcenter + r11 * tmp + r12 * coords(2,k,i,j)
                    coords(2,k,i,j) = ycenter + r21 * tmp + r22 * coords(2,k,i,j)
                end do
            end do
        end do
        !$omp end parallel do

    end subroutine create_grid_squares


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine rotate_2d(x, y, n, angle)
        !f2py threadsafe
        real(real64), intent(in)    :: x(2,n)
        real(real64), intent(inout) :: y(2,n)
        real(real64), intent(in)    :: angle
        integer(int64), intent(in)  :: n

        integer(int64) :: i
        real(real64)   :: sinangle, cosangle

        sinangle = sin(angle * DEG2RAD)
        cosangle = cos(angle * DEG2RAD)
        !$omp parallel do
        do i = 1, n
            y(1,i) = cosangle * x(1,i) - sinangle * x(2,i)
            y(2,i) = sinangle * x(1,i) + cosangle * x(2,i)
        end do
        !$omp end parallel do

    end subroutine rotate_2d


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine rotate_2d_inplace(x, n, angle)
        !f2py threadsafe
        real(real64), intent(inout) :: x(2,n)
        real(real64), intent(in)    :: angle
        integer(int64), intent(in)  :: n

        integer(int64) :: i
        real(real64)   :: tmp, sinangle, cosangle

        sinangle = sin(angle * DEG2RAD)
        cosangle = cos(angle * DEG2RAD)
        !$omp parallel do private(tmp)
        do i = 1, n
            tmp = x(1,i)
            x(1,i) = cosangle * x(1,i) - sinangle * x(2,i)
            x(2,i) = sinangle * tmp    + cosangle * x(2,i)
        end do
        !$omp end parallel do

    end subroutine rotate_2d_inplace


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine surface_simple_polygon(xy, output, nvertices, npolygons)
        !f2py threadsafe
        integer(int64), intent(in)  :: nvertices, npolygons
        real(real64), intent(in)    :: xy(2, nvertices, npolygons)
        real(real64), intent(inout) :: output(npolygons)
        integer(int64)              :: i, j, k

        !$omp parallel do private(j)
        do k=1, npolygons
            output(k) = 0
            j = nvertices
            do i=1, nvertices
                output(k) = output(k) + xy(1,j,k)*xy(2,i,k) - xy(2,j,k)*xy(1,i,k)
                j = i
            end do
            output(k) = 0.5_p * output(k)
        end do
        !$omp end parallel do

    end subroutine surface_simple_polygon


end module geometry

module operators

    use module_pointingmatrix
    implicit none

    ! <itype=4,4,4,8,8,8>
    ! <mtype=4,4,8,4,4,8>
    ! <vtype=4,8,8,4,8,8>

contains

    subroutine fsr_pT1_i4_m4_v4(matrix, pT1, ncolmax, ninput,&
                                    noutput)
        integer, parameter          :: s = 4 + 4
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*ninput*s)
        type(PointingElement_i4_m4), intent(in) ::                 &
            matrix(ncolmax, ninput)
        real*4, intent(inout) :: pT1(0:noutput-1)
        integer*4 :: col
        integer*8 :: i, j        

        !$omp parallel do private(col)
        do i = 1, ninput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                !$omp atomic update
                pT1(col) = pT1(col) + matrix(j,i)%value
            end do
        end do
        !$omp end parallel do

    end subroutine


    subroutine fsr_pT1_i4_m4_v8(matrix, pT1, ncolmax, ninput,&
                                    noutput)
        integer, parameter          :: s = 4 + 4
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*ninput*s)
        type(PointingElement_i4_m4), intent(in) ::                 &
            matrix(ncolmax, ninput)
        real*8, intent(inout) :: pT1(0:noutput-1)
        integer*4 :: col
        integer*8 :: i, j        

        !$omp parallel do private(col)
        do i = 1, ninput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                !$omp atomic update
                pT1(col) = pT1(col) + matrix(j,i)%value
            end do
        end do
        !$omp end parallel do

    end subroutine


    subroutine fsr_pT1_i4_m8_v8(matrix, pT1, ncolmax, ninput,&
                                    noutput)
        integer, parameter          :: s = 4 + 8
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*ninput*s)
        type(PointingElement_i4_m8), intent(in) ::                 &
            matrix(ncolmax, ninput)
        real*8, intent(inout) :: pT1(0:noutput-1)
        integer*4 :: col
        integer*8 :: i, j        

        !$omp parallel do private(col)
        do i = 1, ninput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                !$omp atomic update
                pT1(col) = pT1(col) + matrix(j,i)%value
            end do
        end do
        !$omp end parallel do

    end subroutine


    subroutine fsr_pT1_i8_m4_v4(matrix, pT1, ncolmax, ninput,&
                                    noutput)
        integer, parameter          :: s = 8 + 4
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*ninput*s)
        type(PointingElement_i8_m4), intent(in) ::                 &
            matrix(ncolmax, ninput)
        real*4, intent(inout) :: pT1(0:noutput-1)
        integer*8 :: col
        integer*8 :: i, j        

        !$omp parallel do private(col)
        do i = 1, ninput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                !$omp atomic update
                pT1(col) = pT1(col) + matrix(j,i)%value
            end do
        end do
        !$omp end parallel do

    end subroutine


    subroutine fsr_pT1_i8_m4_v8(matrix, pT1, ncolmax, ninput,&
                                    noutput)
        integer, parameter          :: s = 8 + 4
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*ninput*s)
        type(PointingElement_i8_m4), intent(in) ::                 &
            matrix(ncolmax, ninput)
        real*8, intent(inout) :: pT1(0:noutput-1)
        integer*8 :: col
        integer*8 :: i, j        

        !$omp parallel do private(col)
        do i = 1, ninput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                !$omp atomic update
                pT1(col) = pT1(col) + matrix(j,i)%value
            end do
        end do
        !$omp end parallel do

    end subroutine


    subroutine fsr_pT1_i8_m8_v8(matrix, pT1, ncolmax, ninput,&
                                    noutput)
        integer, parameter          :: s = 8 + 8
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*ninput*s)
        type(PointingElement_i8_m8), intent(in) ::                 &
            matrix(ncolmax, ninput)
        real*8, intent(inout) :: pT1(0:noutput-1)
        integer*8 :: col
        integer*8 :: i, j        

        !$omp parallel do private(col)
        do i = 1, ninput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                !$omp atomic update
                pT1(col) = pT1(col) + matrix(j,i)%value
            end do
        end do
        !$omp end parallel do

    end subroutine




    subroutine fsr_rot3d_pT1_i4_m4_v4(matrix, pT1, ncolmax,  &
                                          ninput, noutput)
        integer, parameter          :: s = 4 + 3 * 4
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*ninput*s)
        type(PointingElementRot3d_i4_m4), intent(in) ::            &
            matrix(ncolmax, ninput)
        real*4, intent(inout) :: pT1(0:noutput-1)
        integer*4 :: col
        integer*8 :: i, j

        !$omp parallel do private(col)
        do i = 1, ninput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                !$omp atomic update
                pT1(col) = pT1(col) + matrix(j,i)%r11
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_rot3d_pT1_i4_m4_v8(matrix, pT1, ncolmax,  &
                                          ninput, noutput)
        integer, parameter          :: s = 4 + 3 * 4
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*ninput*s)
        type(PointingElementRot3d_i4_m4), intent(in) ::            &
            matrix(ncolmax, ninput)
        real*8, intent(inout) :: pT1(0:noutput-1)
        integer*4 :: col
        integer*8 :: i, j

        !$omp parallel do private(col)
        do i = 1, ninput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                !$omp atomic update
                pT1(col) = pT1(col) + matrix(j,i)%r11
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_rot3d_pT1_i4_m8_v8(matrix, pT1, ncolmax,  &
                                          ninput, noutput)
        integer, parameter          :: s = 4 + 3 * 8
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*ninput*s)
        type(PointingElementRot3d_i4_m8), intent(in) ::            &
            matrix(ncolmax, ninput)
        real*8, intent(inout) :: pT1(0:noutput-1)
        integer*4 :: col
        integer*8 :: i, j

        !$omp parallel do private(col)
        do i = 1, ninput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                !$omp atomic update
                pT1(col) = pT1(col) + matrix(j,i)%r11
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_rot3d_pT1_i8_m4_v4(matrix, pT1, ncolmax,  &
                                          ninput, noutput)
        integer, parameter          :: s = 8 + 3 * 4
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*ninput*s)
        type(PointingElementRot3d_i8_m4), intent(in) ::            &
            matrix(ncolmax, ninput)
        real*4, intent(inout) :: pT1(0:noutput-1)
        integer*8 :: col
        integer*8 :: i, j

        !$omp parallel do private(col)
        do i = 1, ninput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                !$omp atomic update
                pT1(col) = pT1(col) + matrix(j,i)%r11
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_rot3d_pT1_i8_m4_v8(matrix, pT1, ncolmax,  &
                                          ninput, noutput)
        integer, parameter          :: s = 8 + 3 * 4
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*ninput*s)
        type(PointingElementRot3d_i8_m4), intent(in) ::            &
            matrix(ncolmax, ninput)
        real*8, intent(inout) :: pT1(0:noutput-1)
        integer*8 :: col
        integer*8 :: i, j

        !$omp parallel do private(col)
        do i = 1, ninput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                !$omp atomic update
                pT1(col) = pT1(col) + matrix(j,i)%r11
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_rot3d_pT1_i8_m8_v8(matrix, pT1, ncolmax,  &
                                          ninput, noutput)
        integer, parameter          :: s = 8 + 3 * 8
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*ninput*s)
        type(PointingElementRot3d_i8_m8), intent(in) ::            &
            matrix(ncolmax, ninput)
        real*8, intent(inout) :: pT1(0:noutput-1)
        integer*8 :: col
        integer*8 :: i, j

        !$omp parallel do private(col)
        do i = 1, ninput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                !$omp atomic update
                pT1(col) = pT1(col) + matrix(j,i)%r11
            end do
        end do
        !$omp end parallel do

    end subroutine




    subroutine fsr_pTx_pT1_i4_m4_v4(matrix, input, pTx, pT1, &
                                    ncolmax, ninput, noutput)
        integer, parameter          :: s = 4 + 4
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*ninput*s)
        type(PointingElement_i4_m4), intent(in) ::                 &
            matrix(ncolmax, ninput)
        real*4, intent(in)    :: input(ninput)
        real*4, intent(inout) :: pTx(0:noutput-1)
        real*4, intent(inout) :: pT1(0:noutput-1)
        real*4 :: val
        integer*4 :: col
        integer*8 :: i, j        

        !$omp parallel do private(col, val)
        do i = 1, ninput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                val = matrix(j,i)%value
                !$omp atomic update
                pTx(col) = pTx(col) + val * input(i)
                !$omp atomic update
                pT1(col) = pT1(col) + val
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_pTx_pT1_i4_m4_v8(matrix, input, pTx, pT1, &
                                    ncolmax, ninput, noutput)
        integer, parameter          :: s = 4 + 4
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*ninput*s)
        type(PointingElement_i4_m4), intent(in) ::                 &
            matrix(ncolmax, ninput)
        real*8, intent(in)    :: input(ninput)
        real*8, intent(inout) :: pTx(0:noutput-1)
        real*8, intent(inout) :: pT1(0:noutput-1)
        real*4 :: val
        integer*4 :: col
        integer*8 :: i, j        

        !$omp parallel do private(col, val)
        do i = 1, ninput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                val = matrix(j,i)%value
                !$omp atomic update
                pTx(col) = pTx(col) + val * input(i)
                !$omp atomic update
                pT1(col) = pT1(col) + val
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_pTx_pT1_i4_m8_v8(matrix, input, pTx, pT1, &
                                    ncolmax, ninput, noutput)
        integer, parameter          :: s = 4 + 8
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*ninput*s)
        type(PointingElement_i4_m8), intent(in) ::                 &
            matrix(ncolmax, ninput)
        real*8, intent(in)    :: input(ninput)
        real*8, intent(inout) :: pTx(0:noutput-1)
        real*8, intent(inout) :: pT1(0:noutput-1)
        real*8 :: val
        integer*4 :: col
        integer*8 :: i, j        

        !$omp parallel do private(col, val)
        do i = 1, ninput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                val = matrix(j,i)%value
                !$omp atomic update
                pTx(col) = pTx(col) + val * input(i)
                !$omp atomic update
                pT1(col) = pT1(col) + val
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_pTx_pT1_i8_m4_v4(matrix, input, pTx, pT1, &
                                    ncolmax, ninput, noutput)
        integer, parameter          :: s = 8 + 4
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*ninput*s)
        type(PointingElement_i8_m4), intent(in) ::                 &
            matrix(ncolmax, ninput)
        real*4, intent(in)    :: input(ninput)
        real*4, intent(inout) :: pTx(0:noutput-1)
        real*4, intent(inout) :: pT1(0:noutput-1)
        real*4 :: val
        integer*8 :: col
        integer*8 :: i, j        

        !$omp parallel do private(col, val)
        do i = 1, ninput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                val = matrix(j,i)%value
                !$omp atomic update
                pTx(col) = pTx(col) + val * input(i)
                !$omp atomic update
                pT1(col) = pT1(col) + val
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_pTx_pT1_i8_m4_v8(matrix, input, pTx, pT1, &
                                    ncolmax, ninput, noutput)
        integer, parameter          :: s = 8 + 4
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*ninput*s)
        type(PointingElement_i8_m4), intent(in) ::                 &
            matrix(ncolmax, ninput)
        real*8, intent(in)    :: input(ninput)
        real*8, intent(inout) :: pTx(0:noutput-1)
        real*8, intent(inout) :: pT1(0:noutput-1)
        real*4 :: val
        integer*8 :: col
        integer*8 :: i, j        

        !$omp parallel do private(col, val)
        do i = 1, ninput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                val = matrix(j,i)%value
                !$omp atomic update
                pTx(col) = pTx(col) + val * input(i)
                !$omp atomic update
                pT1(col) = pT1(col) + val
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_pTx_pT1_i8_m8_v8(matrix, input, pTx, pT1, &
                                    ncolmax, ninput, noutput)
        integer, parameter          :: s = 8 + 8
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*ninput*s)
        type(PointingElement_i8_m8), intent(in) ::                 &
            matrix(ncolmax, ninput)
        real*8, intent(in)    :: input(ninput)
        real*8, intent(inout) :: pTx(0:noutput-1)
        real*8, intent(inout) :: pT1(0:noutput-1)
        real*8 :: val
        integer*8 :: col
        integer*8 :: i, j        

        !$omp parallel do private(col, val)
        do i = 1, ninput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                val = matrix(j,i)%value
                !$omp atomic update
                pTx(col) = pTx(col) + val * input(i)
                !$omp atomic update
                pT1(col) = pT1(col) + val
            end do
        end do
        !$omp end parallel do

    end subroutine




    subroutine fsr_rot3d_pTx_pT1_i4_m4_v4(matrix, input, pTx,&
                                          pT1, ncolmax, ninput, noutput)
        integer, parameter          :: s = 4 + 3 * 4
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*ninput*s)
        type(PointingElementRot3d_i4_m4), intent(in) ::            &
            matrix(ncolmax, ninput)
        real*4, intent(in)    :: input(ninput)
        real*4, intent(inout) :: pTx(0:noutput-1)
        real*4, intent(inout) :: pT1(0:noutput-1)
        real*4 :: val
        integer*4 :: col
        integer*8 :: i, j

        !$omp parallel do private(col, val)
        do i = 1, ninput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                val = matrix(j,i)%r11
                !$omp atomic update
                pTx(col) = pTx(col) + val * input(i)
                !$omp atomic update
                pT1(col) = pT1(col) + val
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_rot3d_pTx_pT1_i4_m4_v8(matrix, input, pTx,&
                                          pT1, ncolmax, ninput, noutput)
        integer, parameter          :: s = 4 + 3 * 4
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*ninput*s)
        type(PointingElementRot3d_i4_m4), intent(in) ::            &
            matrix(ncolmax, ninput)
        real*8, intent(in)    :: input(ninput)
        real*8, intent(inout) :: pTx(0:noutput-1)
        real*8, intent(inout) :: pT1(0:noutput-1)
        real*4 :: val
        integer*4 :: col
        integer*8 :: i, j

        !$omp parallel do private(col, val)
        do i = 1, ninput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                val = matrix(j,i)%r11
                !$omp atomic update
                pTx(col) = pTx(col) + val * input(i)
                !$omp atomic update
                pT1(col) = pT1(col) + val
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_rot3d_pTx_pT1_i4_m8_v8(matrix, input, pTx,&
                                          pT1, ncolmax, ninput, noutput)
        integer, parameter          :: s = 4 + 3 * 8
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*ninput*s)
        type(PointingElementRot3d_i4_m8), intent(in) ::            &
            matrix(ncolmax, ninput)
        real*8, intent(in)    :: input(ninput)
        real*8, intent(inout) :: pTx(0:noutput-1)
        real*8, intent(inout) :: pT1(0:noutput-1)
        real*8 :: val
        integer*4 :: col
        integer*8 :: i, j

        !$omp parallel do private(col, val)
        do i = 1, ninput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                val = matrix(j,i)%r11
                !$omp atomic update
                pTx(col) = pTx(col) + val * input(i)
                !$omp atomic update
                pT1(col) = pT1(col) + val
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_rot3d_pTx_pT1_i8_m4_v4(matrix, input, pTx,&
                                          pT1, ncolmax, ninput, noutput)
        integer, parameter          :: s = 8 + 3 * 4
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*ninput*s)
        type(PointingElementRot3d_i8_m4), intent(in) ::            &
            matrix(ncolmax, ninput)
        real*4, intent(in)    :: input(ninput)
        real*4, intent(inout) :: pTx(0:noutput-1)
        real*4, intent(inout) :: pT1(0:noutput-1)
        real*4 :: val
        integer*8 :: col
        integer*8 :: i, j

        !$omp parallel do private(col, val)
        do i = 1, ninput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                val = matrix(j,i)%r11
                !$omp atomic update
                pTx(col) = pTx(col) + val * input(i)
                !$omp atomic update
                pT1(col) = pT1(col) + val
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_rot3d_pTx_pT1_i8_m4_v8(matrix, input, pTx,&
                                          pT1, ncolmax, ninput, noutput)
        integer, parameter          :: s = 8 + 3 * 4
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*ninput*s)
        type(PointingElementRot3d_i8_m4), intent(in) ::            &
            matrix(ncolmax, ninput)
        real*8, intent(in)    :: input(ninput)
        real*8, intent(inout) :: pTx(0:noutput-1)
        real*8, intent(inout) :: pT1(0:noutput-1)
        real*4 :: val
        integer*8 :: col
        integer*8 :: i, j

        !$omp parallel do private(col, val)
        do i = 1, ninput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                val = matrix(j,i)%r11
                !$omp atomic update
                pTx(col) = pTx(col) + val * input(i)
                !$omp atomic update
                pT1(col) = pT1(col) + val
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_rot3d_pTx_pT1_i8_m8_v8(matrix, input, pTx,&
                                          pT1, ncolmax, ninput, noutput)
        integer, parameter          :: s = 8 + 3 * 8
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*ninput*s)
        type(PointingElementRot3d_i8_m8), intent(in) ::            &
            matrix(ncolmax, ninput)
        real*8, intent(in)    :: input(ninput)
        real*8, intent(inout) :: pTx(0:noutput-1)
        real*8, intent(inout) :: pT1(0:noutput-1)
        real*8 :: val
        integer*8 :: col
        integer*8 :: i, j

        !$omp parallel do private(col, val)
        do i = 1, ninput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                val = matrix(j,i)%r11
                !$omp atomic update
                pTx(col) = pTx(col) + val * input(i)
                !$omp atomic update
                pT1(col) = pT1(col) + val
            end do
        end do
        !$omp end parallel do

    end subroutine




end module operators

module datautils
    
  use module_tamasis, only : p
  use module_math_old,    only : NaN, distance_1d_ => distance_1d, distance_2d_ => distance_2d, distance_3d_ => distance_3d
  implicit none

contains

  subroutine distance_1d(distance, nx, origin, resolution)

      real(p), intent(out) :: distance(0:nx-1)
      integer, intent(in)  :: nx
      real(p), intent(in)  :: origin
      real(p), intent(in)  :: resolution

      call distance_1d_(distance, origin, resolution)

  end subroutine distance_1d


  !-----------------------------------------------------------------------------


  subroutine distance_2d(distance, nx, ny, origin, resolution)

      real(p), intent(out) :: distance(0:nx-1,0:ny-1)
      integer, intent(in)  :: nx, ny
      real(p), intent(in)  :: origin(2)
      real(p), intent(in)  :: resolution(2)

      call distance_2d_(distance, origin, resolution)

  end subroutine distance_2d


  !-----------------------------------------------------------------------------


  subroutine distance_3d(distance, nx, ny, nz, origin, resolution)

      real(p), intent(out) :: distance(0:nx-1,0:ny-1,0:nz-1)
      integer, intent(in)  :: nx, ny, nz
      real(p), intent(in)  :: origin(3)
      real(p), intent(in)  :: resolution(3)

      call distance_3d_(distance, origin, resolution)

  end subroutine distance_3d


  !-----------------------------------------------------------------------------


  subroutine profile_axisymmetric_2d(array, nx, ny, origin, bin, nbins, x, y, n)

      real*8, intent(in)   :: array(0:nx-1,0:ny-1)
      integer, intent(in)  :: nx, ny
      real*8, intent(in)   :: origin(2)
      real*8, intent(in)   :: bin
      integer, intent(in)  :: nbins
      real*8, intent(out)  :: x(nbins)
      real*8, intent(out)  :: y(nbins)
      integer, intent(out) :: n(nbins)

      integer :: i, j, ibin
      real*8  :: distance, val, tmpj

      x = 0
      y = 0
      n = 0
      !$omp parallel do private(distance, ibin, tmpj, val) reduction(+:x,y,n)
      do j = 0, ny - 1
          tmpj = (j - origin(2))**2
          do i = 0, nx - 1
              val = array(i,j)
              if (val /= val) cycle
              distance = sqrt((i - origin(1))**2 + tmpj)
              ibin = int(distance / bin) + 1
              if (ibin > nbins) cycle
              x(ibin) = x(ibin) + distance
              y(ibin) = y(ibin) + val
              n(ibin) = n(ibin) + 1
          end do
      end do
      !$omp end parallel do

      do i = 1, nbins
          if (n(i) /= 0) then
              x(i) = x(i) / n(i)
              y(i) = y(i) / n(i)
          else
              x(i) = bin * (i - 0.5_p)
              y(i) = NaN
          end if
      end do
 
  end subroutine profile_axisymmetric_2d

end module datautils

! Copyright 2010-2011 Pierre Chanial
! All rights reserved
!
module module_math

    use iso_fortran_env, only : ERROR_UNIT
    use module_tamasis,  only : p

    implicit none
    private

    public :: PI
    public :: DEG2RAD
    public :: RAD2DEG
    public :: mInf
    public :: pInf
    public :: NaN

    public :: distance
    public :: profile
    public :: linspace
    public :: logspace
    public :: mad
    public :: mean
    public :: mean_degrees
    public :: minmax_degrees
    public :: angle_lonlat
    public :: barycenter_lonlat
    public :: median_copy
    public :: median_nocopy
    public :: moment
    public :: nint_down
    public :: nint_up
    public :: sigma_clipping
    public :: stddev
    public :: sum_kahan
    public :: norm_l1
    public :: norm_huber
    public :: norm2
    public :: normp
    public :: dot
    public :: swap
    public :: eq_real
    public :: neq_real
    public :: shift_fast
    public :: shift_medium

    interface distance
        module procedure distance_1d, distance_2d, distance_3d
    end interface

    interface profile
        module procedure profile_axisymmetric_2d
    end interface

    interface sum_kahan
        module procedure sum_kahan_1d, sum_kahan_2d, sum_kahan_3d
    end interface

    real(p), parameter :: PI = 4._p * atan(1._p)
    real(p), parameter :: DEG2RAD = PI / 180._p
    real(p), parameter :: RAD2DEG = 180._p / PI
    !XXX should use ieee_arithmetic instead when gfortran implements it. So far, gfortran doesn't allow NaN, mInf, pInf conversion
    ! between different real kinds...
#if PRECISION_REAL == 4
    real(p), parameter ::                                                                                                          &
        NaN  = transfer('11111111110000000000000000000000'b, 0._p),                                                                &
        mInf = transfer('11111111100000000000000000000000'b, 0._p),                                                                &
        pInf = transfer('01111111100000000000000000000000'b, 0._p)
#elif PRECISION_REAL == 8
    real(p), parameter ::                                                                                                          &
        NaN  = transfer('1111111111111000000000000000000000000000000000000000000000000000'b, 0._p),                                &
        mInf = transfer('1111111111110000000000000000000000000000000000000000000000000000'b, 0._p),                                &
        pInf = transfer('0111111111110000000000000000000000000000000000000000000000000000'b, 0._p)
#elif PRECISION_REAL == 16
    real(16), parameter :: NaN  = 'FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF'z
    real(16), parameter :: mInf = 'FFFF0000000000000000000000000000'z
    real(16), parameter :: pInf = '7FFF0000000000000000000000000000'z
#endif


contains


    subroutine moment(input, mean, variance, skewness, kurtosis, stddev, meandev, mask)

        real(p), intent(in)            :: input(:)
        real(p), intent(out), optional :: mean, variance, skewness
        real(p), intent(out), optional :: kurtosis, stddev, meandev
        logical, intent(in), optional  :: mask(:)

        integer              :: nsamples
        real(p)              :: m, var, sdev
        real(p), allocatable :: residuals(:)

        nsamples = size(input)

        if (present(mask)) then
            if (size(mask) /= nsamples) then
                write (ERROR_UNIT,'(a,2(i0,a))'), 'Error: the mask has an incompatible dimension (', size(mask), ' instead of ',   &
                     size(input), ').'
                stop 1
            end if
            nsamples = nsamples - count(mask)
        end if

        ! compute the mean
        if (nsamples == 0) then
            m = NaN
        else
            m = sum_kahan(input, mask) / nsamples
        end if
        if (present(mean)) mean = m

        if (.not. present(meandev)  .and. .not. present(stddev)   .and.                                                            &
            .not. present(variance) .and. .not. present(skewness) .and.                                                            &
            .not. present(kurtosis)) return

        allocate(residuals(size(input)))
        residuals = input - m

        ! compute mean deviation
        if (present(meandev)) then
            if (nsamples == 0) then
                meandev = NaN
            else
                meandev = sum_kahan(abs(residuals), mask) / nsamples
            end if
        end if

        ! compute variance
        if (nsamples <= 1) then
            var = NaN
        else
            var = sum_kahan(residuals**2, mask) / (nsamples-1)
        end if
        if (present(variance)) variance = var

        ! compute standard deviation
        sdev = sqrt(var)
        if (present(stddev)) stddev = sdev

        ! compute skewness
        if (present(skewness)) then
            if (nsamples == 0 .or. sdev == 0) then
                skewness = NaN
            else
                skewness = sum_kahan(residuals**3, mask) / (nsamples * sdev**3)
            end if
        end if

        ! compute kurtosis
        if (present(kurtosis)) then
            if (nsamples == 0 .or. sdev == 0) then
                kurtosis = NaN
            else
                kurtosis = sum_kahan(residuals**4, mask) / (nsamples * sdev**4) - 3
            end if
        end if

        deallocate(residuals)

    end subroutine moment


    !-------------------------------------------------------------------------------------------------------------------------------


    function mean(input, mask)

        real(p)                      :: mean
        real(p), intent(in)          :: input(:)
        logical, intent(in),optional :: mask(:)

        call moment(input, mean, mask=mask)

    end function mean


    !-------------------------------------------------------------------------------------------------------------------------------


    function stddev(input, mask)

        real(p)                       :: stddev
        real(p), intent(in)           :: input(:)
        logical, intent(in), optional :: mask(:)

        call moment(input, stddev=stddev, mask=mask)

    end function stddev


    !-------------------------------------------------------------------------------------------------------------------------------


    function sum_kahan_1d(input, mask) result (sum)

        real(p), intent(in)           :: input(:)
        logical, intent(in), optional :: mask(:)
        real(p)                       :: sum, c, t, y

        integer                       :: i

        if (size(input) == 0) then
            sum = 0
            return
        end if

        if (present(mask)) then
            if (size(mask) /= size(input)) then
                write (ERROR_UNIT,'(a,2(i0,a))'), 'Error: the mask has an incompatible dimension (', size(mask), ' instead of ',   &
                     size(input), ').'
                stop 1
            end if
            do i = 1, size(input)
                if (.not. mask(i)) exit
            end do
            if (i > size(input)) then
                sum = 0
                return
            end if
        else
            i = 1
        end if

        sum = input(i)
        c = 0
        do i = i+1, size(input)
            if (present(mask)) then
                if (mask(i)) cycle
            end if
            y = input(i) - c
            t = sum + y
            c = (t - sum) - y
            sum = t
        end do

    end function sum_kahan_1d


    !-------------------------------------------------------------------------------------------------------------------------------


    function sum_kahan_2d(input) result (sum)

        real(p), intent(in) :: input(:,:)
        real(p)             :: sum, c, t, y

        integer             :: i

        if (size(input) == 0) then
            sum = 0
            return
        end if

        sum = sum_kahan_1d(input(:,1))
        c = 0
        do i = 2, size(input,2)
            y = sum_kahan_1d(input(:,i)) - c
            t = sum + y
            c = (t - sum) - y
            sum = t
        end do
    end function sum_kahan_2d


    !-------------------------------------------------------------------------------------------------------------------------------


    function sum_kahan_3d(input) result (sum)

        real(p), intent(in) :: input(:,:,:)
        real(p)             :: sum, c, t, y

        integer             :: i

        if (size(input) == 0) then
            sum = 0
            return
        end if

        sum = sum_kahan_2d(input(:,:,1))
        c = 0
        do i = 2, size(input,3)
            y = sum_kahan_2d(input(:,:,i)) - c
            t = sum + y
            c = (t - sum) - y
            sum = t
        end do
    end function sum_kahan_3d


    !-------------------------------------------------------------------------------------------------------------------------------


    function norm_l1(input) result (sum)

        real(p), intent(in) :: input(:)
        real(p)             :: sum

        real(p) :: c, t, y
        integer :: i

        if (size(input) == 0) then
            sum = 0
            return
        end if

        sum = abs(input(1))
        c = 0
        do i = 2, size(input)
            y = abs(input(i)) - c
            t = sum + y
            c = (t - sum) - y
            sum = t
        end do

    end function norm_l1


    !-------------------------------------------------------------------------------------------------------------------------------


    function norm_huber(input, delta) result (sum)

        real(p), intent(in) :: input(:)
        real(p), intent(in) :: delta
        real(p)             :: sum

        real(p) :: c, t, y, a, b
        integer :: i

        if (size(input) == 0) then
            sum = 0
            return
        end if

        a = 2 * delta
        b = -delta**2

        if (abs(input(1)) < delta) then
            sum = input(1) ** 2
        else
            sum = a * abs(input(1)) + b
        end if

        c = 0
        do i = 2, size(input)
            if (abs(input(i)) < delta) then
                y = input(i) ** 2 - c
            else
                y = a * abs(input(i)) + b - c
            end if
            t = sum + y
            c = (t - sum) - y
            sum = t
        end do

    end function norm_huber


    !-------------------------------------------------------------------------------------------------------------------------------


    function norm2(input) result (sum)

        real(p), intent(in) :: input(:)
        real(p)             :: sum

        real(p) :: c, t, y
        integer :: i

        if (size(input) == 0) then
            sum = 0
            return
        end if

        sum = input(1)*input(1)
        c = 0
        do i = 2, size(input)
            y = input(i)*input(i) - c
            t = sum + y
            c = (t - sum) - y
            sum = t
        end do

    end function norm2


    !-------------------------------------------------------------------------------------------------------------------------------


    function normp(input, lp) result (sum)

        real(p), intent(in) :: input(:)
        real(p), intent(in) :: lp
        real(p)             :: sum

        real(p) :: c, t, y
        integer :: i

        if (size(input) == 0) then
            sum = 0
            return
        end if

        sum = abs(input(1))**lp
        c = 0
        do i = 2, size(input)
            y = abs(input(i))**lp - c
            t = sum + y
            c = (t - sum) - y
            sum = t
        end do

    end function normp


    !-------------------------------------------------------------------------------------------------------------------------------


    function dot(input1, input2) result (sum)

        real(p), intent(in) :: input1(:)
        real(p), intent(in) :: input2(:)
        real(p)             :: sum

        real(p) :: c, t, y
        integer :: i

        if (size(input1) == 0) then
            sum = 0
            return
        end if

        sum = input1(1)*input2(1)
        c = 0
        do i = 2, size(input1)
            y = input1(i)*input2(i) - c
            t = sum + y
            c = (t - sum) - y
            sum = t
        end do

    end function dot


    !-------------------------------------------------------------------------------------------------------------------------------


    function mean_degrees(array, mask)

        real(p), intent(in)           :: array(:)
        logical, optional, intent(in) :: mask(:)
        real(p)                       :: mean_degrees

        real(p) :: value
        integer :: isample, n180, nvalids
        logical :: zero_minus, zero_plus

        mean_degrees = 0
        zero_minus = .false.
        zero_plus  = .false.
        n180 = 0
        nvalids = 0

        !$omp parallel do default(shared) reduction(+:n180, nvalids,mean_degrees)           &
        !$omp reduction(.or.:zero_minus,zero_plus) private(isample, value)
        do isample=1, size(array)
            if (present(mask)) then
                if (mask(isample)) cycle
            end if
            value = modulo(array(isample), 360._p)
            if (value /= value) cycle
            zero_minus = zero_minus .or. value > 270._p
            zero_plus  = zero_plus  .or. value <= 90._p
            if (value >= 180._p) n180 = n180 + 1
            mean_degrees = mean_degrees + value
            nvalids = nvalids + 1
        end do
        !$omp end parallel do

        if (zero_minus .and. zero_plus) mean_degrees = mean_degrees - 360._p * n180

        if (nvalids > 0) then
            mean_degrees = modulo(mean_degrees / nvalids, 360._p)
        else
            mean_degrees = NaN
        end if

    end function mean_degrees


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine minmax_degrees(array, minv, maxv)

        real(p), intent(in)  :: array(:)
        real(p), intent(out) :: minv, maxv

        real(p) :: value, meanv
        integer :: isample

        meanv = mean_degrees(array)
        if (meanv /= meanv) then
            minv = NaN
            maxv = NaN
            return
        end if

        minv = pInf
        maxv = mInf
        !$omp parallel do default(shared) reduction(min:minv) reduction(max:maxv) private(value)
        do isample=1, size(array)
            value = array(isample)
            if (value /= value) cycle
            value = modulo(value, 360._p)
            if (value > meanv) then
                if (abs(value-360._p-meanv) < abs(value-meanv)) value = value - 360._p
            else
                if (abs(value+360._p-meanv) < abs(value-meanv)) value = value + 360._p
            end if
            minv = min(minv, value)
            maxv = max(maxv, value)
        end do
        !$omp end parallel do

        minv = modulo(minv, 360._p)
        maxv = modulo(maxv, 360._p)

    end subroutine minmax_degrees


    !-------------------------------------------------------------------------------------------------------------------------------


    pure elemental subroutine angle_lonlat(lon1, lat1, lon2, lat2, angle)

        real(p), intent(in)  :: lon1, lat1, lon2, lat2
        real(p), intent(out) :: angle
        
        angle = acos(cos(lat1*DEG2RAD) * cos(lat2*DEG2RAD) * cos((lon2 - lon1)*DEG2RAD) + sin(lat1*DEG2RAD) * sin(lat2*DEG2RAD)) * &
                RAD2DEG

    end subroutine angle_lonlat


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine barycenter_lonlat(lon, lat, lon0, lat0)

        real(p), intent(in)  :: lon(:), lat(:)
        real(p), intent(out) :: lon0, lat0

        real(p) :: x, y, z, phi, cotheta, cocotheta
        integer :: i

        if (size(lon) == 0) then
            lon0 = NaN
            lat0 = NaN
            return
        end if

        x = 0
        y = 0
        z = 0
        !$omp parallel do reduction(+:x,y,z) private(phi,cotheta,cocotheta)
        do i = 1, size(lon)
            phi = lon(i) * DEG2RAD
            cotheta = lat(i) * DEG2RAD
            if (cotheta /= cotheta .or. phi /= phi) cycle
            cocotheta = cos(cotheta)
            x = x + cocotheta * cos(phi)
            y = y + cocotheta * sin(phi)
            z = z + sin(cotheta)
        end do
        !$omp end parallel do
        
        lon0 = modulo(atan2(y,x) * RAD2DEG + 360._p, 360._p)
        lat0 = acos(sqrt((x**2 + y**2)/(x**2 + y**2 + z**2))) * RAD2DEG
        lat0 = sign(lat0, z)
        
    end subroutine barycenter_lonlat


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine distance_1d(distance, origin, resolution)

        real(p), intent(out) :: distance(:)
        real(p), intent(in)  :: origin
        real(p), intent(in)  :: resolution

        integer :: i
        real(p) :: resolution_

        resolution_ = abs(resolution)

        !$omp parallel do
        do i = 1, size(distance,1)
            distance(i) = resolution_ * abs(i - origin)
        end do
        !$omp end parallel do

    end subroutine distance_1d


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine distance_2d(distance, origin, resolution)

        real(p), intent(out) :: distance(:,:)
        real(p), intent(in)  :: origin(2)
        real(p), intent(in)  :: resolution(2)

        integer :: i, j
        real(p) :: tmpj

        !$omp parallel do private(tmpj)
        do j = 1, size(distance,2)
            tmpj = (resolution(2) * (j - origin(2)))**2
            do i = 1, size(distance,1)
                distance(i,j) = sqrt((resolution(1) * (i - origin(1)))**2 + tmpj)
            end do
        end do
        !$omp end parallel do

    end subroutine distance_2d


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine distance_3d(distance, origin, resolution)

        real(p), intent(out) :: distance(:,:,:)
        real(p), intent(in)  :: origin(3)
        real(p), intent(in)  :: resolution(3)

        integer :: i, j, k
        real(p) :: tmpj, tmpk

        !$omp parallel do private(tmpj, tmpk)
        do k = 1, size(distance,3)
            tmpk = (resolution(3) * (k - origin(3)))**2
            do j = 1, size(distance,2)
                tmpj = (resolution(2) * (j - origin(2)))**2
                do i = 1, size(distance,1)
                    distance(i,j,k) = sqrt((resolution(1) * (i - origin(1)))**2 + tmpj + tmpk)
                end do
            end do
        end do
        !$omp end parallel do

    end subroutine distance_3d


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine profile_axisymmetric_2d(array, origin, bin, nbins, x, y, n)

        real(p), intent(in)  :: array(:,:)
        real(p), intent(in)  :: origin(2)
        real(p), intent(in)  :: bin
        integer, intent(in)  :: nbins
        real(p), intent(out) :: x(nbins)
        real(p), intent(out) :: y(nbins)
        integer, intent(out) :: n(nbins)

        integer :: i, j, ibin
        real(p) :: distance, value, tmpj

        x = 0
        y = 0
        n = 0
        !$omp parallel do private(distance, ibin, tmpj, value) reduction(+:x,y,n)
        do j = 1, size(array,2)
            tmpj = (j - origin(2))**2
            do i = 1, size(array,1)
                value = array(i,j)
                if (value /= value) cycle
                distance = sqrt((i - origin(1))**2 + tmpj)
                ibin = int(distance / bin) + 1
                if (ibin > nbins) cycle
                x(ibin) = x(ibin) + distance
                y(ibin) = y(ibin) + value
                n(ibin) = n(ibin) + 1
            end do
        end do
        !$omp end parallel do

        do i = 1, nbins
            if (n(i) /= 0) then
                x(i) = x(i) / n(i)
                y(i) = y(i) / n(i)
            else
                x(i) = bin * (i - 0.5_p)
                y(i) = NaN
            end if
        end do

    end subroutine profile_axisymmetric_2d


    !-------------------------------------------------------------------------------------------------------------------------------


    function linspace(min, max, n)

        real(p)             :: linspace(n)
        real(p), intent(in) :: min, max
        integer, intent(in) :: n

        integer             :: i

        linspace = min + (max - min) / (n-1) * [(i, i=0, n-1)]

    end function linspace


    !-------------------------------------------------------------------------------------------------------------------------------


    function logspace(min, max, n)
        real(p)             :: logspace(n)
        real(p), intent(in) :: min, max
        integer, intent(in) :: n
        integer             :: i

        logspace = exp(log(min)+(log(max)-log(min)) / (n-1) * [(i, i=0,n-1)])

    end function logspace


    !-------------------------------------------------------------------------------------------------------------------------------


    elemental function nint_down(x)

        integer             :: nint_down
        real(p), intent(in) :: x

        nint_down = nint(x)
        if (x > 0 .and. abs(x-nint_down) == 0.5_p) then
            nint_down = nint_down - 1
        end if

    end function nint_down


    !-------------------------------------------------------------------------------------------------------------------------------


    elemental function nint_up(x)

        integer             :: nint_up
        real(p), intent(in) :: x

        nint_up = nint(x)
        if (x < 0 .and. abs(x-nint_up) == 0.5_p) then
            nint_up = nint_up + 1
        end if

    end function nint_up


    !-------------------------------------------------------------------------------------------------------------------------------


    elemental subroutine swap(a,b)

        real(p), intent(inout) :: a, b

        real(p)                :: tmp

        tmp = a
        a   = b
        b   = tmp

    end subroutine swap


    !-------------------------------------------------------------------------------------------------------------------------------


    function median_copy(array, remove_nan, mask) result (median) 

        real(p)             :: median
        real(p), intent(in) :: array(:)
        logical, intent(in) :: remove_nan
        logical*1, intent(in), optional :: mask(size(array))

        real(p), allocatable :: array_copy(:)

#ifdef IFORT
        if (remove_nan .and. present(mask)) then
            allocate (array_copy(count(array == array .and. .not. mask)))
        else if (present(mask)) then
            allocate (array_copy(count(.not. mask)))
        else if (remove_nan) then
            allocate (array_copy(count(array == array)))
        end if
#endif
        if (remove_nan .and. present(mask)) then
            array_copy = pack(array, array == array .and. .not. mask)
        else if (present(mask)) then
            array_copy = pack(array, .not. mask)
        else if (remove_nan) then
            array_copy = pack(array, array == array)
        else
            allocate (array_copy(size(array)))
            array_copy = array
        end if

        median = median_nocopy(array_copy, .false.)

    end function median_copy


    !-------------------------------------------------------------------------------------------------------------------------------


    ! This Quickselect routine is based on the algorithm described in
    ! "Numerical recipes in C", Second Edition,
    ! Cambridge University Press, 1992, Section 8.5, ISBN 0-521-43108-5
    ! input array may be reordered
    ! This code by Nicolas Devillard - 1998. Public domain.
    function median_nocopy(arr, remove_nan, mask) result (median)

        real(p)                :: median
        real(p), intent(inout) :: arr(0:)
        logical, intent(in)    :: remove_nan
        logical*1, intent(inout), optional :: mask(0:size(arr)-1)

        integer :: low, high, imedian, middle, ll, hh

        low = 0
        high = size(arr)-1

        if (remove_nan .or. present(mask)) then
            ! remove NaN or masked elements from input array
            ll = 0
            do
                if (ll > high) exit
                if (remove_nan .and. arr(ll) /= arr(ll)) go to 99
                if (present(mask)) then
                    if (mask(ll)) go to 99
                end if
                ! element is ok, let's check the next one
                ll = ll + 1
                cycle
                ! we remove the element by copying the last one into it
99              arr(ll) = arr(high)
                if (present(mask)) then
                    mask(ll) = mask(high)
                end if
                high = high - 1
            end do
        end if

        if (high < 0) then
            median = NaN
            return
        end if

        imedian = (low + high) / 2
        do
            if (high <= low) then
                median = arr(imedian)
                return
            end if

            if (high == low + 1) then  ! Two elements only
                if (arr(low) > arr(high)) call swap(arr(low), arr(high))
                median = arr(imedian)
                return
            end if

            ! Find imedian of low, middle and high items swap into position low
            middle = (low + high) / 2
            if (arr(middle) > arr(high)) call swap(arr(middle), arr(high))
            if (arr(low)    > arr(high)) call swap(arr(low),    arr(high))
            if (arr(middle) > arr(low))  call swap(arr(middle), arr(low))

            ! Swap low item (now in position middle) into position (low+1)
            call swap(arr(middle), arr(low+1)) 

            ! Nibble from each end towards middle, swapping items when stuck
            ll = low + 1
            hh = high
            do
                do 
                    ll = ll + 1
                    if (arr(low) <= arr(ll)) exit
                end do

                do 
                    hh = hh - 1
                    if (arr(hh)  <= arr(low)) exit
                end do

                if (hh < ll) exit

                call swap(arr(ll), arr(hh)) 

            end do

            ! Swap middle item (in position low) back into correct position
            call swap(arr(low), arr(hh)) 

            ! Re-set active partition
            if (hh <= imedian) low = ll
            if (hh >= imedian) high = hh - 1

        end do

    end function median_nocopy


    !-------------------------------------------------------------------------------------------------------------------------------


    ! returns the median absolute deviation
    function mad(x, m)

        real(p)                        :: mad
        real(p), intent(in)            :: x(:)
        real(p), intent(out), optional :: m

        real(p)                        :: x_(size(x)), med

        x_ = x
        med = median_nocopy(x_, .true.)
        x_ = abs(x_ - med)
        mad = median_nocopy(x_, .true.)

        if (present(m)) m = med

    end function mad


    !-------------------------------------------------------------------------------------------------------------------------------


    ! sigma clip an input vector. In the output mask, .true. means rejected
    subroutine sigma_clipping(input, mask, nsigma, nitermax)

        real(p), intent(in)           :: input(:)
        logical, intent(out)          :: mask(size(input))
        real(p), intent(in)           :: nsigma
        integer, intent(in), optional :: nitermax

        integer :: iter, nitermax_
        real(p) :: mean, stddev
        logical :: newmask(size(input))

        if (present(nitermax)) then
            nitermax_ = nitermax
        else
            nitermax_ = 0
        end if

        mask = .false.
        iter = 1
        do

            call moment(input, mean, stddev=stddev, mask=mask)
            newmask = mask .or. abs(input - mean) > nsigma * stddev
            if (count(newmask) == count(mask)) exit
            mask = newmask
            if (iter == nitermax_) exit

        end do

    end subroutine sigma_clipping


    !-------------------------------------------------------------------------------------------------------------------------------


    elemental function eq_real(a, b, rtol)

        logical                       :: eq_real
        real(p), intent(in)           :: a, b
        real(p), intent(in), optional :: rtol

        real(p) :: rtol_

        ! check for NaN values
        if (a /= a) then
            eq_real = b /= b
            return
        end if
        if (b /= b) then
            eq_real = .false.
            return
        end if

        if (present(rtol)) then
            rtol_ = rtol
        else
            rtol_ = 10._p * epsilon(1._p)
        end if

        eq_real = abs(a-b) <= rtol_ * max(abs(a),abs(b))

    end function eq_real


    !-------------------------------------------------------------------------------------------------------------------------------


    elemental function neq_real(a, b, rtol)

        logical                       :: neq_real
        real(p), intent(in)           :: a, b
        real(p), intent(in), optional :: rtol

        neq_real = .not. eq_real(a, b, rtol)

    end function neq_real


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine shift_fast(input, output, m, n, offset)

        integer*8, intent(in)  :: m, n
        real(p), intent(in)    :: input(m,n)
        real(p), intent(inout) :: output(m,n)
        integer*8, intent(in)  :: offset(:)

        integer*8 :: i, j, d

        !$omp parallel do private(i,j,d)
        do j = 1, n
            d = offset((j-1) / (n / size(offset)) + 1)
            if (d == 0) then
                output(:,j) = input(:,j)
                cycle
            end if
            if (d > 0) then
                do i = m, d+1, -1
                    output(i,j) = input(i-d,j)
                end do
                output(1:min(d,m),j) = 0
            else
                do i = 1, m+d
                    output(i,j) = input(i-d,j)
                end do
                output(max(m+d+1,1):m,j) = 0             
            end if
        end do
        !$omp end parallel do

    end subroutine shift_fast


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine shift_medium(input, output, m, n, o, offset)

        integer*8, intent(in)  :: m, n, o
        real(p), intent(in)    :: input(m,n,o)
        real(p), intent(inout) :: output(m,n,o)
        integer*8, intent(in)  :: offset(:)

        integer*8 :: j, k, d

        !$omp parallel do private(d)
        do k = 1, o
            d = offset((k-1) / (o / size(offset)) + 1)
            if (d == 0)  then
                output(:,:,k) = input(:,:,k)
                cycle
            end if
            if (d > 0) then
                do j = n, d+1, -1
                    output(:,j,k) = input(:,j-d,k)
                end do
                output(:,1:min(d,n),k) = 0
            else
                do j = 1, n+d
                    output(:,j,k) = input(:,j-d,k)
                end do
                output(:,max(n+d+1,1):n,k) = 0             
            end if
        end do
        !$omp end parallel do

    end subroutine shift_medium


end module module_math

module datautils
    
  use module_tamasis, only : p
  use module_math,    only : NaN
  implicit none

contains

  subroutine distance_1d(distance, nx, origin, resolution)

      integer, intent(in)  :: nx
      real(p), intent(out) :: distance(nx)
      real(p), intent(in)  :: origin
      real(p), intent(in)  :: resolution

      integer :: i
      real(p) :: resolution_

      resolution_ = abs(resolution)

      !$omp parallel do
      do i = 1, size(distance,1)
          distance(i) = resolution_ * abs(i - origin)
      end do
      !$omp end parallel do

  end subroutine distance_1d


  !-----------------------------------------------------------------------------


  subroutine distance_2d(distance, nx, ny, origin, resolution)

      integer, intent(in)  :: nx, ny
      real(p), intent(out) :: distance(nx,ny)
      real(p), intent(in)  :: origin(2)
      real(p), intent(in)  :: resolution(2)

      integer :: i, j
      real(p) :: tmpj

      !$omp parallel do private(tmpj)
      do j = 1, size(distance,2)
          tmpj = (resolution(2) * (j - origin(2)))**2
          do i = 1, size(distance,1)
              distance(i,j) = sqrt((resolution(1) * (i - origin(1)))**2 + tmpj)
          end do
      end do
      !$omp end parallel do

  end subroutine distance_2d


  !-----------------------------------------------------------------------------


  subroutine distance_3d(distance, nx, ny, nz, origin, resolution)

      integer, intent(in)  :: nx, ny, nz
      real(p), intent(out) :: distance(nx,ny,nz)
      real(p), intent(in)  :: origin(3)
      real(p), intent(in)  :: resolution(3)

      integer :: i, j, k
      real(p) :: tmpj, tmpk

      !$omp parallel do private(tmpj, tmpk)
      do k = 1, size(distance,3)
          tmpk = (resolution(3) * (k - origin(3)))**2
          do j = 1, size(distance,2)
              tmpj = (resolution(2) * (j - origin(2)))**2
              do i = 1, size(distance,1)
                  distance(i,j,k) = sqrt((resolution(1) * (i - origin(1)))**2 + tmpj + tmpk)
              end do
          end do
      end do
      !$omp end parallel do

  end subroutine distance_3d


  !---------------------------------------------------------------------------


  subroutine profile_axisymmetric_2d(array, nx, ny, origin, bin, nbins, x, y, n)

      real*8, intent(in)   :: array(nx,ny)
      integer, intent(in)  :: nx, ny
      real*8, intent(in)   :: origin(2)
      real*8, intent(in)   :: bin
      integer, intent(in)  :: nbins
      real*8, intent(out)  :: x(nbins)
      real*8, intent(out)  :: y(nbins)
      integer, intent(out) :: n(nbins)

      integer :: i, j, ibin
      real*8  :: distance, val, tmpj

      x = 0
      y = 0
      n = 0
      !$omp parallel do private(distance, ibin, tmpj, val) reduction(+:x,y,n)
      do j = 1, ny
          tmpj = (j - origin(2))**2
          do i = 1, nx
              val = array(i,j)
              if (val /= val) cycle
              distance = sqrt((i - origin(1))**2 + tmpj)
              ibin = int(distance / bin) + 1
              if (ibin > nbins) cycle
              x(ibin) = x(ibin) + distance
              y(ibin) = y(ibin) + val
              n(ibin) = n(ibin) + 1
          end do
      end do
      !$omp end parallel do

      do i = 1, nbins
          if (n(i) /= 0) then
              x(i) = x(i) / n(i)
              y(i) = y(i) / n(i)
          else
              x(i) = bin * (i - 0.5_p)
              y(i) = NaN
          end if
      end do
 
  end subroutine profile_axisymmetric_2d

end module datautils

! Copyright 2010-2013 Pierre Chanial
! All rights reserved
!
module module_pointingmatrix

    use module_math_old,  only : NaN, nint_down, nint_up
    use module_geometry,  only : intersection_polygon_unity_square_r8
    use module_precision, only : sp
    use module_tamasis,   only : p
    implicit none
    private

    public :: PointingElement
    public :: PointingElement_i4_r4
    public :: PointingElement_i4_r8
    public :: PointingElement_i8_r4
    public :: PointingElement_i8_r8
    public :: PointingElementBlock_1_2_i4_r4
    public :: PointingElementBlock_1_2_i4_r8
    public :: PointingElementBlock_1_2_i8_r4
    public :: PointingElementBlock_1_2_i8_r8
    public :: PointingElementBlock_1_3_i4_r4
    public :: PointingElementBlock_1_3_i4_r8
    public :: PointingElementBlock_1_3_i8_r4
    public :: PointingElementBlock_1_3_i8_r8
    public :: PointingElementBlock_2_1_i4_r4
    public :: PointingElementBlock_2_1_i4_r8
    public :: PointingElementBlock_2_1_i8_r4
    public :: PointingElementBlock_2_1_i8_r8
    public :: PointingElementBlock_2_2_i4_r4
    public :: PointingElementBlock_2_2_i4_r8
    public :: PointingElementBlock_2_2_i8_r4
    public :: PointingElementBlock_2_2_i8_r8
    public :: PointingElementBlock_2_3_i4_r4
    public :: PointingElementBlock_2_3_i4_r8
    public :: PointingElementBlock_2_3_i8_r4
    public :: PointingElementBlock_2_3_i8_r8
    public :: PointingElementBlock_3_1_i4_r4
    public :: PointingElementBlock_3_1_i4_r8
    public :: PointingElementBlock_3_1_i8_r4
    public :: PointingElementBlock_3_1_i8_r8
    public :: PointingElementBlock_3_2_i4_r4
    public :: PointingElementBlock_3_2_i4_r8
    public :: PointingElementBlock_3_2_i8_r4
    public :: PointingElementBlock_3_2_i8_r8
    public :: PointingElementBlock_3_3_i4_r4
    public :: PointingElementBlock_3_3_i4_r8
    public :: PointingElementBlock_3_3_i8_r4
    public :: PointingElementBlock_3_3_i8_r8
    public :: PointingElementRot2d_i4_r4
    public :: PointingElementRot2d_i4_r8
    public :: PointingElementRot2d_i8_r4
    public :: PointingElementRot2d_i8_r8
    public :: PointingElementRot3d_i4_r4
    public :: PointingElementRot3d_i4_r8
    public :: PointingElementRot3d_i8_r4
    public :: PointingElementRot3d_i8_r8
    public :: pmatrix_direct
    public :: pmatrix_direct_one_pixel_per_sample
    public :: pmatrix_transpose
    public :: pmatrix_transpose_one_pixel_per_sample
    public :: pmatrix_ptp
    public :: pmatrix_mask
    public :: pmatrix_pack
    public :: xy2roi
    public :: xy2pmatrix
    public :: roi2pmatrix_cartesian
    public :: backprojection_weight
    public :: backprojection_weighted_roi

    type PointingElement
        integer*4 :: index
        real(sp)  :: value
    end type PointingElement

    type PointingElement_i4_r4
        integer*4 :: index
        real*4    :: value
    end type

    type PointingElement_i8_r4
        integer*8 :: index
        real*4    :: value
    end type

    type PointingElement_i4_r8
        integer*4 :: index
        real*8    :: value
    end type

    type PointingElement_i8_r8
        integer*8 :: index
        real*8    :: value
    end type

    type PointingElementBlock_1_2_i4_r4
        integer*4 :: index
        real*4    :: value(2,1)
    end type

    type PointingElementBlock_1_2_i8_r4
        integer*8 :: index
        real*4    :: value(2,1)
    end type

    type PointingElementBlock_1_2_i4_r8
        integer*4 :: index
        real*8    :: value(2,1)
    end type

    type PointingElementBlock_1_2_i8_r8
        integer*8 :: index
        real*8    :: value(2,1)
    end type

    type PointingElementBlock_1_3_i4_r4
        integer*4 :: index
        real*4    :: value(3,1)
    end type

    type PointingElementBlock_1_3_i8_r4
        integer*8 :: index
        real*4    :: value(3,1)
    end type

    type PointingElementBlock_1_3_i4_r8
        integer*4 :: index
        real*8    :: value(3,1)
    end type

    type PointingElementBlock_1_3_i8_r8
        integer*8 :: index
        real*8    :: value(3,1)
    end type

    type PointingElementBlock_2_1_i4_r4
        integer*4 :: index
        real*4    :: value(1,2)
    end type

    type PointingElementBlock_2_1_i8_r4
        integer*8 :: index
        real*4    :: value(1,2)
    end type

    type PointingElementBlock_2_1_i4_r8
        integer*4 :: index
        real*8    :: value(1,2)
    end type

    type PointingElementBlock_2_1_i8_r8
        integer*8 :: index
        real*8    :: value(1,2)
    end type

    type PointingElementBlock_2_2_i4_r4
        integer*4 :: index
        real*4    :: value(2,2)
    end type

    type PointingElementBlock_2_2_i8_r4
        integer*8 :: index
        real*4    :: value(2,2)
    end type

    type PointingElementBlock_2_2_i4_r8
        integer*4 :: index
        real*8    :: value(2,2)
    end type

    type PointingElementBlock_2_2_i8_r8
        integer*8 :: index
        real*8    :: value(2,2)
    end type

    type PointingElementBlock_2_3_i4_r4
        integer*4 :: index
        real*4    :: value(3,2)
    end type

    type PointingElementBlock_2_3_i8_r4
        integer*8 :: index
        real*4    :: value(3,2)
    end type

    type PointingElementBlock_2_3_i4_r8
        integer*4 :: index
        real*8    :: value(3,2)
    end type

    type PointingElementBlock_2_3_i8_r8
        integer*8 :: index
        real*8    :: value(3,2)
    end type

    type PointingElementBlock_3_1_i4_r4
        integer*4 :: index
        real*4    :: value(1,3)
    end type

    type PointingElementBlock_3_1_i8_r4
        integer*8 :: index
        real*4    :: value(1,3)
    end type

    type PointingElementBlock_3_1_i4_r8
        integer*4 :: index
        real*8    :: value(1,3)
    end type

    type PointingElementBlock_3_1_i8_r8
        integer*8 :: index
        real*8    :: value(1,3)
    end type

    type PointingElementBlock_3_2_i4_r4
        integer*4 :: index
        real*4    :: value(2,3)
    end type

    type PointingElementBlock_3_2_i8_r4
        integer*8 :: index
        real*4    :: value(2,3)
    end type

    type PointingElementBlock_3_2_i4_r8
        integer*4 :: index
        real*8    :: value(2,3)
    end type

    type PointingElementBlock_3_2_i8_r8
        integer*8 :: index
        real*8    :: value(2,3)
    end type

    type PointingElementBlock_3_3_i4_r4
        integer*4 :: index
        real*4    :: value(3,3)
    end type

    type PointingElementBlock_3_3_i8_r4
        integer*8 :: index
        real*4    :: value(3,3)
    end type

    type PointingElementBlock_3_3_i4_r8
        integer*4 :: index
        real*8    :: value(3,3)
    end type

    type PointingElementBlock_3_3_i8_r8
        integer*8 :: index
        real*8    :: value(3,3)
    end type

    type PointingElementRot2d_i4_r4
        integer*4 :: index
        real*4    :: r11, r21
    end type

    type PointingElementRot2d_i8_r4
        integer*8 :: index
        real*4    :: r11, r21
    end type

    type PointingElementRot2d_i4_r8
        integer*4 :: index
        real*8    :: r11, r21
    end type

    type PointingElementRot2d_i8_r8
        integer*8 :: index
        real*8    :: r11, r21
    end type

    type PointingElementRot3d_i4_r4
        integer*4 :: index
        real*4    :: r11, r22, r32
    end type

    type PointingElementRot3d_i8_r4
        integer*8 :: index
        real*4    :: r11, r22, r32
    end type

    type PointingElementRot3d_i4_r8
        integer*4 :: index
        real*8    :: r11, r22, r32
    end type

    type PointingElementRot3d_i8_r8
        integer*8 :: index
        real*8    :: r11, r22, r32
    end type


contains


    subroutine pmatrix_direct(pmatrix, map, timeline)

        type(pointingelement), intent(in) :: pmatrix(:,:)
        real(p), intent(in)               :: map(0:)
        real(p), intent(inout)            :: timeline(:)
        integer                           :: ipixel, isample, npixels_per_sample, nsamples

        npixels_per_sample = size(pmatrix,1)
        nsamples = size(pmatrix, 2)

        !$omp parallel do
        do isample = 1, nsamples
!!$            timeline(isample) = sum(map(pmatrix(:,isample)%index) * pmatrix(:,isample)%value)
            timeline(isample) = 0
            do ipixel = 1, npixels_per_sample
                if (pmatrix(ipixel,isample)%index == -1) exit
                timeline(isample) = timeline(isample) + map(pmatrix(ipixel,isample)%index) * pmatrix(ipixel,isample)%value
            end do
        end do
        !$omp end parallel do

    end subroutine pmatrix_direct


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine pmatrix_direct_one_pixel_per_sample(pmatrix, map, timeline)

        type(pointingelement), intent(in) :: pmatrix(:)
        real(p), intent(in)               :: map(0:)
        real(p), intent(inout)            :: timeline(:)
        integer                           :: isample, nsamples

        nsamples = size(pmatrix, 1)

        !$omp parallel do
        do isample = 1, nsamples
            if (pmatrix(isample)%index >= 0) then
                timeline(isample) = map(pmatrix(isample)%index) * pmatrix(isample)%value
            end if
        end do
        !$omp end parallel do

    end subroutine pmatrix_direct_one_pixel_per_sample


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine pmatrix_transpose(pmatrix, timeline, map)
        type(pointingelement), intent(in) :: pmatrix(:,:)
        real(kind=p), intent(in)          :: timeline(:)
        real(kind=p), intent(inout)       :: map(0:)
        integer                           :: isample, ipixel, npixels, nsamples

        npixels  = size(pmatrix, 1)
        nsamples = size(pmatrix, 2)

        !$omp parallel do
        do isample = 1, nsamples
            do ipixel = 1, npixels
                if (pmatrix(ipixel,isample)%index == -1) exit
                !$omp atomic
                map(pmatrix(ipixel,isample)%index) = map(pmatrix(ipixel,isample)%index) +                                          &
                    pmatrix(ipixel,isample)%value * timeline(isample)
            end do
        end do
        !$omp end parallel do

    end subroutine pmatrix_transpose


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine pmatrix_transpose_one_pixel_per_sample(pmatrix, timeline, map)
        type(pointingelement), intent(in) :: pmatrix(:)
        real(kind=p), intent(in)          :: timeline(:)
        real(kind=p), intent(inout)       :: map(0:)
        integer                           :: isample, nsamples

        nsamples = size(pmatrix, 1)

        !$omp parallel do
        do isample = 1, nsamples
            if (pmatrix(isample)%index >= 0) then
                !$omp atomic
                map(pmatrix(isample)%index) = map(pmatrix(isample)%index) + pmatrix(isample)%value * timeline(isample)
            end if
        end do
        !$omp end parallel do

    end subroutine pmatrix_transpose_one_pixel_per_sample


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine pmatrix_ptp(pmatrix, ptp)
        type(pointingelement), intent(in) :: pmatrix(:,:)
        real(kind=p), intent(inout)       :: ptp(0:,0:)
        integer                           :: isample
        integer                           :: ipixel, jpixel, i, j
        integer                           :: npixels, nsamples
        real(kind(pmatrix%value))         :: pi, pj

        npixels  = size(pmatrix, 1)
        nsamples = size(pmatrix, 2)

        !$omp parallel do private(isample, ipixel, jpixel, i, j, pi, pj)
        do isample = 1, nsamples
            do ipixel = 1, npixels
                if (pmatrix(ipixel,isample)%index == -1) exit
                i  = pmatrix(ipixel,isample)%index
                pi = pmatrix(ipixel,isample)%value
                do jpixel = 1, npixels
                    if (pmatrix(jpixel,isample)%index == -1) exit
                    j  = pmatrix(jpixel,isample)%index
                    pj = pmatrix(jpixel,isample)%value
                    !$omp atomic
                    ptp(i,j) = ptp(i,j) + pi * pj
                end do
            end do
        end do
        !$omp end parallel do

    end subroutine pmatrix_ptp


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine pmatrix_mask(pmatrix, mask)
        ! True means: not observed
        type(pointingelement), intent(in) :: pmatrix(:,:)
        logical(1), intent(inout)         :: mask(0:)

        integer*8 :: isample, ipixel, npixels, nsamples
        integer*4 :: pixel

        npixels  = size(pmatrix, 1)
        nsamples = size(pmatrix, 2)

        !$omp parallel do private(pixel)
        do isample = 1, nsamples
            do ipixel = 1, npixels
                pixel = pmatrix(ipixel,isample)%index
                if (pixel == -1) exit
                if (pmatrix(ipixel,isample)%value == 0) cycle
                mask(pixel) = .false.
            end do
        end do
        !$omp end parallel do

    end subroutine pmatrix_mask


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine pmatrix_pack(pmatrix, mask)
        ! True means: not observed

        type(pointingelement), intent(inout) :: pmatrix(:,:)
        logical(1), intent(in)               :: mask(0:)

        integer*8 :: isample, nsamples
        integer*4 :: table(lbound(mask,1):ubound(mask,1))
        integer*4 :: pixel, ipixel, ipacked, npixels

        ! fill a table which contains the packed indices of the non-masked pixels
        ipacked = 0
        do ipixel=0, size(mask)-1
            if (mask(ipixel)) cycle
            table(ipixel) = ipacked
            ipacked = ipacked + 1
        end do

        npixels  = size(pmatrix, 1)
        nsamples = size(pmatrix, 2)

        !$omp parallel do private(pixel, ipixel)
        do isample = 1, nsamples
            ipixel = 1
            do while (ipixel <= npixels)
                pixel = pmatrix(ipixel,isample)%index
                if (pixel == -1) exit
                if (pmatrix(ipixel,isample)%value == 0 .or. mask(pixel)) then
                    pmatrix(ipixel:npixels-1,isample) = pmatrix(ipixel+1:npixels,isample)
                    pmatrix(npixels,isample)%index = -1
                    pmatrix(npixels,isample)%value = 0
                    cycle
                end if
                pmatrix(ipixel,isample)%index = table(pixel)
                ipixel = ipixel + 1
            end do
        end do
        !$omp end parallel do

    end subroutine pmatrix_pack


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine backprojection_weight(pmatrix, timeline, mask, map, weight)
        type(PointingElement), intent(in)     :: pmatrix(:,:)
        real(kind=p), intent(in)              :: timeline(:)
        logical(kind=1), intent(in), optional :: mask(:)
        real(kind=p), intent(inout)           :: map(0:)
        real(kind=p), intent(inout)           :: weight(0:)

        integer                               :: npixels, nsamples
        integer                               :: ipixel, isample, imap
        logical                               :: domask

        npixels  = size(pmatrix, 1)
        nsamples = size(pmatrix, 2)
        domask   = present(mask)

        !$omp parallel do private(isample,ipixel,imap)
        do isample = 1, nsamples
            if (domask) then
                if (mask(isample)) cycle
            end if
            do ipixel = 1, npixels
                imap = pmatrix(ipixel,isample)%index
                if (imap == -1) exit
                !$omp atomic
                map(imap) = map(imap) + pmatrix(ipixel,isample)%value * timeline(isample)
                !$omp atomic
                weight(imap) = weight(imap) + pmatrix(ipixel,isample)%value
            end do
        end do
        !$omp end parallel do

    end subroutine backprojection_weight


    !-------------------------------------------------------------------------------------------------------------------------------


    ! backproject a frame into a minimap
    subroutine backprojection_weighted_roi(pmatrix, nx, timeline, mask, itime, map, roi)

        type(pointingelement), intent(in) :: pmatrix(:,:,:)
        integer, intent(in)               :: nx
        real(p), intent(in)               :: timeline(:,:)
        logical(kind=1), intent(in)       :: mask(:,:)
        integer, intent(in)               :: itime
        real(p), intent(out)              :: map(0:)
        integer, intent(out)              :: roi(2,2)

        real(sp) :: weight(0:ubound(map,1))
        integer  :: nxmap, xmap, ymap, imap
        integer  :: ndetectors, npixels_per_sample, idetector, ipixel

        npixels_per_sample = size(pmatrix,1)
        ndetectors = size(pmatrix,3)

        roi(1,1) = minval(modulo(pmatrix(:,itime,:)%index,nx), pmatrix(:,itime,:)%index /= -1) ! xmin
        roi(1,2) = maxval(modulo(pmatrix(:,itime,:)%index,nx), pmatrix(:,itime,:)%index /= -1) ! xmax
        roi(2,1) = minval(pmatrix(:,itime,:)%index / nx, pmatrix(:,itime,:)%index /= -1)       ! ymin
        roi(2,2) = maxval(pmatrix(:,itime,:)%index / nx, pmatrix(:,itime,:)%index /= -1)       ! ymax

        nxmap = roi(1,2) - roi(1,1) + 1

        ! backprojection of the timeline and weights
        map = 0
        weight = 0
        do idetector = 1, ndetectors

            if (mask(itime,idetector)) cycle

            do ipixel = 1, npixels_per_sample

                if (pmatrix(ipixel,itime,idetector)%index == -1) exit

                xmap = mod(pmatrix(ipixel,itime,idetector)%index, nx) - roi(1,1)
                ymap = pmatrix(ipixel,itime,idetector)%index / nx     - roi(2,1)
                imap = xmap + ymap * nxmap
                map(imap) = map(imap) + timeline(itime,idetector) * pmatrix(ipixel,itime,idetector)%value
                weight(imap) = weight(imap) + pmatrix(ipixel,itime,idetector)%value

            end do

        end do

        map = map / weight
        where (weight == 0)
            map = NaN
        end where

    end subroutine backprojection_weighted_roi


    !-------------------------------------------------------------------------------------------------------------------------------


    ! roi is a 3-dimensional array: [1=x|2=y,1=min|2=max,idetector]
    function xy2roi(xy) result(roi)

        real(p), intent(in) :: xy(:,:,:)

        integer             :: roi(size(xy,1),2,size(xy,3))
        integer             :: i

        do i = 1, size(xy,3)
            roi(1,1,i) = nint_up  (minval(xy(1,:,i)))
            roi(1,2,i) = nint_down(maxval(xy(1,:,i)))
            roi(2,1,i) = nint_up  (minval(xy(2,:,i)))
            roi(2,2,i) = nint_down(maxval(xy(2,:,i)))
        end do

    end function xy2roi


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine xy2pmatrix(x, y, nx, ny, out, pmatrix)

        real(p), intent(in)                :: x(:), y(:)
        integer, intent(in)                :: nx, ny
        logical, intent(inout)             :: out
        type(pointingelement), intent(out) :: pmatrix(:)

        integer                            :: idetector, ix, iy

        do idetector = 1, size(pmatrix)

            ix = nint_up(x(idetector))
            iy = nint_up(y(idetector))
            if (ix < 0 .or. ix > nx - 1 .or. iy < 0 .or. iy > ny - 1) then
               out = .true.
               pmatrix(idetector)%index  = -1
               pmatrix(idetector)%value = 0
               cycle
            end if

            pmatrix(idetector)%index  = ix + iy * nx
            pmatrix(idetector)%value = 1.

        end do

    end subroutine xy2pmatrix


    !-------------------------------------------------------------------------------------------------------------------------------


    subroutine roi2pmatrix_cartesian(roi, coords, nx, ny, new_npixels_per_sample, out, pmatrix)

        integer, intent(in)                :: roi(:,:,:)
        real(p), intent(in)                :: coords(:,:,:)
        integer, intent(in)                :: nx, ny
        integer, intent(inout)             :: new_npixels_per_sample
        logical, intent(inout)             :: out
        type(pointingelement), intent(out) :: pmatrix(:,:)

        integer  :: ncoords, nvertices
        real(p)  :: polygon(size(roi,1),size(coords,2))
        integer  :: npixels_per_sample, icoord, ix, iy, npixels
        real(kind(pmatrix%value)) :: val

        ncoords = size(roi, 3)
        nvertices = size(coords, 2)
        npixels_per_sample = size(pmatrix, 1)
        do icoord = 1, ncoords

            if (roi(2,1,icoord) < 0 .or. roi(2,2,icoord) > ny - 1 .or.   &
                roi(1,1,icoord) < 0 .or. roi(1,2,icoord) > nx - 1) then
               out = .true.
            end if

            npixels = 1
            do iy = max(roi(2,1,icoord), 0), min(roi(2,2,icoord), ny - 1)

                do ix = max(roi(1,1,icoord), 0), min(roi(1,2,icoord), nx - 1)

                    polygon(1,:) = coords(1,:,icoord) - (ix - 0.5_p)
                    polygon(2,:) = coords(2,:,icoord) - (iy - 0.5_p)
                    val = real(intersection_polygon_unity_square_r8(polygon, nvertices), sp)
                    if (val == 0) cycle
                    if (npixels <= npixels_per_sample) then
                        pmatrix(npixels,icoord)%index  = ix + iy * nx
                        pmatrix(npixels,icoord)%value = abs(val)
                    end if
                    npixels = npixels + 1

                end do

            end do

            ! fill the rest of the pointing matrix
            pmatrix(npixels:,icoord)%index  = -1
            pmatrix(npixels:,icoord)%value = 0
            new_npixels_per_sample = max(new_npixels_per_sample, npixels-1)

        end do

    end subroutine roi2pmatrix_cartesian


end module module_pointingmatrix

module pointingmatrix
    use, intrinsic :: iso_fortran_env, only : int32
    use module_tamasis, only : p
    use module_pointingmatrix, backprojection_weight_ => backprojection_weight,&
                               roi2pmatrix_cartesian_ => roi2pmatrix_cartesian
    implicit none

contains

    subroutine backprojection_weight(matrix, data, map1d, weight1d, npixels_per_sample, nsamples, npixels)

        integer*8, intent(in)             :: nsamples
        !f2py integer*8, intent(in)       :: matrix(npixels_per_sample*nsamples)
        type(PointingElement), intent(in) :: matrix(npixels_per_sample,nsamples)
        real(p), intent(in)               :: data(nsamples)
        real(p), intent(inout)            :: map1d(npixels)
        real(p), intent(inout)            :: weight1d(npixels)
        integer, intent(in)               :: npixels_per_sample
        integer, intent(in)               :: npixels

        call backprojection_weight_(matrix, data, map=map1d, weight=weight1d)

    end subroutine backprojection_weight


    !---------------------------------------------------------------------------


    subroutine backprojection_weight_mask(matrix, data, mask, map1d, weight1d, npixels_per_sample, nsamples, npixels)

        integer*8, intent(in)             :: nsamples
        !f2py integer*8,intent(in)        :: matrix(npixels_per_sample*nsamples)
        type(PointingElement), intent(in) :: matrix(npixels_per_sample,nsamples)
        real(p), intent(in)               :: data(nsamples)
        logical*1, intent(in)             :: mask(nsamples)
        real(p), intent(inout)            :: map1d(npixels)
        real(p), intent(inout)            :: weight1d(npixels)
        integer, intent(in)               :: npixels_per_sample
        integer, intent(in)               :: npixels

        call backprojection_weight_(matrix, data, mask, map1d, weight1d)

    end subroutine backprojection_weight_mask


    !---------------------------------------------------------------------------


    subroutine direct(matrix, map1d, signal, npixels_per_sample, nsamples, npixels)

        integer*8, intent(in)                :: nsamples
        !f2py integer*8, intent(inout)       :: matrix(npixels_per_sample*nsamples)
        type(PointingElement), intent(inout) :: matrix(npixels_per_sample,nsamples)
        real(p), intent(in)    :: map1d(npixels)
        real(p), intent(inout) :: signal(nsamples)
        integer, intent(in)    :: npixels_per_sample
        integer, intent(in)    :: npixels

        if (npixels_per_sample == 1) then
            call pmatrix_direct_one_pixel_per_sample(matrix(1,:), map1d, signal)
        else
            call pmatrix_direct(matrix, map1d, signal)
        end if

    end subroutine direct


    !---------------------------------------------------------------------------


    subroutine intersects(matrix, pixel, npixels_per_sample, nsamples, ndetectors, out)

        integer*8, intent(in)                   :: nsamples
        !f2py integer*8, intent(in)             :: matrix(npixels_per_sample*nsamples*ndetectors)
        type(PointingElement), intent(in)       :: matrix(npixels_per_sample,nsamples,ndetectors)
        integer(int32), intent(in) :: pixel
        integer, intent(in)                     :: npixels_per_sample
        integer, intent(in)                     :: ndetectors
        logical*1, intent(out)                  :: out

        out = any(matrix%index == pixel)

    end subroutine intersects


    !---------------------------------------------------------------------------


    subroutine intersects_openmp2(matrix, pixel, npixels_per_sample, nsamples, ndetectors, out)

        integer*8, intent(in)                   :: nsamples
        !f2py integer*8, intent(in)             :: matrix(npixels_per_sample*nsamples*ndetectors)
        type(PointingElement), intent(in)       :: matrix(npixels_per_sample,nsamples,ndetectors)
        integer(int32), intent(in) :: pixel
        integer, intent(in)                     :: npixels_per_sample
        integer, intent(in)                     :: ndetectors
        logical*1, intent(out)                  :: out

        !$omp parallel workshare
        out = any(matrix%index == pixel)
        !$omp end parallel workshare

    end subroutine intersects_openmp2


    !---------------------------------------------------------------------------


    subroutine intersects_axis2(matrix, pixel, npixels_per_sample, nsamples, ndetectors, out)

        integer*8, intent(in)                   :: nsamples
        !f2py integer*8, intent(in)             :: matrix(npixels_per_sample*nsamples*ndetectors)
        type(PointingElement), intent(in)       :: matrix(npixels_per_sample,nsamples,ndetectors)
        integer(int32), intent(in) :: pixel
        integer, intent(in)                     :: npixels_per_sample
        integer, intent(in)                     :: ndetectors
        logical*1, intent(out)                  :: out(ndetectors)

        integer   :: idetector, ipixel
        integer*8 :: isample

        out = .false.
        !$omp parallel do schedule(guided)
        loop_detector: do idetector = 1, ndetectors
            do isample = 1, nsamples
                do ipixel = 1, npixels_per_sample
                    if (matrix(ipixel,isample,idetector)%index == pixel) then
                        out(idetector) = .true.
                        cycle loop_detector
                    end if
                end do
            end do
        end do loop_detector
        !$omp end parallel do

    end subroutine intersects_axis2


    !---------------------------------------------------------------------------


    subroutine intersects_axis3(matrix, pixel, npixels_per_sample, nsamples, ndetectors, out)

        integer*8, intent(in)                   :: nsamples
        !f2py integer*8, intent(in)             :: matrix(npixels_per_sample*nsamples*ndetectors)
        type(PointingElement), intent(in)       :: matrix(npixels_per_sample,nsamples,ndetectors)
        integer(int32), intent(in) :: pixel
        integer, intent(in)                     :: npixels_per_sample
        integer, intent(in)                     :: ndetectors
        logical*1, intent(out)                  :: out(nsamples)

        integer   :: idetector, ipixel
        integer*8 :: isample

        out = .false.
        !$omp parallel do schedule(guided)
        loop_sample: do isample = 1, nsamples
            do idetector = 1, ndetectors
                do ipixel = 1, npixels_per_sample
                    if (matrix(ipixel,isample,idetector)%index == pixel) then
                        out(isample) = .true.
                        cycle loop_sample
                    end if
                end do
            end do
        end do loop_sample
        !$omp end parallel do

    end subroutine intersects_axis3


    !---------------------------------------------------------------------------


    subroutine isvalid(matrix, npixels_per_sample, nsamples, npixels, output)

        !f2py threadsafe
        integer*8, intent(in)             :: nsamples
        !f2py integer*8                   :: matrix(npixels_per_sample*nsamples)
        type(PointingElement), intent(in) :: matrix(npixels_per_sample,nsamples)
        integer, intent(in)               :: npixels_per_sample
        integer, intent(in)               :: npixels
        logical*1, intent(out)            :: output
        integer :: index, ipixel, isample

        output = .false.
        do isample = 1, size(matrix, 2)
            do ipixel = 1, size(matrix, 1)
                index = matrix(ipixel,isample)%index
                if (index == -1) cycle
                if (index < 0 .or. index >= npixels) return
            end do
        end do
        output = .true.

    end subroutine isvalid


    !---------------------------------------------------------------------------


    subroutine mask(matrix, mask1d, npixels_per_sample, nsamples, npixels)

        integer*8, intent(in)             :: nsamples
        !f2py integer*8, intent(in)       :: matrix(npixels_per_sample*nsamples)
        type(PointingElement), intent(in) :: matrix(npixels_per_sample,nsamples)
        logical*1, intent(inout)          :: mask1d(npixels)
        integer, intent(in)               :: npixels_per_sample
        integer, intent(in)               :: npixels

        call pmatrix_mask(matrix, mask1d)

    end subroutine mask


    !---------------------------------------------------------------------------


    subroutine pack(matrix, mask1d, npixels_per_sample, nsamples, npixels)

        integer*8, intent(in)                :: nsamples
        !f2py integer*8, intent(inout)       :: matrix(npixels_per_sample*nsamples)
        type(PointingElement), intent(inout) :: matrix(npixels_per_sample,nsamples)
        logical*1, intent(in)                :: mask1d(npixels)
        integer, intent(in)                  :: npixels_per_sample
        integer, intent(in)                  :: npixels

        call pmatrix_pack(matrix, mask1d)

    end subroutine pack


    !---------------------------------------------------------------------------


    subroutine ptp(matrix, array, npixels_per_sample, nsamples, npixels)

        integer*8, intent(in)                :: nsamples
        !f2py integer*8, intent(inout)       :: matrix(npixels_per_sample*nsamples)
        type(PointingElement), intent(inout) :: matrix(npixels_per_sample,nsamples)
        real(p), intent(inout)               :: array(npixels, npixels)
        integer, intent(in)                  :: npixels_per_sample
        integer, intent(in)                  :: npixels

        call pmatrix_ptp(matrix, array)

    end subroutine ptp


    !---------------------------------------------------------------------------


    subroutine ptp_one(matrix, array, nsamples, npixels)

        integer*8, intent(in)                :: nsamples
        !f2py integer*8, intent(inout)       :: matrix(nsamples)
        type(PointingElement), intent(inout) :: matrix(nsamples)
        real(p), intent(inout)               :: array(0:npixels-1)
        integer, intent(in)                  :: npixels
        integer*8 :: isample

        do isample = 1, nsamples
            array(matrix(isample)%index) = array(matrix(isample)%index) +    &
                                           matrix(isample)%value**2
        end do

    end subroutine ptp_one


    !---------------------------------------------------------------------------


    subroutine transpose(matrix, signal, map1d, npixels_per_sample, nsamples, npixels)

        integer*8, intent(in)                :: nsamples
        !f2py integer*8, intent(inout)       :: matrix(npixels_per_sample*nsamples)
        type(PointingElement), intent(inout) :: matrix(npixels_per_sample,nsamples)
        real(p), intent(in)                  :: signal(nsamples)
        real(p), intent(inout)               :: map1d(npixels)
        integer, intent(in)                  :: npixels_per_sample
        integer, intent(in)                  :: npixels

        if (npixels_per_sample == 1) then
            call pmatrix_transpose_one_pixel_per_sample(matrix(1,:), signal, map1d)
        else
            call pmatrix_transpose(matrix, signal, map1d)
        end if

    end subroutine transpose


    !---------------------------------------------------------------------------


    subroutine roi2pmatrix_cartesian(roi, coords, ncoords, nvertices,          &
        npixels_per_sample, nx, ny, matrix, new_npixels_per_sample, out)

        !f2py threadsafe
        integer, intent(in)                :: roi(2,2,ncoords)
        real(p), intent(in)                :: coords(2,nvertices,ncoords)
        integer, intent(in)                :: ncoords, nvertices
        integer, intent(in)                :: npixels_per_sample
        integer, intent(in)                :: nx, ny
        integer, intent(out)               :: new_npixels_per_sample
        logical, intent(out)               :: out
        !f2py integer*8, intent(in)        :: matrix(npixels_per_sample*ncoords)
        type(PointingElement),intent(inout):: matrix(npixels_per_sample,ncoords)

        new_npixels_per_sample = 0
        call roi2pmatrix_cartesian_(roi, coords, nx, ny, new_npixels_per_sample, out, matrix)

    end subroutine roi2pmatrix_cartesian


end module pointingmatrix

module sparse

! <itype=4,4,4,8,8,8>
! <mtype=4,4,8,4,4,8>
! <vtype=4,8,8,4,8,8>

    type PointingElement_i4_m4
        integer*4 :: index
        real*4 :: value
    end type

    type PointingElement_i8_m4
        integer*8 :: index
        real*4 :: value
    end type

    type PointingElement_i4_m8
        integer*4 :: index
        real*8 :: value
    end type

    type PointingElement_i8_m8
        integer*8 :: index
        real*8 :: value
    end type

    type PointingElementRot3d_i4_m4
        integer*4 :: index
        real*4 :: r11, r22, r32
    end type

    type PointingElementRot3d_i8_m4
        integer*8 :: index
        real*4 :: r11, r22, r32
    end type

    type PointingElementRot3d_i4_m8
        integer*4 :: index
        real*8 :: r11, r22, r32
    end type

    type PointingElementRot3d_i8_m8
        integer*8 :: index
        real*8 :: r11, r22, r32
    end type


contains


    subroutine fsc_matvec_i4_m4_v4(matrix, input, output,    &
                                   nrowmax, ninput, noutput)
        integer, parameter          :: s = 4 + 4
        integer*8, intent(in)       :: nrowmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(nrowmax*ninput*s)
        type(PointingElement_i4_m4), intent(in) ::                 &
            matrix(nrowmax, ninput)
        real*4, intent(in)    :: input(ninput)
        real*4, intent(inout) :: output(0:noutput-1)

        integer*8 :: i, j

        if (nrowmax == 1) then
            !$omp parallel do
            do i = 1, ninput
                if (matrix(1,i)%index < 0) continue
                !$omp atomic
                output(matrix(1,i)%index) = output(matrix(1,i)%index) +    &
                                            matrix(1,i)%value * input(i)
            end do
            !$omp end parallel do
            return
        end if

        !$omp parallel do
        do i = 1, ninput
            do j = 1, nrowmax
                if (matrix(j,i)%index < 0) exit
                !$omp atomic
                output(matrix(j,i)%index) = output(matrix(j,i)%index) +        &
                                            matrix(j,i)%value * input(i)
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsc_matvec_i4_m4_v8(matrix, input, output,    &
                                   nrowmax, ninput, noutput)
        integer, parameter          :: s = 4 + 4
        integer*8, intent(in)       :: nrowmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(nrowmax*ninput*s)
        type(PointingElement_i4_m4), intent(in) ::                 &
            matrix(nrowmax, ninput)
        real*8, intent(in)    :: input(ninput)
        real*8, intent(inout) :: output(0:noutput-1)

        integer*8 :: i, j

        if (nrowmax == 1) then
            !$omp parallel do
            do i = 1, ninput
                if (matrix(1,i)%index < 0) continue
                !$omp atomic
                output(matrix(1,i)%index) = output(matrix(1,i)%index) +    &
                                            matrix(1,i)%value * input(i)
            end do
            !$omp end parallel do
            return
        end if

        !$omp parallel do
        do i = 1, ninput
            do j = 1, nrowmax
                if (matrix(j,i)%index < 0) exit
                !$omp atomic
                output(matrix(j,i)%index) = output(matrix(j,i)%index) +        &
                                            matrix(j,i)%value * input(i)
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsc_matvec_i4_m8_v8(matrix, input, output,    &
                                   nrowmax, ninput, noutput)
        integer, parameter          :: s = 4 + 8
        integer*8, intent(in)       :: nrowmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(nrowmax*ninput*s)
        type(PointingElement_i4_m8), intent(in) ::                 &
            matrix(nrowmax, ninput)
        real*8, intent(in)    :: input(ninput)
        real*8, intent(inout) :: output(0:noutput-1)

        integer*8 :: i, j

        if (nrowmax == 1) then
            !$omp parallel do
            do i = 1, ninput
                if (matrix(1,i)%index < 0) continue
                !$omp atomic
                output(matrix(1,i)%index) = output(matrix(1,i)%index) +    &
                                            matrix(1,i)%value * input(i)
            end do
            !$omp end parallel do
            return
        end if

        !$omp parallel do
        do i = 1, ninput
            do j = 1, nrowmax
                if (matrix(j,i)%index < 0) exit
                !$omp atomic
                output(matrix(j,i)%index) = output(matrix(j,i)%index) +        &
                                            matrix(j,i)%value * input(i)
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsc_matvec_i8_m4_v4(matrix, input, output,    &
                                   nrowmax, ninput, noutput)
        integer, parameter          :: s = 8 + 4
        integer*8, intent(in)       :: nrowmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(nrowmax*ninput*s)
        type(PointingElement_i8_m4), intent(in) ::                 &
            matrix(nrowmax, ninput)
        real*4, intent(in)    :: input(ninput)
        real*4, intent(inout) :: output(0:noutput-1)

        integer*8 :: i, j

        if (nrowmax == 1) then
            !$omp parallel do
            do i = 1, ninput
                if (matrix(1,i)%index < 0) continue
                !$omp atomic
                output(matrix(1,i)%index) = output(matrix(1,i)%index) +    &
                                            matrix(1,i)%value * input(i)
            end do
            !$omp end parallel do
            return
        end if

        !$omp parallel do
        do i = 1, ninput
            do j = 1, nrowmax
                if (matrix(j,i)%index < 0) exit
                !$omp atomic
                output(matrix(j,i)%index) = output(matrix(j,i)%index) +        &
                                            matrix(j,i)%value * input(i)
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsc_matvec_i8_m4_v8(matrix, input, output,    &
                                   nrowmax, ninput, noutput)
        integer, parameter          :: s = 8 + 4
        integer*8, intent(in)       :: nrowmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(nrowmax*ninput*s)
        type(PointingElement_i8_m4), intent(in) ::                 &
            matrix(nrowmax, ninput)
        real*8, intent(in)    :: input(ninput)
        real*8, intent(inout) :: output(0:noutput-1)

        integer*8 :: i, j

        if (nrowmax == 1) then
            !$omp parallel do
            do i = 1, ninput
                if (matrix(1,i)%index < 0) continue
                !$omp atomic
                output(matrix(1,i)%index) = output(matrix(1,i)%index) +    &
                                            matrix(1,i)%value * input(i)
            end do
            !$omp end parallel do
            return
        end if

        !$omp parallel do
        do i = 1, ninput
            do j = 1, nrowmax
                if (matrix(j,i)%index < 0) exit
                !$omp atomic
                output(matrix(j,i)%index) = output(matrix(j,i)%index) +        &
                                            matrix(j,i)%value * input(i)
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsc_matvec_i8_m8_v8(matrix, input, output,    &
                                   nrowmax, ninput, noutput)
        integer, parameter          :: s = 8 + 8
        integer*8, intent(in)       :: nrowmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(nrowmax*ninput*s)
        type(PointingElement_i8_m8), intent(in) ::                 &
            matrix(nrowmax, ninput)
        real*8, intent(in)    :: input(ninput)
        real*8, intent(inout) :: output(0:noutput-1)

        integer*8 :: i, j

        if (nrowmax == 1) then
            !$omp parallel do
            do i = 1, ninput
                if (matrix(1,i)%index < 0) continue
                !$omp atomic
                output(matrix(1,i)%index) = output(matrix(1,i)%index) +    &
                                            matrix(1,i)%value * input(i)
            end do
            !$omp end parallel do
            return
        end if

        !$omp parallel do
        do i = 1, ninput
            do j = 1, nrowmax
                if (matrix(j,i)%index < 0) exit
                !$omp atomic
                output(matrix(j,i)%index) = output(matrix(j,i)%index) +        &
                                            matrix(j,i)%value * input(i)
            end do
        end do
        !$omp end parallel do

    end subroutine




    subroutine fsr_matvec_i4_m4_v4(matrix, input, output,    &
                                   ncolmax, ninput, noutput)
        integer, parameter          :: s = 4 + 4
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*noutput*s)
        type(PointingElement_i4_m4), intent(in) ::                 &
            matrix(ncolmax, noutput)
        real*4, intent(in)    :: input(0:ninput-1)
        real*4, intent(inout) :: output(noutput)

        integer*8 :: i, j

        if (ncolmax == 1) then
            !$omp parallel do
            do i = 1, noutput
                if (matrix(1,i)%index < 0) continue
                output(i) = output(i) +                                        &
                            matrix(1,i)%value * input(matrix(1,i)%index)
            end do
            !$omp end parallel do
            return
        end if

        !$omp parallel do
        do i = 1, noutput
!!$            output(i) = sum(input(matrix(:,i)%index) * matrix(:,i)%value)
            do j = 1, ncolmax
                if (matrix(j,i)%index < 0) exit
                output(i) = output(i) +                                        &
                            matrix(j,i)%value * input(matrix(j,i)%index)
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_matvec_i4_m4_v8(matrix, input, output,    &
                                   ncolmax, ninput, noutput)
        integer, parameter          :: s = 4 + 4
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*noutput*s)
        type(PointingElement_i4_m4), intent(in) ::                 &
            matrix(ncolmax, noutput)
        real*8, intent(in)    :: input(0:ninput-1)
        real*8, intent(inout) :: output(noutput)

        integer*8 :: i, j

        if (ncolmax == 1) then
            !$omp parallel do
            do i = 1, noutput
                if (matrix(1,i)%index < 0) continue
                output(i) = output(i) +                                        &
                            matrix(1,i)%value * input(matrix(1,i)%index)
            end do
            !$omp end parallel do
            return
        end if

        !$omp parallel do
        do i = 1, noutput
!!$            output(i) = sum(input(matrix(:,i)%index) * matrix(:,i)%value)
            do j = 1, ncolmax
                if (matrix(j,i)%index < 0) exit
                output(i) = output(i) +                                        &
                            matrix(j,i)%value * input(matrix(j,i)%index)
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_matvec_i4_m8_v8(matrix, input, output,    &
                                   ncolmax, ninput, noutput)
        integer, parameter          :: s = 4 + 8
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*noutput*s)
        type(PointingElement_i4_m8), intent(in) ::                 &
            matrix(ncolmax, noutput)
        real*8, intent(in)    :: input(0:ninput-1)
        real*8, intent(inout) :: output(noutput)

        integer*8 :: i, j

        if (ncolmax == 1) then
            !$omp parallel do
            do i = 1, noutput
                if (matrix(1,i)%index < 0) continue
                output(i) = output(i) +                                        &
                            matrix(1,i)%value * input(matrix(1,i)%index)
            end do
            !$omp end parallel do
            return
        end if

        !$omp parallel do
        do i = 1, noutput
!!$            output(i) = sum(input(matrix(:,i)%index) * matrix(:,i)%value)
            do j = 1, ncolmax
                if (matrix(j,i)%index < 0) exit
                output(i) = output(i) +                                        &
                            matrix(j,i)%value * input(matrix(j,i)%index)
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_matvec_i8_m4_v4(matrix, input, output,    &
                                   ncolmax, ninput, noutput)
        integer, parameter          :: s = 8 + 4
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*noutput*s)
        type(PointingElement_i8_m4), intent(in) ::                 &
            matrix(ncolmax, noutput)
        real*4, intent(in)    :: input(0:ninput-1)
        real*4, intent(inout) :: output(noutput)

        integer*8 :: i, j

        if (ncolmax == 1) then
            !$omp parallel do
            do i = 1, noutput
                if (matrix(1,i)%index < 0) continue
                output(i) = output(i) +                                        &
                            matrix(1,i)%value * input(matrix(1,i)%index)
            end do
            !$omp end parallel do
            return
        end if

        !$omp parallel do
        do i = 1, noutput
!!$            output(i) = sum(input(matrix(:,i)%index) * matrix(:,i)%value)
            do j = 1, ncolmax
                if (matrix(j,i)%index < 0) exit
                output(i) = output(i) +                                        &
                            matrix(j,i)%value * input(matrix(j,i)%index)
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_matvec_i8_m4_v8(matrix, input, output,    &
                                   ncolmax, ninput, noutput)
        integer, parameter          :: s = 8 + 4
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*noutput*s)
        type(PointingElement_i8_m4), intent(in) ::                 &
            matrix(ncolmax, noutput)
        real*8, intent(in)    :: input(0:ninput-1)
        real*8, intent(inout) :: output(noutput)

        integer*8 :: i, j

        if (ncolmax == 1) then
            !$omp parallel do
            do i = 1, noutput
                if (matrix(1,i)%index < 0) continue
                output(i) = output(i) +                                        &
                            matrix(1,i)%value * input(matrix(1,i)%index)
            end do
            !$omp end parallel do
            return
        end if

        !$omp parallel do
        do i = 1, noutput
!!$            output(i) = sum(input(matrix(:,i)%index) * matrix(:,i)%value)
            do j = 1, ncolmax
                if (matrix(j,i)%index < 0) exit
                output(i) = output(i) +                                        &
                            matrix(j,i)%value * input(matrix(j,i)%index)
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_matvec_i8_m8_v8(matrix, input, output,    &
                                   ncolmax, ninput, noutput)
        integer, parameter          :: s = 8 + 8
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*noutput*s)
        type(PointingElement_i8_m8), intent(in) ::                 &
            matrix(ncolmax, noutput)
        real*8, intent(in)    :: input(0:ninput-1)
        real*8, intent(inout) :: output(noutput)

        integer*8 :: i, j

        if (ncolmax == 1) then
            !$omp parallel do
            do i = 1, noutput
                if (matrix(1,i)%index < 0) continue
                output(i) = output(i) +                                        &
                            matrix(1,i)%value * input(matrix(1,i)%index)
            end do
            !$omp end parallel do
            return
        end if

        !$omp parallel do
        do i = 1, noutput
!!$            output(i) = sum(input(matrix(:,i)%index) * matrix(:,i)%value)
            do j = 1, ncolmax
                if (matrix(j,i)%index < 0) exit
                output(i) = output(i) +                                        &
                            matrix(j,i)%value * input(matrix(j,i)%index)
            end do
        end do
        !$omp end parallel do

    end subroutine




    subroutine fsc_rot3d_matvec_i4_m4_v4(matrix, input,      &
                                         output, nrowmax, ninput, noutput)
        integer, parameter          :: s = 4 + 3 * 4
        integer*8, intent(in)       :: nrowmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(nrowmax*ninput*s)
        type(PointingElementRot3d_i4_m4), intent(in) ::            &
            matrix(nrowmax, ninput)
        real*4, intent(in)    :: input(3,ninput)
        real*4, intent(inout) :: output(3,0:noutput-1)

        integer*8 :: i, j
        integer*4 :: col

        !$omp parallel do private(col)
        do i = 1, ninput
            do j = 1, nrowmax
                if (matrix(j,i)%index < 0) exit
                col = matrix(j,i)%index
                !$omp atomic
                output(1,col) = output(1,col) + matrix(j,i)%r11 * input(1,i)
                !$omp atomic
                output(2,col) = output(2,col) + (matrix(j,i)%r22 * input(2,i) +&
                                                 matrix(j,i)%r32 * input(3,i))
                !$omp atomic
                output(3,col) = output(3,col) + (-matrix(j,i)%r32 * input(2,i)+&
                                                  matrix(j,i)%r22 * input(3,i))
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsc_rot3d_matvec_i4_m4_v8(matrix, input,      &
                                         output, nrowmax, ninput, noutput)
        integer, parameter          :: s = 4 + 3 * 4
        integer*8, intent(in)       :: nrowmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(nrowmax*ninput*s)
        type(PointingElementRot3d_i4_m4), intent(in) ::            &
            matrix(nrowmax, ninput)
        real*8, intent(in)    :: input(3,ninput)
        real*8, intent(inout) :: output(3,0:noutput-1)

        integer*8 :: i, j
        integer*4 :: col

        !$omp parallel do private(col)
        do i = 1, ninput
            do j = 1, nrowmax
                if (matrix(j,i)%index < 0) exit
                col = matrix(j,i)%index
                !$omp atomic
                output(1,col) = output(1,col) + matrix(j,i)%r11 * input(1,i)
                !$omp atomic
                output(2,col) = output(2,col) + (matrix(j,i)%r22 * input(2,i) +&
                                                 matrix(j,i)%r32 * input(3,i))
                !$omp atomic
                output(3,col) = output(3,col) + (-matrix(j,i)%r32 * input(2,i)+&
                                                  matrix(j,i)%r22 * input(3,i))
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsc_rot3d_matvec_i4_m8_v8(matrix, input,      &
                                         output, nrowmax, ninput, noutput)
        integer, parameter          :: s = 4 + 3 * 8
        integer*8, intent(in)       :: nrowmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(nrowmax*ninput*s)
        type(PointingElementRot3d_i4_m8), intent(in) ::            &
            matrix(nrowmax, ninput)
        real*8, intent(in)    :: input(3,ninput)
        real*8, intent(inout) :: output(3,0:noutput-1)

        integer*8 :: i, j
        integer*4 :: col

        !$omp parallel do private(col)
        do i = 1, ninput
            do j = 1, nrowmax
                if (matrix(j,i)%index < 0) exit
                col = matrix(j,i)%index
                !$omp atomic
                output(1,col) = output(1,col) + matrix(j,i)%r11 * input(1,i)
                !$omp atomic
                output(2,col) = output(2,col) + (matrix(j,i)%r22 * input(2,i) +&
                                                 matrix(j,i)%r32 * input(3,i))
                !$omp atomic
                output(3,col) = output(3,col) + (-matrix(j,i)%r32 * input(2,i)+&
                                                  matrix(j,i)%r22 * input(3,i))
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsc_rot3d_matvec_i8_m4_v4(matrix, input,      &
                                         output, nrowmax, ninput, noutput)
        integer, parameter          :: s = 8 + 3 * 4
        integer*8, intent(in)       :: nrowmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(nrowmax*ninput*s)
        type(PointingElementRot3d_i8_m4), intent(in) ::            &
            matrix(nrowmax, ninput)
        real*4, intent(in)    :: input(3,ninput)
        real*4, intent(inout) :: output(3,0:noutput-1)

        integer*8 :: i, j
        integer*8 :: col

        !$omp parallel do private(col)
        do i = 1, ninput
            do j = 1, nrowmax
                if (matrix(j,i)%index < 0) exit
                col = matrix(j,i)%index
                !$omp atomic
                output(1,col) = output(1,col) + matrix(j,i)%r11 * input(1,i)
                !$omp atomic
                output(2,col) = output(2,col) + (matrix(j,i)%r22 * input(2,i) +&
                                                 matrix(j,i)%r32 * input(3,i))
                !$omp atomic
                output(3,col) = output(3,col) + (-matrix(j,i)%r32 * input(2,i)+&
                                                  matrix(j,i)%r22 * input(3,i))
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsc_rot3d_matvec_i8_m4_v8(matrix, input,      &
                                         output, nrowmax, ninput, noutput)
        integer, parameter          :: s = 8 + 3 * 4
        integer*8, intent(in)       :: nrowmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(nrowmax*ninput*s)
        type(PointingElementRot3d_i8_m4), intent(in) ::            &
            matrix(nrowmax, ninput)
        real*8, intent(in)    :: input(3,ninput)
        real*8, intent(inout) :: output(3,0:noutput-1)

        integer*8 :: i, j
        integer*8 :: col

        !$omp parallel do private(col)
        do i = 1, ninput
            do j = 1, nrowmax
                if (matrix(j,i)%index < 0) exit
                col = matrix(j,i)%index
                !$omp atomic
                output(1,col) = output(1,col) + matrix(j,i)%r11 * input(1,i)
                !$omp atomic
                output(2,col) = output(2,col) + (matrix(j,i)%r22 * input(2,i) +&
                                                 matrix(j,i)%r32 * input(3,i))
                !$omp atomic
                output(3,col) = output(3,col) + (-matrix(j,i)%r32 * input(2,i)+&
                                                  matrix(j,i)%r22 * input(3,i))
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsc_rot3d_matvec_i8_m8_v8(matrix, input,      &
                                         output, nrowmax, ninput, noutput)
        integer, parameter          :: s = 8 + 3 * 8
        integer*8, intent(in)       :: nrowmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(nrowmax*ninput*s)
        type(PointingElementRot3d_i8_m8), intent(in) ::            &
            matrix(nrowmax, ninput)
        real*8, intent(in)    :: input(3,ninput)
        real*8, intent(inout) :: output(3,0:noutput-1)

        integer*8 :: i, j
        integer*8 :: col

        !$omp parallel do private(col)
        do i = 1, ninput
            do j = 1, nrowmax
                if (matrix(j,i)%index < 0) exit
                col = matrix(j,i)%index
                !$omp atomic
                output(1,col) = output(1,col) + matrix(j,i)%r11 * input(1,i)
                !$omp atomic
                output(2,col) = output(2,col) + (matrix(j,i)%r22 * input(2,i) +&
                                                 matrix(j,i)%r32 * input(3,i))
                !$omp atomic
                output(3,col) = output(3,col) + (-matrix(j,i)%r32 * input(2,i)+&
                                                  matrix(j,i)%r22 * input(3,i))
            end do
        end do
        !$omp end parallel do

    end subroutine




    subroutine fsr_rot3d_matvec_i4_m4_v4(matrix, input,      &
                                         output, ncolmax, ninput, noutput)
        integer, parameter          :: s = 4 + 3 * 4
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*noutput*s)
        type(PointingElementRot3d_i4_m4), intent(in) ::            &
            matrix(ncolmax, noutput)
        real*4, intent(in)    :: input(3,0:ninput-1)
        real*4, intent(inout) :: output(3,noutput)

        integer*8 :: i, j
        integer*4 :: col

        !$omp parallel do private(col)
        do i = 1, noutput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                output(1,i) = output(1,i) + matrix(j,i)%r11 * input(1,col)
                output(2,i) = output(2,i) + matrix(j,i)%r22 * input(2,col) -   &
                                            matrix(j,i)%r32 * input(3,col)
                output(3,i) = output(3,i) + matrix(j,i)%r32 * input(2,col) +   &
                                            matrix(j,i)%r22 * input(3,col)
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_rot3d_matvec_i4_m4_v8(matrix, input,      &
                                         output, ncolmax, ninput, noutput)
        integer, parameter          :: s = 4 + 3 * 4
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*noutput*s)
        type(PointingElementRot3d_i4_m4), intent(in) ::            &
            matrix(ncolmax, noutput)
        real*8, intent(in)    :: input(3,0:ninput-1)
        real*8, intent(inout) :: output(3,noutput)

        integer*8 :: i, j
        integer*4 :: col

        !$omp parallel do private(col)
        do i = 1, noutput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                output(1,i) = output(1,i) + matrix(j,i)%r11 * input(1,col)
                output(2,i) = output(2,i) + matrix(j,i)%r22 * input(2,col) -   &
                                            matrix(j,i)%r32 * input(3,col)
                output(3,i) = output(3,i) + matrix(j,i)%r32 * input(2,col) +   &
                                            matrix(j,i)%r22 * input(3,col)
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_rot3d_matvec_i4_m8_v8(matrix, input,      &
                                         output, ncolmax, ninput, noutput)
        integer, parameter          :: s = 4 + 3 * 8
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*noutput*s)
        type(PointingElementRot3d_i4_m8), intent(in) ::            &
            matrix(ncolmax, noutput)
        real*8, intent(in)    :: input(3,0:ninput-1)
        real*8, intent(inout) :: output(3,noutput)

        integer*8 :: i, j
        integer*4 :: col

        !$omp parallel do private(col)
        do i = 1, noutput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                output(1,i) = output(1,i) + matrix(j,i)%r11 * input(1,col)
                output(2,i) = output(2,i) + matrix(j,i)%r22 * input(2,col) -   &
                                            matrix(j,i)%r32 * input(3,col)
                output(3,i) = output(3,i) + matrix(j,i)%r32 * input(2,col) +   &
                                            matrix(j,i)%r22 * input(3,col)
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_rot3d_matvec_i8_m4_v4(matrix, input,      &
                                         output, ncolmax, ninput, noutput)
        integer, parameter          :: s = 8 + 3 * 4
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*noutput*s)
        type(PointingElementRot3d_i8_m4), intent(in) ::            &
            matrix(ncolmax, noutput)
        real*4, intent(in)    :: input(3,0:ninput-1)
        real*4, intent(inout) :: output(3,noutput)

        integer*8 :: i, j
        integer*8 :: col

        !$omp parallel do private(col)
        do i = 1, noutput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                output(1,i) = output(1,i) + matrix(j,i)%r11 * input(1,col)
                output(2,i) = output(2,i) + matrix(j,i)%r22 * input(2,col) -   &
                                            matrix(j,i)%r32 * input(3,col)
                output(3,i) = output(3,i) + matrix(j,i)%r32 * input(2,col) +   &
                                            matrix(j,i)%r22 * input(3,col)
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_rot3d_matvec_i8_m4_v8(matrix, input,      &
                                         output, ncolmax, ninput, noutput)
        integer, parameter          :: s = 8 + 3 * 4
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*noutput*s)
        type(PointingElementRot3d_i8_m4), intent(in) ::            &
            matrix(ncolmax, noutput)
        real*8, intent(in)    :: input(3,0:ninput-1)
        real*8, intent(inout) :: output(3,noutput)

        integer*8 :: i, j
        integer*8 :: col

        !$omp parallel do private(col)
        do i = 1, noutput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                output(1,i) = output(1,i) + matrix(j,i)%r11 * input(1,col)
                output(2,i) = output(2,i) + matrix(j,i)%r22 * input(2,col) -   &
                                            matrix(j,i)%r32 * input(3,col)
                output(3,i) = output(3,i) + matrix(j,i)%r32 * input(2,col) +   &
                                            matrix(j,i)%r22 * input(3,col)
            end do
        end do
        !$omp end parallel do

    end subroutine



    subroutine fsr_rot3d_matvec_i8_m8_v8(matrix, input,      &
                                         output, ncolmax, ninput, noutput)
        integer, parameter          :: s = 8 + 3 * 8
        integer*8, intent(in)       :: ncolmax
        integer*8, intent(in)       :: ninput
        integer*8, intent(in)       :: noutput
        !f2py integer*1, intent(in) :: matrix(ncolmax*noutput*s)
        type(PointingElementRot3d_i8_m8), intent(in) ::            &
            matrix(ncolmax, noutput)
        real*8, intent(in)    :: input(3,0:ninput-1)
        real*8, intent(inout) :: output(3,noutput)

        integer*8 :: i, j
        integer*8 :: col

        !$omp parallel do private(col)
        do i = 1, noutput
            do j = 1, ncolmax
                col = matrix(j,i)%index
                if (col < 0) exit
                output(1,i) = output(1,i) + matrix(j,i)%r11 * input(1,col)
                output(2,i) = output(2,i) + matrix(j,i)%r22 * input(2,col) -   &
                                            matrix(j,i)%r32 * input(3,col)
                output(3,i) = output(3,i) + matrix(j,i)%r32 * input(2,col) +   &
                                            matrix(j,i)%r22 * input(3,col)
            end do
        end do
        !$omp end parallel do

    end subroutine




end module sparse

! Copyright 2010-2011 Pierre Chanial
! All rights reserved
!
module module_projection

    use module_tamasis, only : p
    implicit none
    private

    public :: intersection_polygon_unity_square
    public :: intersection_segment_unity_square
    public :: point_in_polygon


contains


    pure function intersection_polygon_unity_square(xy, nvertices) result(output)

        real(p)             :: output
        real(p), intent(in) :: xy(2,nvertices)
        integer, intent(in) :: nvertices

        integer             :: i, j

        output = 0
        j = nvertices
        do i=1, nvertices
            output = output + intersection_segment_unity_square(xy(1,i), xy(2,i), xy(1,j), xy(2,j))
            j = i
        end do

    end function intersection_polygon_unity_square


    !-------------------------------------------------------------------------------------------------------------------------------


    pure function intersection_segment_unity_square(x1,  y1, x2,  y2) result(output)

        real(p)             :: output
        real(p), intent(in) :: x1, y1, x2, y2 ! first and second point coordinates

        ! we will use the following variables :

        real(p) :: pente               ! The slope of the straight line going through p1, p2
        real(p) :: ordonnee            ! The point where the straight line crosses y-axis
        real(p) :: delta_x             ! = x2-x1
        real(p) :: xmin, xmax          ! minimum and maximum values of x to consider
                                       ! (clipped in the square (0,0),(1,0),(1,1),(0,1)
        real(p) :: ymin, ymax          ! minimum and maximum values of y to consider
                                       ! (clipped in the square (0,0),(1,0),(1,1),(0,1)
        real(p) :: xhaut               ! value of x at which straight line crosses the
                                       ! (0,1),(1,1) line
        logical :: negative_delta_x    ! TRUE if delta_x < 0

        ! Check for vertical line : the area intercepted is 0
        if (x1 == x2) then
            output = 0
            return
        end if

        ! Order the two input points in x
        if (x2 > x1) then
            xmin = x1
            xmax = x2
        else
            xmin = x2
            xmax = x1
        end if

        ! And determine the bounds ignoring y for now
        ! test is p1 and p2 are outside the square along x-axis
        if (xmin > 1 .or. xmax < 0) then
            output = 0
            return    ! outside, the area is 0
        end if

        ! We compute xmin, xmax, clipped between 0 and 1 in x
        ! then we compute pente (slope) and ordonnee and use it to get ymin
        ! and ymax
        xmin = max(xmin, 0._p)
        xmax = min(xmax, 1._p)

        delta_x = x2 - x1
        negative_delta_x = delta_x < 0
        pente = (y2 - y1) / delta_x
        ordonnee  = y1 - pente * x1
        ymin = pente * xmin + ordonnee
        ymax = pente * xmax + ordonnee

        ! Trap segment entirely below axis
        if (ymin < 0 .and. ymax < 0) then
            output = 0
            return  ! if segment below axis, intercepted surface is 0
        end if

        ! Adjust bounds if segment crosses axis x-axis
        !(to exclude anything below axis)
        if (ymin < 0) then
            ymin = 0
            xmin = - ordonnee / pente
        end if
        if (ymax < 0) then
            ymax = 0
            xmax = - ordonnee / pente
        end if

        ! There are four possibilities: both y below 1, both y above 1
        ! and one of each.

        if (ymin >= 1 .and. ymax >= 1) then

            ! Line segment is entirely above square : we clip with the square
            if (negative_delta_x) then
                output = xmin - xmax
            else
                output = xmax - xmin
            end if
            return

        end if

        if (ymin <= 1 .and. ymax <= 1) then
          ! Segment is entirely within square
          if (negative_delta_x) then
             output = 0.5_p * (xmin-xmax) * (ymax+ymin)
          else
             output = 0.5_p * (xmax-xmin) * (ymax+ymin)
          end if
          return
        end if

        ! otherwise it must cross the top of the square
        ! the crossing occurs at xhaut
        xhaut = (1 - ordonnee) / pente
        !!if ((xhaut < xmin) .or. (xhaut > xmax))   cout << " BUGGGG "
        if (ymin < 1) then
            if (negative_delta_x) then
                output = -(0.5_p * (xhaut-xmin) * (1+ymin) + xmax - xhaut)
            else
                output = 0.5_p * (xhaut-xmin) * (1+ymin) + xmax - xhaut
            end if
        else
            if (negative_delta_x) then
                output = -(0.5_p * (xmax-xhaut) * (1+ymax) + xhaut-xmin)
            else
                output = 0.5_p * (xmax-xhaut) * (1+ymax) + xhaut-xmin
            end if
        end if

    end function intersection_segment_unity_square


    !-------------------------------------------------------------------------------------------------------------------------------


    ! returns 1, 0, -1 if a point is inside, on an edge or outside a polygon
    ! algo from Simulation of Simplicity: A Technique to Cope with Degenerate Cases in Geometric Algorithms
    ! modified to cope with the cases in which the point lies on an edge
    function point_in_polygon(point, polygon)

        real(p), intent(in) :: point(2), polygon(:,:)
        integer             :: point_in_polygon

        integer :: i, j, n
        real(p) :: a, b

        point_in_polygon = -1
        n = size(polygon, 2)

        ! first, test if a point is on one of the vertices
        do i = 1, n
            if (all(polygon(:,i) == point)) then
                point_in_polygon = 0
                return
            end if
        end do

        ! loop over the edges. Count how many time a horizontal rightwards ray crosses the polygon
        ! if it crosses an even number of times, the point is outside (Jordan curve theorem).
        j = n
        do i = 1, n
            if ((polygon(2,i) > point(2)) .neqv. (polygon(2,j) > point(2))) then
                a = point(1) - polygon(1,i)
                b = (polygon(1,j) - polygon(1,i)) * (point(2)-polygon(2,i)) / &
                    (polygon(2,j) - polygon(2,i))
                if (a == b) then
                    point_in_polygon = 0
                    return
                end if
                if (a < b) then
                    point_in_polygon = - point_in_polygon;
                end if
            else if (polygon(2,i) == polygon(2,j) .and. point(2) == polygon(2,i) .and. (polygon(1,i) > point(1) .neqv. polygon(1,j)&
                     > point(1))) then
                point_in_polygon = 0
                return
            endif
            j = i
        end do

    end function point_in_polygon


end module module_projection
